/* sudoku-cell.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_POPOVER_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _Block10Data Block10Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL,
	SUDOKU_CELL_NUM_SIGNALS
};
static guint sudoku_cell_signals[SUDOKU_CELL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkPopover* _popover;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
	gboolean initialized_earmarks;
	gboolean _initialize_earmarks;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void __lambda9_ (SudokuCell* self);
static void ___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint val,
                                 gboolean enabled);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint value,
                                         gboolean enabled);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda7_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCell* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_initialize_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 136 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 307 "sudoku-cell.c"
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp3_;
	gint _tmp3__length1;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 131 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 133 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 133 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 133 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, val)) {
#line 134 "../src/sudoku-cell.vala"
		return;
#line 336 "sudoku-cell.c"
	}
#line 136 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->earmark_labels;
#line 136 "../src/sudoku-cell.vala"
	_tmp3__length1 = self->priv->earmark_labels_length1;
#line 136 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_[val - 1];
#line 136 "../src/sudoku-cell.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 136 "../src/sudoku-cell.vala"
	earmark = _tmp5_;
#line 137 "../src/sudoku-cell.vala"
	if (enabled) {
#line 350 "sudoku-cell.c"
		GtkLabel* _tmp7_;
#line 137 "../src/sudoku-cell.vala"
		_tmp7_ = earmark;
#line 137 "../src/sudoku-cell.vala"
		_tmp6_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp7_, "error");
#line 356 "sudoku-cell.c"
	} else {
#line 137 "../src/sudoku-cell.vala"
		_tmp6_ = FALSE;
#line 360 "sudoku-cell.c"
	}
#line 137 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 364 "sudoku-cell.c"
		GtkLabel* _tmp8_;
#line 138 "../src/sudoku-cell.vala"
		_tmp8_ = earmark;
#line 138 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "highlight-label");
#line 370 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp9_;
#line 140 "../src/sudoku-cell.vala"
		_tmp9_ = earmark;
#line 140 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp9_, "highlight-label");
#line 377 "sudoku-cell.c"
	}
#line 131 "../src/sudoku-cell.vala"
	_g_object_unref0 (earmark);
#line 381 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 206 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 392 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 207 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 404 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 208 "../src/sudoku-cell.vala"
	return result;
#line 418 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 209 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 430 "sudoku-cell.c"
}

static void
__lambda9_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 234 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 234 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 234 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 234 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 234 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 450 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
#line 236 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 236 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 236 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp5_, NULL);
#line 237 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 461 "sudoku-cell.c"
	}
}

static void
___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
#line 233 "../src/sudoku-cell.vala"
	__lambda9_ ((SudokuCell*) self);
#line 471 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkEventController* _tmp13_;
	GtkGestureLongPress* _tmp14_;
	GtkEventController* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkEventController* _tmp17_;
	GtkGestureClick* _tmp18_;
	GtkGestureLongPress* _tmp19_;
	GtkGestureLongPress* _tmp20_;
	GtkGestureClick* _tmp21_;
	GtkEventControllerKey* _tmp22_;
	GtkEventControllerKey* _tmp23_;
	GtkLabel* _tmp24_;
	gint num = 0;
	GtkPopover* _tmp46_;
	GtkPopover* _tmp47_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp48_;
	GtkEventControllerKey* _tmp49_;
	GtkEventControllerKey* _tmp50_;
	GtkWidget* _tmp51_ = NULL;
	GtkPopover* _tmp52_;
	GtkPopover* _tmp53_;
	GtkPopover* _tmp56_;
	GtkPopover* _tmp57_;
#line 179 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 179 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 181 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 183 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 184 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 185 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 185 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 185 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 187 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 187 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/sudoku-cell.vala"
	if (_tmp2_ != 0) {
#line 534 "sudoku-cell.c"
		GtkLabel* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkLabel* _tmp8_;
#line 189 "../src/sudoku-cell.vala"
		_tmp3_ = self->priv->value_label;
#line 189 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_value (self);
#line 189 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 189 "../src/sudoku-cell.vala"
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 189 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 189 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp3_, _tmp7_);
#line 189 "../src/sudoku-cell.vala"
		_g_free0 (_tmp7_);
#line 190 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->value_label;
#line 190 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 559 "sudoku-cell.c"
	}
#line 193 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 194 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 196 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_is_fixed (self);
#line 196 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 196 "../src/sudoku-cell.vala"
	if (_tmp10_) {
#line 197 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 573 "sudoku-cell.c"
	}
#line 199 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->button_controller;
#line 199 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp11_, (guint) 0);
#line 201 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->button_controller;
#line 201 "../src/sudoku-cell.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 201 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
#line 202 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->long_press_controller;
#line 202 "../src/sudoku-cell.vala"
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
#line 202 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
#line 203 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->key_controller;
#line 203 "../src/sudoku-cell.vala"
	_tmp17_ = _g_object_ref0 ((GtkEventController*) _tmp16_);
#line 203 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp17_);
#line 204 "../src/sudoku-cell.vala"
	_tmp18_ = self->priv->button_controller;
#line 204 "../src/sudoku-cell.vala"
	_tmp19_ = self->priv->long_press_controller;
#line 204 "../src/sudoku-cell.vala"
	gtk_gesture_group ((GtkGesture*) _tmp18_, (GtkGesture*) _tmp19_);
#line 206 "../src/sudoku-cell.vala"
	_tmp20_ = self->priv->long_press_controller;
#line 206 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp20_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 207 "../src/sudoku-cell.vala"
	_tmp21_ = self->priv->button_controller;
#line 207 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp21_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 208 "../src/sudoku-cell.vala"
	_tmp22_ = self->priv->key_controller;
#line 208 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp22_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 209 "../src/sudoku-cell.vala"
	_tmp23_ = self->priv->key_controller;
#line 209 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp23_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 211 "../src/sudoku-cell.vala"
	_tmp24_ = self->priv->value_label;
#line 211 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp24_, (GtkWidget*) self);
#line 213 "../src/sudoku-cell.vala"
	num = 0;
#line 625 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 214 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 630 "sudoku-cell.c"
		{
			gboolean _tmp25_ = FALSE;
#line 214 "../src/sudoku-cell.vala"
			_tmp25_ = TRUE;
#line 214 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 637 "sudoku-cell.c"
				SudokuBoard* _tmp27_;
				SudokuBoard* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 214 "../src/sudoku-cell.vala"
				if (!_tmp25_) {
#line 644 "sudoku-cell.c"
					gint _tmp26_;
#line 214 "../src/sudoku-cell.vala"
					_tmp26_ = row_tmp;
#line 214 "../src/sudoku-cell.vala"
					row_tmp = _tmp26_ + 1;
#line 650 "sudoku-cell.c"
				}
#line 214 "../src/sudoku-cell.vala"
				_tmp25_ = FALSE;
#line 214 "../src/sudoku-cell.vala"
				_tmp27_ = sudoku_game_get_board (*game);
#line 214 "../src/sudoku-cell.vala"
				_tmp28_ = _tmp27_;
#line 214 "../src/sudoku-cell.vala"
				_tmp29_ = sudoku_board_get_block_rows (_tmp28_);
#line 214 "../src/sudoku-cell.vala"
				_tmp30_ = _tmp29_;
#line 214 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp30_)) {
#line 214 "../src/sudoku-cell.vala"
					break;
#line 666 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 216 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 672 "sudoku-cell.c"
					{
						gboolean _tmp31_ = FALSE;
#line 216 "../src/sudoku-cell.vala"
						_tmp31_ = TRUE;
#line 216 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 679 "sudoku-cell.c"
							SudokuBoard* _tmp33_;
							SudokuBoard* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							gchar* _tmp39_;
							gchar* _tmp40_;
							GtkLabel* _tmp41_ = NULL;
							GtkLabel** _tmp42_;
							gint _tmp42__length1;
							GtkLabel* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
#line 216 "../src/sudoku-cell.vala"
							if (!_tmp31_) {
#line 698 "sudoku-cell.c"
								gint _tmp32_;
#line 216 "../src/sudoku-cell.vala"
								_tmp32_ = col_tmp;
#line 216 "../src/sudoku-cell.vala"
								col_tmp = _tmp32_ + 1;
#line 704 "sudoku-cell.c"
							}
#line 216 "../src/sudoku-cell.vala"
							_tmp31_ = FALSE;
#line 216 "../src/sudoku-cell.vala"
							_tmp33_ = sudoku_game_get_board (*game);
#line 216 "../src/sudoku-cell.vala"
							_tmp34_ = _tmp33_;
#line 216 "../src/sudoku-cell.vala"
							_tmp35_ = sudoku_board_get_block_cols (_tmp34_);
#line 216 "../src/sudoku-cell.vala"
							_tmp36_ = _tmp35_;
#line 216 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp36_)) {
#line 216 "../src/sudoku-cell.vala"
								break;
#line 720 "sudoku-cell.c"
							}
#line 218 "../src/sudoku-cell.vala"
							_tmp37_ = num;
#line 218 "../src/sudoku-cell.vala"
							num = _tmp37_ + 1;
#line 220 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 220 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 220 "../src/sudoku-cell.vala"
							_tmp39_ = g_strdup_printf ("%i", num);
#line 220 "../src/sudoku-cell.vala"
							_tmp40_ = _tmp39_;
#line 220 "../src/sudoku-cell.vala"
							_tmp41_ = (GtkLabel*) gtk_label_new (_tmp40_);
#line 220 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp41_, FALSE);
#line 220 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp41_);
#line 220 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp38_[num - 1]);
#line 220 "../src/sudoku-cell.vala"
							_tmp38_[num - 1] = _tmp41_;
#line 220 "../src/sudoku-cell.vala"
							_g_free0 (_tmp40_);
#line 223 "../src/sudoku-cell.vala"
							_tmp42_ = self->priv->earmark_labels;
#line 223 "../src/sudoku-cell.vala"
							_tmp42__length1 = self->priv->earmark_labels_length1;
#line 223 "../src/sudoku-cell.vala"
							_tmp43_ = _tmp42_[num - 1];
#line 223 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp43_, (GtkWidget*) self);
#line 224 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 224 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 224 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 224 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "earmark");
#line 762 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 228 "../src/sudoku-cell.vala"
	_tmp46_ = sudoku_cell_get_popover (self);
#line 228 "../src/sudoku-cell.vala"
	_tmp47_ = _tmp46_;
#line 228 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp47_, (GtkWidget*) self);
#line 229 "../src/sudoku-cell.vala"
	_tmp48_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 229 "../src/sudoku-cell.vala"
	popover_controller = _tmp48_;
#line 230 "../src/sudoku-cell.vala"
	_tmp49_ = popover_controller;
#line 230 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp49_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 231 "../src/sudoku-cell.vala"
	_tmp50_ = popover_controller;
#line 231 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp50_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 232 "../src/sudoku-cell.vala"
	_tmp52_ = sudoku_cell_get_popover (self);
#line 232 "../src/sudoku-cell.vala"
	_tmp53_ = _tmp52_;
#line 232 "../src/sudoku-cell.vala"
	_tmp51_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp53_) : NULL;
#line 232 "../src/sudoku-cell.vala"
	if (_tmp51_ != NULL) {
#line 795 "sudoku-cell.c"
		GtkEventControllerKey* _tmp54_;
		GtkEventController* _tmp55_;
#line 232 "../src/sudoku-cell.vala"
		_tmp54_ = popover_controller;
#line 232 "../src/sudoku-cell.vala"
		_tmp55_ = _g_object_ref0 ((GtkEventController*) _tmp54_);
#line 232 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp51_, _tmp55_);
#line 804 "sudoku-cell.c"
	}
#line 233 "../src/sudoku-cell.vala"
	_tmp56_ = sudoku_cell_get_popover (self);
#line 233 "../src/sudoku-cell.vala"
	_tmp57_ = _tmp56_;
#line 233 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp57_, "closed", (GCallback) ___lambda9__gtk_popover_closed, self, 0);
#line 242 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 179 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 179 "../src/sudoku-cell.vala"
	return self;
#line 818 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 179 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 828 "sudoku-cell.c"
}

void
sudoku_cell_update_value (SudokuCell* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 249 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 251 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 251 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 252 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 848 "sudoku-cell.c"
	}
#line 254 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_value (self);
#line 254 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 254 "../src/sudoku-cell.vala"
	if (_tmp3_ != 0) {
#line 856 "sudoku-cell.c"
		GtkLabel* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GtkLabel* _tmp9_;
#line 256 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->value_label;
#line 256 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_value (self);
#line 256 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 256 "../src/sudoku-cell.vala"
		_tmp7_ = g_strdup_printf ("%i", _tmp6_);
#line 256 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 256 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp4_, _tmp8_);
#line 256 "../src/sudoku-cell.vala"
		_g_free0 (_tmp8_);
#line 257 "../src/sudoku-cell.vala"
		_tmp9_ = self->priv->value_label;
#line 257 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp9_, TRUE);
#line 881 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp10_;
#line 260 "../src/sudoku-cell.vala"
		_tmp10_ = self->priv->value_label;
#line 260 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 888 "sudoku-cell.c"
	}
#line 262 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 892 "sudoku-cell.c"
}

void
sudoku_cell_update_earmark (SudokuCell* self,
                            gint val,
                            gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 265 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 267 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 267 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 268 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 912 "sudoku-cell.c"
	}
#line 270 "../src/sudoku-cell.vala"
	sudoku_cell_check_earmark_warnings (self, val, enabled);
#line 271 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 918 "sudoku-cell.c"
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 273 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 277 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 277 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 935 "sudoku-cell.c"
	} else {
#line 277 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 939 "sudoku-cell.c"
	}
#line 277 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 278 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 945 "sudoku-cell.c"
	}
#line 282 "../src/sudoku-cell.vala"
	result = GDK_EVENT_PROPAGATE;
#line 282 "../src/sudoku-cell.vala"
	return result;
#line 951 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	gboolean _tmp10_ = FALSE;
	gint key = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
#line 285 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 289 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 289 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 289 "../src/sudoku-cell.vala"
	if (_tmp3_ == GAME_MODE_PLAY) {
#line 981 "sudoku-cell.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 289 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_is_fixed (self);
#line 289 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 289 "../src/sudoku-cell.vala"
		if (_tmp6_) {
#line 289 "../src/sudoku-cell.vala"
			_tmp4_ = TRUE;
#line 993 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 289 "../src/sudoku-cell.vala"
			_tmp7_ = self->priv->game;
#line 289 "../src/sudoku-cell.vala"
			_tmp8_ = sudoku_game_get_paused (_tmp7_);
#line 289 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp8_;
#line 289 "../src/sudoku-cell.vala"
			_tmp4_ = _tmp9_;
#line 1006 "sudoku-cell.c"
		}
#line 289 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp4_;
#line 1010 "sudoku-cell.c"
	} else {
#line 289 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1014 "sudoku-cell.c"
	}
#line 289 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 290 "../src/sudoku-cell.vala"
		return;
#line 1020 "sudoku-cell.c"
	}
#line 292 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 292 "../src/sudoku-cell.vala"
		_tmp10_ = TRUE;
#line 1026 "sudoku-cell.c"
	} else {
#line 292 "../src/sudoku-cell.vala"
		_tmp10_ = keyval == GDK_KEY_Control_R;
#line 1030 "sudoku-cell.c"
	}
#line 292 "../src/sudoku-cell.vala"
	if (_tmp10_) {
#line 293 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 1036 "sudoku-cell.c"
	}
#line 295 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 296 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 296 "../src/sudoku-cell.vala"
		_tmp11_ = key <= 9;
#line 1044 "sudoku-cell.c"
	} else {
#line 296 "../src/sudoku-cell.vala"
		_tmp11_ = FALSE;
#line 1048 "sudoku-cell.c"
	}
#line 296 "../src/sudoku-cell.vala"
	if (_tmp11_) {
#line 1052 "sudoku-cell.c"
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp12_;
		GtkPopover* _tmp13_;
		GtkWidget* _tmp14_;
		NumberPicker* _tmp15_;
		gboolean ctrl_pressed = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		GtkPopover* _tmp19_;
		GtkPopover* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
		gboolean want_earmark = FALSE;
		gboolean _tmp30_ = FALSE;
#line 299 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_cell_get_popover (self);
#line 299 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 299 "../src/sudoku-cell.vala"
		_tmp14_ = gtk_popover_get_child (_tmp13_);
#line 299 "../src/sudoku-cell.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_NUMBER_PICKER, NumberPicker));
#line 299 "../src/sudoku-cell.vala"
		number_picker = _tmp15_;
#line 300 "../src/sudoku-cell.vala"
		ctrl_pressed = (state & GDK_CONTROL_MASK) > 0;
#line 301 "../src/sudoku-cell.vala"
		_tmp19_ = sudoku_cell_get_popover (self);
#line 301 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp19_;
#line 301 "../src/sudoku-cell.vala"
		_tmp21_ = gtk_widget_get_visible ((GtkWidget*) _tmp20_);
#line 301 "../src/sudoku-cell.vala"
		_tmp22_ = _tmp21_;
#line 301 "../src/sudoku-cell.vala"
		if (_tmp22_) {
#line 1090 "sudoku-cell.c"
			NumberPicker* _tmp23_;
#line 301 "../src/sudoku-cell.vala"
			_tmp23_ = number_picker;
#line 301 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp23_ != NULL;
#line 1096 "sudoku-cell.c"
		} else {
#line 301 "../src/sudoku-cell.vala"
			_tmp18_ = FALSE;
#line 1100 "sudoku-cell.c"
		}
#line 301 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 1104 "sudoku-cell.c"
			NumberPicker* _tmp24_;
			gboolean _tmp25_;
			gboolean _tmp26_;
#line 301 "../src/sudoku-cell.vala"
			_tmp24_ = number_picker;
#line 301 "../src/sudoku-cell.vala"
			_tmp25_ = number_picker_get_is_earmark_picker (_tmp24_);
#line 301 "../src/sudoku-cell.vala"
			_tmp26_ = _tmp25_;
#line 301 "../src/sudoku-cell.vala"
			_tmp17_ = _tmp26_;
#line 1116 "sudoku-cell.c"
		} else {
#line 301 "../src/sudoku-cell.vala"
			_tmp17_ = FALSE;
#line 1120 "sudoku-cell.c"
		}
#line 301 "../src/sudoku-cell.vala"
		if (_tmp17_) {
#line 301 "../src/sudoku-cell.vala"
			_tmp16_ = TRUE;
#line 1126 "sudoku-cell.c"
		} else {
			gboolean _tmp27_ = FALSE;
#line 302 "../src/sudoku-cell.vala"
			if (ctrl_pressed) {
#line 1131 "sudoku-cell.c"
				gint _tmp28_;
				gint _tmp29_;
#line 302 "../src/sudoku-cell.vala"
				_tmp28_ = sudoku_cell_get_value (self);
#line 302 "../src/sudoku-cell.vala"
				_tmp29_ = _tmp28_;
#line 302 "../src/sudoku-cell.vala"
				_tmp27_ = _tmp29_ == 0;
#line 1140 "sudoku-cell.c"
			} else {
#line 302 "../src/sudoku-cell.vala"
				_tmp27_ = FALSE;
#line 1144 "sudoku-cell.c"
			}
#line 302 "../src/sudoku-cell.vala"
			_tmp16_ = _tmp27_;
#line 1148 "sudoku-cell.c"
		}
#line 301 "../src/sudoku-cell.vala"
		want_earmark = _tmp16_;
#line 303 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 1154 "sudoku-cell.c"
			SudokuGame* _tmp31_;
			GameMode _tmp32_;
			GameMode _tmp33_;
#line 303 "../src/sudoku-cell.vala"
			_tmp31_ = self->priv->game;
#line 303 "../src/sudoku-cell.vala"
			_tmp32_ = sudoku_game_get_mode (_tmp31_);
#line 303 "../src/sudoku-cell.vala"
			_tmp33_ = _tmp32_;
#line 303 "../src/sudoku-cell.vala"
			_tmp30_ = _tmp33_ == GAME_MODE_PLAY;
#line 1166 "sudoku-cell.c"
		} else {
#line 303 "../src/sudoku-cell.vala"
			_tmp30_ = FALSE;
#line 1170 "sudoku-cell.c"
		}
#line 303 "../src/sudoku-cell.vala"
		if (_tmp30_) {
#line 1174 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp34_;
			SudokuBoard* _tmp35_;
			SudokuBoard* _tmp36_;
			gboolean _tmp37_ = FALSE;
			NumberPicker* _tmp38_;
#line 305 "../src/sudoku-cell.vala"
			_tmp34_ = self->priv->game;
#line 305 "../src/sudoku-cell.vala"
			_tmp35_ = sudoku_game_get_board (_tmp34_);
#line 305 "../src/sudoku-cell.vala"
			_tmp36_ = _tmp35_;
#line 305 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp36_, self->priv->row, self->priv->col, key);
#line 307 "../src/sudoku-cell.vala"
			_tmp38_ = number_picker;
#line 307 "../src/sudoku-cell.vala"
			if (_tmp38_ != NULL) {
#line 1193 "sudoku-cell.c"
				NumberPicker* _tmp39_;
				gboolean _tmp40_;
				gboolean _tmp41_;
#line 307 "../src/sudoku-cell.vala"
				_tmp39_ = number_picker;
#line 307 "../src/sudoku-cell.vala"
				_tmp40_ = number_picker_get_is_earmark_picker (_tmp39_);
#line 307 "../src/sudoku-cell.vala"
				_tmp41_ = _tmp40_;
#line 307 "../src/sudoku-cell.vala"
				_tmp37_ = _tmp41_;
#line 1205 "sudoku-cell.c"
			} else {
#line 307 "../src/sudoku-cell.vala"
				_tmp37_ = FALSE;
#line 1209 "sudoku-cell.c"
			}
#line 307 "../src/sudoku-cell.vala"
			if (_tmp37_) {
#line 1213 "sudoku-cell.c"
				NumberPicker* _tmp42_;
#line 309 "../src/sudoku-cell.vala"
				_tmp42_ = number_picker;
#line 309 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp42_, self->priv->row, self->priv->col, key - 1, new_state);
#line 1219 "sudoku-cell.c"
			} else {
#line 313 "../src/sudoku-cell.vala"
				if (new_state) {
#line 1223 "sudoku-cell.c"
					SudokuGame* _tmp43_;
#line 314 "../src/sudoku-cell.vala"
					_tmp43_ = self->priv->game;
#line 314 "../src/sudoku-cell.vala"
					sudoku_game_enable_earmark (_tmp43_, self->priv->row, self->priv->col, key);
#line 1229 "sudoku-cell.c"
				} else {
					SudokuGame* _tmp44_;
#line 316 "../src/sudoku-cell.vala"
					_tmp44_ = self->priv->game;
#line 316 "../src/sudoku-cell.vala"
					sudoku_game_disable_earmark (_tmp44_, self->priv->row, self->priv->col, key);
#line 1236 "sudoku-cell.c"
				}
			}
		} else {
#line 319 "../src/sudoku-cell.vala"
			if (!ctrl_pressed) {
#line 1242 "sudoku-cell.c"
				SudokuGame* _tmp45_;
				SudokuBoard* _tmp46_;
				SudokuBoard* _tmp47_;
#line 321 "../src/sudoku-cell.vala"
				sudoku_cell_set_value (self, key);
#line 322 "../src/sudoku-cell.vala"
				_tmp45_ = self->priv->game;
#line 322 "../src/sudoku-cell.vala"
				_tmp46_ = sudoku_game_get_board (_tmp45_);
#line 322 "../src/sudoku-cell.vala"
				_tmp47_ = _tmp46_;
#line 322 "../src/sudoku-cell.vala"
				sudoku_board_disable_all_earmarks (_tmp47_, self->priv->row, self->priv->col);
#line 1256 "sudoku-cell.c"
			}
		}
#line 324 "../src/sudoku-cell.vala"
		_g_object_unref0 (number_picker);
#line 324 "../src/sudoku-cell.vala"
		return;
#line 1263 "sudoku-cell.c"
	}
#line 327 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 327 "../src/sudoku-cell.vala"
		_tmp49_ = TRUE;
#line 1269 "sudoku-cell.c"
	} else {
#line 328 "../src/sudoku-cell.vala"
		_tmp49_ = keyval == GDK_KEY_BackSpace;
#line 1273 "sudoku-cell.c"
	}
#line 327 "../src/sudoku-cell.vala"
	if (_tmp49_) {
#line 327 "../src/sudoku-cell.vala"
		_tmp48_ = TRUE;
#line 1279 "sudoku-cell.c"
	} else {
#line 329 "../src/sudoku-cell.vala"
		_tmp48_ = keyval == GDK_KEY_Delete;
#line 1283 "sudoku-cell.c"
	}
#line 327 "../src/sudoku-cell.vala"
	if (_tmp48_) {
#line 1287 "sudoku-cell.c"
		SudokuGame* _tmp50_;
		SudokuBoard* _tmp51_;
		SudokuBoard* _tmp52_;
#line 331 "../src/sudoku-cell.vala"
		_tmp50_ = self->priv->game;
#line 331 "../src/sudoku-cell.vala"
		_tmp51_ = sudoku_game_get_board (_tmp50_);
#line 331 "../src/sudoku-cell.vala"
		_tmp52_ = _tmp51_;
#line 331 "../src/sudoku-cell.vala"
		if (sudoku_board_has_earmarks (_tmp52_, self->priv->row, self->priv->col)) {
#line 1299 "sudoku-cell.c"
			SudokuGame* _tmp53_;
#line 332 "../src/sudoku-cell.vala"
			_tmp53_ = self->priv->game;
#line 332 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp53_, self->priv->row, self->priv->col);
#line 1305 "sudoku-cell.c"
		}
#line 333 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 334 "../src/sudoku-cell.vala"
		return;
#line 1311 "sudoku-cell.c"
	}
#line 337 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 337 "../src/sudoku-cell.vala"
		_tmp55_ = TRUE;
#line 1317 "sudoku-cell.c"
	} else {
#line 338 "../src/sudoku-cell.vala"
		_tmp55_ = keyval == GDK_KEY_Return;
#line 1321 "sudoku-cell.c"
	}
#line 337 "../src/sudoku-cell.vala"
	if (_tmp55_) {
#line 337 "../src/sudoku-cell.vala"
		_tmp54_ = TRUE;
#line 1327 "sudoku-cell.c"
	} else {
#line 339 "../src/sudoku-cell.vala"
		_tmp54_ = keyval == GDK_KEY_KP_Enter;
#line 1331 "sudoku-cell.c"
	}
#line 337 "../src/sudoku-cell.vala"
	if (_tmp54_) {
#line 1335 "sudoku-cell.c"
		GtkPopover* _tmp56_;
		GtkPopover* _tmp57_;
		gboolean _tmp58_;
		gboolean _tmp59_;
#line 341 "../src/sudoku-cell.vala"
		_tmp56_ = sudoku_cell_get_popover (self);
#line 341 "../src/sudoku-cell.vala"
		_tmp57_ = _tmp56_;
#line 341 "../src/sudoku-cell.vala"
		_tmp58_ = gtk_widget_get_visible ((GtkWidget*) _tmp57_);
#line 341 "../src/sudoku-cell.vala"
		_tmp59_ = _tmp58_;
#line 341 "../src/sudoku-cell.vala"
		if (_tmp59_) {
#line 342 "../src/sudoku-cell.vala"
			return;
#line 1352 "sudoku-cell.c"
		}
#line 343 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 344 "../src/sudoku-cell.vala"
		return;
#line 1358 "sudoku-cell.c"
	}
#line 347 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Escape) {
#line 1362 "sudoku-cell.c"
		GtkPopover* _tmp60_;
		GtkPopover* _tmp61_;
		gboolean _tmp62_;
		gboolean _tmp63_;
#line 349 "../src/sudoku-cell.vala"
		_tmp60_ = sudoku_cell_get_popover (self);
#line 349 "../src/sudoku-cell.vala"
		_tmp61_ = _tmp60_;
#line 349 "../src/sudoku-cell.vala"
		_tmp62_ = gtk_widget_get_visible ((GtkWidget*) _tmp61_);
#line 349 "../src/sudoku-cell.vala"
		_tmp63_ = _tmp62_;
#line 349 "../src/sudoku-cell.vala"
		if (_tmp63_) {
#line 1377 "sudoku-cell.c"
			GtkPopover* _tmp64_;
			GtkPopover* _tmp65_;
#line 350 "../src/sudoku-cell.vala"
			_tmp64_ = sudoku_cell_get_popover (self);
#line 350 "../src/sudoku-cell.vala"
			_tmp65_ = _tmp64_;
#line 350 "../src/sudoku-cell.vala"
			gtk_popover_popdown (_tmp65_);
#line 1386 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		return;
#line 1390 "sudoku-cell.c"
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	SudokuGame* _tmp2_;
	GameMode _tmp3_;
	GameMode _tmp4_;
#line 355 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 359 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 359 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 359 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 359 "../src/sudoku-cell.vala"
	if (_tmp4_ == GAME_MODE_PLAY) {
#line 1417 "sudoku-cell.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 359 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_is_fixed (self);
#line 359 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 359 "../src/sudoku-cell.vala"
		if (_tmp7_) {
#line 359 "../src/sudoku-cell.vala"
			_tmp5_ = TRUE;
#line 1429 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 359 "../src/sudoku-cell.vala"
			_tmp8_ = self->priv->game;
#line 359 "../src/sudoku-cell.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 359 "../src/sudoku-cell.vala"
			_tmp10_ = _tmp9_;
#line 359 "../src/sudoku-cell.vala"
			_tmp5_ = _tmp10_;
#line 1442 "sudoku-cell.c"
		}
#line 359 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp5_;
#line 1446 "sudoku-cell.c"
	} else {
#line 359 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 1450 "sudoku-cell.c"
	}
#line 359 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 359 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 1456 "sudoku-cell.c"
	} else {
		gint _tmp11_;
		gint _tmp12_;
#line 359 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_cell_get_value (self);
#line 359 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 359 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp12_ != 0;
#line 1466 "sudoku-cell.c"
	}
#line 359 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 360 "../src/sudoku-cell.vala"
		return;
#line 1472 "sudoku-cell.c"
	}
#line 362 "../src/sudoku-cell.vala"
	sudoku_cell_show_earmark_picker (self);
#line 1476 "sudoku-cell.c"
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	GameMode _tmp5_;
	GameMode _tmp6_;
#line 365 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 370 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 371 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1501 "sudoku-cell.c"
	} else {
#line 370 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1505 "sudoku-cell.c"
	}
#line 370 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 372 "../src/sudoku-cell.vala"
		return;
#line 1511 "sudoku-cell.c"
	}
#line 374 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 374 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 374 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 375 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1521 "sudoku-cell.c"
	}
#line 377 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->game;
#line 377 "../src/sudoku-cell.vala"
	_tmp5_ = sudoku_game_get_mode (_tmp4_);
#line 377 "../src/sudoku-cell.vala"
	_tmp6_ = _tmp5_;
#line 377 "../src/sudoku-cell.vala"
	if (_tmp6_ == GAME_MODE_PLAY) {
#line 1531 "sudoku-cell.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 377 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_cell_get_is_fixed (self);
#line 377 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 377 "../src/sudoku-cell.vala"
		if (_tmp9_) {
#line 377 "../src/sudoku-cell.vala"
			_tmp7_ = TRUE;
#line 1543 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 377 "../src/sudoku-cell.vala"
			_tmp10_ = self->priv->game;
#line 377 "../src/sudoku-cell.vala"
			_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 377 "../src/sudoku-cell.vala"
			_tmp12_ = _tmp11_;
#line 377 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp12_;
#line 1556 "sudoku-cell.c"
		}
#line 377 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp7_;
#line 1560 "sudoku-cell.c"
	} else {
#line 377 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 1564 "sudoku-cell.c"
	}
#line 377 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 378 "../src/sudoku-cell.vala"
		return;
#line 1570 "sudoku-cell.c"
	}
#line 380 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1574 "sudoku-cell.c"
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
#line 382 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 1579 "sudoku-cell.c"
			GdkEventSequence* _tmp15_;
			GdkEvent* _tmp16_;
#line 383 "../src/sudoku-cell.vala"
			_tmp15_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) gesture);
#line 383 "../src/sudoku-cell.vala"
			_tmp16_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp15_);
#line 383 "../src/sudoku-cell.vala"
			_tmp14_ = (gdk_event_get_modifier_state (_tmp16_) & GDK_CONTROL_MASK) > 0;
#line 1588 "sudoku-cell.c"
		} else {
#line 382 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1592 "sudoku-cell.c"
		}
#line 382 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 1596 "sudoku-cell.c"
			gint _tmp17_;
			gint _tmp18_;
#line 384 "../src/sudoku-cell.vala"
			_tmp17_ = sudoku_cell_get_value (self);
#line 384 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp17_;
#line 384 "../src/sudoku-cell.vala"
			_tmp13_ = _tmp18_ == 0;
#line 1605 "sudoku-cell.c"
		} else {
#line 382 "../src/sudoku-cell.vala"
			_tmp13_ = FALSE;
#line 1609 "sudoku-cell.c"
		}
#line 382 "../src/sudoku-cell.vala"
		if (_tmp13_) {
#line 385 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1615 "sudoku-cell.c"
		} else {
#line 387 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1619 "sudoku-cell.c"
		}
#line 388 "../src/sudoku-cell.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1623 "sudoku-cell.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 390 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 391 "../src/sudoku-cell.vala"
			_tmp20_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY);
#line 1631 "sudoku-cell.c"
		} else {
#line 390 "../src/sudoku-cell.vala"
			_tmp20_ = FALSE;
#line 1635 "sudoku-cell.c"
		}
#line 390 "../src/sudoku-cell.vala"
		if (_tmp20_) {
#line 1639 "sudoku-cell.c"
			gint _tmp21_;
			gint _tmp22_;
#line 392 "../src/sudoku-cell.vala"
			_tmp21_ = sudoku_cell_get_value (self);
#line 392 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 392 "../src/sudoku-cell.vala"
			_tmp19_ = _tmp22_ == 0;
#line 1648 "sudoku-cell.c"
		} else {
#line 390 "../src/sudoku-cell.vala"
			_tmp19_ = FALSE;
#line 1652 "sudoku-cell.c"
		}
#line 390 "../src/sudoku-cell.vala"
		if (_tmp19_) {
#line 394 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 395 "../src/sudoku-cell.vala"
			gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1660 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 399 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 401 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1678 "sudoku-cell.c"
		{
#line 405 "../src/sudoku-cell.vala"
			result = 0;
#line 405 "../src/sudoku-cell.vala"
			return result;
#line 1684 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1690 "sudoku-cell.c"
		{
#line 408 "../src/sudoku-cell.vala"
			result = 1;
#line 408 "../src/sudoku-cell.vala"
			return result;
#line 1696 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1702 "sudoku-cell.c"
		{
#line 411 "../src/sudoku-cell.vala"
			result = 2;
#line 411 "../src/sudoku-cell.vala"
			return result;
#line 1708 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1714 "sudoku-cell.c"
		{
#line 414 "../src/sudoku-cell.vala"
			result = 3;
#line 414 "../src/sudoku-cell.vala"
			return result;
#line 1720 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1726 "sudoku-cell.c"
		{
#line 417 "../src/sudoku-cell.vala"
			result = 4;
#line 417 "../src/sudoku-cell.vala"
			return result;
#line 1732 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1738 "sudoku-cell.c"
		{
#line 420 "../src/sudoku-cell.vala"
			result = 5;
#line 420 "../src/sudoku-cell.vala"
			return result;
#line 1744 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1750 "sudoku-cell.c"
		{
#line 423 "../src/sudoku-cell.vala"
			result = 6;
#line 423 "../src/sudoku-cell.vala"
			return result;
#line 1756 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1762 "sudoku-cell.c"
		{
#line 426 "../src/sudoku-cell.vala"
			result = 7;
#line 426 "../src/sudoku-cell.vala"
			return result;
#line 1768 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1774 "sudoku-cell.c"
		{
#line 429 "../src/sudoku-cell.vala"
			result = 8;
#line 429 "../src/sudoku-cell.vala"
			return result;
#line 1780 "sudoku-cell.c"
		}
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 401 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1786 "sudoku-cell.c"
		{
#line 432 "../src/sudoku-cell.vala"
			result = 9;
#line 432 "../src/sudoku-cell.vala"
			return result;
#line 1792 "sudoku-cell.c"
		}
		default:
		{
#line 434 "../src/sudoku-cell.vala"
			result = -1;
#line 434 "../src/sudoku-cell.vala"
			return result;
#line 1800 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gint num = 0;
#line 438 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 440 "../src/sudoku-cell.vala"
	marks = NULL;
#line 440 "../src/sudoku-cell.vala"
	marks_length1 = 0;
#line 440 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 441 "../src/sudoku-cell.vala"
	if (!self->show_possibilities) {
#line 1822 "sudoku-cell.c"
		SudokuGame* _tmp23_;
		SudokuBoard* _tmp24_;
		SudokuBoard* _tmp25_;
		gint _tmp26_ = 0;
		gboolean* _tmp27_;
#line 443 "../src/sudoku-cell.vala"
		if (!self->priv->initialized_earmarks) {
#line 1830 "sudoku-cell.c"
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 445 "../src/sudoku-cell.vala"
			if (self->priv->_initialize_earmarks) {
#line 1835 "sudoku-cell.c"
				SudokuGame* _tmp2_;
				GameMode _tmp3_;
				GameMode _tmp4_;
#line 445 "../src/sudoku-cell.vala"
				_tmp2_ = self->priv->game;
#line 445 "../src/sudoku-cell.vala"
				_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 445 "../src/sudoku-cell.vala"
				_tmp4_ = _tmp3_;
#line 445 "../src/sudoku-cell.vala"
				_tmp1_ = _tmp4_ == GAME_MODE_PLAY;
#line 1847 "sudoku-cell.c"
			} else {
#line 445 "../src/sudoku-cell.vala"
				_tmp1_ = FALSE;
#line 1851 "sudoku-cell.c"
			}
#line 445 "../src/sudoku-cell.vala"
			if (_tmp1_) {
#line 1855 "sudoku-cell.c"
				SudokuGame* _tmp5_;
				SudokuBoard* _tmp6_;
				SudokuBoard* _tmp7_;
				gdouble _tmp8_;
				gdouble _tmp9_;
#line 446 "../src/sudoku-cell.vala"
				_tmp5_ = self->priv->game;
#line 446 "../src/sudoku-cell.vala"
				_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 446 "../src/sudoku-cell.vala"
				_tmp7_ = _tmp6_;
#line 446 "../src/sudoku-cell.vala"
				_tmp8_ = sudoku_board_get_previous_played_time (_tmp7_);
#line 446 "../src/sudoku-cell.vala"
				_tmp9_ = _tmp8_;
#line 446 "../src/sudoku-cell.vala"
				_tmp0_ = _tmp9_ == 0.0;
#line 1873 "sudoku-cell.c"
			} else {
#line 445 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 1877 "sudoku-cell.c"
			}
#line 445 "../src/sudoku-cell.vala"
			if (_tmp0_) {
#line 1881 "sudoku-cell.c"
				SudokuGame* _tmp10_;
				SudokuBoard* _tmp11_;
				SudokuBoard* _tmp12_;
				gint _tmp13_ = 0;
				gboolean* _tmp14_;
#line 448 "../src/sudoku-cell.vala"
				_tmp10_ = self->priv->game;
#line 448 "../src/sudoku-cell.vala"
				_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 448 "../src/sudoku-cell.vala"
				_tmp12_ = _tmp11_;
#line 448 "../src/sudoku-cell.vala"
				_tmp14_ = sudoku_board_get_possibilities_as_bool_array (_tmp12_, self->priv->row, self->priv->col, &_tmp13_);
#line 448 "../src/sudoku-cell.vala"
				marks = (g_free (marks), NULL);
#line 448 "../src/sudoku-cell.vala"
				marks = _tmp14_;
#line 448 "../src/sudoku-cell.vala"
				marks_length1 = _tmp13_;
#line 448 "../src/sudoku-cell.vala"
				_marks_size_ = marks_length1;
#line 1903 "sudoku-cell.c"
				{
					gint num = 0;
#line 449 "../src/sudoku-cell.vala"
					num = 1;
#line 1908 "sudoku-cell.c"
					{
						gboolean _tmp15_ = FALSE;
#line 449 "../src/sudoku-cell.vala"
						_tmp15_ = TRUE;
#line 449 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1915 "sudoku-cell.c"
							gboolean* _tmp17_;
							gint _tmp17__length1;
							gboolean* _tmp18_;
							gint _tmp18__length1;
							gboolean _tmp19_;
#line 449 "../src/sudoku-cell.vala"
							if (!_tmp15_) {
#line 1923 "sudoku-cell.c"
								gint _tmp16_;
#line 449 "../src/sudoku-cell.vala"
								_tmp16_ = num;
#line 449 "../src/sudoku-cell.vala"
								num = _tmp16_ + 1;
#line 1929 "sudoku-cell.c"
							}
#line 449 "../src/sudoku-cell.vala"
							_tmp15_ = FALSE;
#line 449 "../src/sudoku-cell.vala"
							_tmp17_ = marks;
#line 449 "../src/sudoku-cell.vala"
							_tmp17__length1 = marks_length1;
#line 449 "../src/sudoku-cell.vala"
							if (!(num <= _tmp17__length1)) {
#line 449 "../src/sudoku-cell.vala"
								break;
#line 1941 "sudoku-cell.c"
							}
#line 451 "../src/sudoku-cell.vala"
							_tmp18_ = marks;
#line 451 "../src/sudoku-cell.vala"
							_tmp18__length1 = marks_length1;
#line 451 "../src/sudoku-cell.vala"
							_tmp19_ = _tmp18_[num - 1];
#line 451 "../src/sudoku-cell.vala"
							if (_tmp19_) {
#line 1951 "sudoku-cell.c"
								SudokuGame* _tmp20_;
								SudokuBoard* _tmp21_;
								SudokuBoard* _tmp22_;
#line 453 "../src/sudoku-cell.vala"
								_tmp20_ = self->priv->game;
#line 453 "../src/sudoku-cell.vala"
								_tmp21_ = sudoku_game_get_board (_tmp20_);
#line 453 "../src/sudoku-cell.vala"
								_tmp22_ = _tmp21_;
#line 453 "../src/sudoku-cell.vala"
								sudoku_board_enable_earmark (_tmp22_, self->priv->row, self->priv->col, num);
#line 1963 "sudoku-cell.c"
							}
						}
					}
				}
			}
#line 457 "../src/sudoku-cell.vala"
			self->priv->initialized_earmarks = TRUE;
#line 1971 "sudoku-cell.c"
		}
#line 460 "../src/sudoku-cell.vala"
		_tmp23_ = self->priv->game;
#line 460 "../src/sudoku-cell.vala"
		_tmp24_ = sudoku_game_get_board (_tmp23_);
#line 460 "../src/sudoku-cell.vala"
		_tmp25_ = _tmp24_;
#line 460 "../src/sudoku-cell.vala"
		_tmp27_ = sudoku_board_get_earmarks (_tmp25_, self->priv->row, self->priv->col, &_tmp26_);
#line 460 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 460 "../src/sudoku-cell.vala"
		marks = _tmp27_;
#line 460 "../src/sudoku-cell.vala"
		marks_length1 = _tmp26_;
#line 460 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1989 "sudoku-cell.c"
	} else {
		gint _tmp28_;
		gint _tmp29_;
#line 462 "../src/sudoku-cell.vala"
		_tmp28_ = sudoku_cell_get_value (self);
#line 462 "../src/sudoku-cell.vala"
		_tmp29_ = _tmp28_;
#line 462 "../src/sudoku-cell.vala"
		if (_tmp29_ == 0) {
#line 1999 "sudoku-cell.c"
			SudokuGame* _tmp30_;
			SudokuBoard* _tmp31_;
			SudokuBoard* _tmp32_;
			gint _tmp33_ = 0;
			gboolean* _tmp34_;
#line 464 "../src/sudoku-cell.vala"
			_tmp30_ = self->priv->game;
#line 464 "../src/sudoku-cell.vala"
			_tmp31_ = sudoku_game_get_board (_tmp30_);
#line 464 "../src/sudoku-cell.vala"
			_tmp32_ = _tmp31_;
#line 464 "../src/sudoku-cell.vala"
			_tmp34_ = sudoku_board_get_possibilities_as_bool_array (_tmp32_, self->priv->row, self->priv->col, &_tmp33_);
#line 464 "../src/sudoku-cell.vala"
			marks = (g_free (marks), NULL);
#line 464 "../src/sudoku-cell.vala"
			marks = _tmp34_;
#line 464 "../src/sudoku-cell.vala"
			marks_length1 = _tmp33_;
#line 464 "../src/sudoku-cell.vala"
			_marks_size_ = marks_length1;
#line 2021 "sudoku-cell.c"
		}
	}
#line 467 "../src/sudoku-cell.vala"
	num = 0;
#line 2026 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 468 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 2031 "sudoku-cell.c"
		{
			gboolean _tmp35_ = FALSE;
#line 468 "../src/sudoku-cell.vala"
			_tmp35_ = TRUE;
#line 468 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2038 "sudoku-cell.c"
				SudokuGame* _tmp37_;
				SudokuBoard* _tmp38_;
				SudokuBoard* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
#line 468 "../src/sudoku-cell.vala"
				if (!_tmp35_) {
#line 2046 "sudoku-cell.c"
					gint _tmp36_;
#line 468 "../src/sudoku-cell.vala"
					_tmp36_ = row_tmp;
#line 468 "../src/sudoku-cell.vala"
					row_tmp = _tmp36_ + 1;
#line 2052 "sudoku-cell.c"
				}
#line 468 "../src/sudoku-cell.vala"
				_tmp35_ = FALSE;
#line 468 "../src/sudoku-cell.vala"
				_tmp37_ = self->priv->game;
#line 468 "../src/sudoku-cell.vala"
				_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 468 "../src/sudoku-cell.vala"
				_tmp39_ = _tmp38_;
#line 468 "../src/sudoku-cell.vala"
				_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 468 "../src/sudoku-cell.vala"
				_tmp41_ = _tmp40_;
#line 468 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp41_)) {
#line 468 "../src/sudoku-cell.vala"
					break;
#line 2070 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 470 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 2076 "sudoku-cell.c"
					{
						gboolean _tmp42_ = FALSE;
#line 470 "../src/sudoku-cell.vala"
						_tmp42_ = TRUE;
#line 470 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 2083 "sudoku-cell.c"
							SudokuGame* _tmp44_;
							SudokuBoard* _tmp45_;
							SudokuBoard* _tmp46_;
							gint _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							gboolean _tmp50_ = FALSE;
							gboolean* _tmp51_;
							gint _tmp51__length1;
#line 470 "../src/sudoku-cell.vala"
							if (!_tmp42_) {
#line 2095 "sudoku-cell.c"
								gint _tmp43_;
#line 470 "../src/sudoku-cell.vala"
								_tmp43_ = col_tmp;
#line 470 "../src/sudoku-cell.vala"
								col_tmp = _tmp43_ + 1;
#line 2101 "sudoku-cell.c"
							}
#line 470 "../src/sudoku-cell.vala"
							_tmp42_ = FALSE;
#line 470 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->game;
#line 470 "../src/sudoku-cell.vala"
							_tmp45_ = sudoku_game_get_board (_tmp44_);
#line 470 "../src/sudoku-cell.vala"
							_tmp46_ = _tmp45_;
#line 470 "../src/sudoku-cell.vala"
							_tmp47_ = sudoku_board_get_block_cols (_tmp46_);
#line 470 "../src/sudoku-cell.vala"
							_tmp48_ = _tmp47_;
#line 470 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp48_)) {
#line 470 "../src/sudoku-cell.vala"
								break;
#line 2119 "sudoku-cell.c"
							}
#line 472 "../src/sudoku-cell.vala"
							_tmp49_ = num;
#line 472 "../src/sudoku-cell.vala"
							num = _tmp49_ + 1;
#line 474 "../src/sudoku-cell.vala"
							_tmp51_ = marks;
#line 474 "../src/sudoku-cell.vala"
							_tmp51__length1 = marks_length1;
#line 474 "../src/sudoku-cell.vala"
							if (_tmp51_ == NULL) {
#line 474 "../src/sudoku-cell.vala"
								_tmp50_ = TRUE;
#line 2133 "sudoku-cell.c"
							} else {
								gint _tmp52_;
								gint _tmp53_;
#line 474 "../src/sudoku-cell.vala"
								_tmp52_ = sudoku_cell_get_value (self);
#line 474 "../src/sudoku-cell.vala"
								_tmp53_ = _tmp52_;
#line 474 "../src/sudoku-cell.vala"
								_tmp50_ = _tmp53_ != 0;
#line 2143 "sudoku-cell.c"
							}
#line 474 "../src/sudoku-cell.vala"
							if (_tmp50_) {
#line 2147 "sudoku-cell.c"
								GtkLabel** _tmp54_;
								gint _tmp54__length1;
								GtkLabel* _tmp55_;
#line 475 "../src/sudoku-cell.vala"
								_tmp54_ = self->priv->earmark_labels;
#line 475 "../src/sudoku-cell.vala"
								_tmp54__length1 = self->priv->earmark_labels_length1;
#line 475 "../src/sudoku-cell.vala"
								_tmp55_ = _tmp54_[num - 1];
#line 475 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp55_, FALSE);
#line 2159 "sudoku-cell.c"
							} else {
								GtkLabel** _tmp56_;
								gint _tmp56__length1;
								GtkLabel* _tmp57_;
								gboolean* _tmp58_;
								gint _tmp58__length1;
								gboolean _tmp59_;
#line 477 "../src/sudoku-cell.vala"
								_tmp56_ = self->priv->earmark_labels;
#line 477 "../src/sudoku-cell.vala"
								_tmp56__length1 = self->priv->earmark_labels_length1;
#line 477 "../src/sudoku-cell.vala"
								_tmp57_ = _tmp56_[num - 1];
#line 477 "../src/sudoku-cell.vala"
								_tmp58_ = marks;
#line 477 "../src/sudoku-cell.vala"
								_tmp58__length1 = marks_length1;
#line 477 "../src/sudoku-cell.vala"
								_tmp59_ = _tmp58_[num - 1];
#line 477 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp57_, _tmp59_);
#line 2181 "sudoku-cell.c"
							}
						}
					}
				}
			}
		}
	}
#line 438 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2191 "sudoku-cell.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 482 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 482 "../src/sudoku-cell.vala"
	return _data10_;
#line 2201 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 482 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2211 "sudoku-cell.c"
		SudokuCell* self;
#line 482 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 482 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 482 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 482 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 2221 "sudoku-cell.c"
	}
}

static void
__lambda7_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
#line 495 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 496 "../src/sudoku-cell.vala"
	if (state) {
#line 2238 "sudoku-cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
#line 498 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 498 "../src/sudoku-cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 498 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp1_;
#line 498 "../src/sudoku-cell.vala"
		if (!sudoku_board_is_earmark_enabled (_tmp2_, self->priv->row, self->priv->col, number)) {
#line 2250 "sudoku-cell.c"
			SudokuGame* _tmp3_;
#line 499 "../src/sudoku-cell.vala"
			_tmp3_ = self->priv->game;
#line 499 "../src/sudoku-cell.vala"
			sudoku_game_enable_earmark (_tmp3_, self->priv->row, self->priv->col, number);
#line 2256 "sudoku-cell.c"
		}
	} else {
#line 503 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 2261 "sudoku-cell.c"
			SudokuGame* _tmp4_;
#line 504 "../src/sudoku-cell.vala"
			_tmp4_ = self->priv->game;
#line 504 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 2267 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			SudokuBoard* _tmp6_;
			SudokuBoard* _tmp7_;
#line 506 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 506 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 506 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 506 "../src/sudoku-cell.vala"
			if (sudoku_board_is_earmark_enabled (_tmp7_, self->priv->row, self->priv->col, number)) {
#line 2280 "sudoku-cell.c"
				SudokuGame* _tmp8_;
#line 507 "../src/sudoku-cell.vala"
				_tmp8_ = self->priv->game;
#line 507 "../src/sudoku-cell.vala"
				sudoku_game_disable_earmark (_tmp8_, self->priv->row, self->priv->col, number);
#line 2286 "sudoku-cell.c"
			}
		}
	}
#line 510 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 510 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 510 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 510 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp11_, self->priv->row, self->priv->col)) {
#line 2298 "sudoku-cell.c"
		NumberPicker* _tmp12_;
#line 511 "../src/sudoku-cell.vala"
		_tmp12_ = _data10_->earmark_picker;
#line 511 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp12_, FALSE);
#line 2304 "sudoku-cell.c"
	} else {
		NumberPicker* _tmp13_;
#line 513 "../src/sudoku-cell.vala"
		_tmp13_ = _data10_->earmark_picker;
#line 513 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp13_, TRUE);
#line 2311 "sudoku-cell.c"
	}
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 495 "../src/sudoku-cell.vala"
	__lambda7_ (self, number, active);
#line 2323 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	Block10Data* _data10_;
	gboolean _tmp2_ = FALSE;
	GtkPopover* _tmp3_;
	GtkPopover* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	SudokuGame* _tmp13_;
	NumberPicker* _tmp14_;
	NumberPicker* _tmp15_;
	SudokuGame* _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	NumberPicker* _tmp20_;
	NumberPicker* _tmp21_;
	GtkPopover* _tmp22_;
	GtkPopover* _tmp23_;
	NumberPicker* _tmp24_;
	GtkPopover* _tmp25_;
	GtkPopover* _tmp26_;
#line 482 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 482 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 482 "../src/sudoku-cell.vala"
	_vala_return_if_fail (_tmp1_ == 0, "this.value == 0");
#line 482 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 482 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 482 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 485 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_popover (self);
#line 485 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 485 "../src/sudoku-cell.vala"
	_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
#line 485 "../src/sudoku-cell.vala"
	_tmp6_ = _tmp5_;
#line 485 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 2374 "sudoku-cell.c"
		GtkPopover* _tmp7_;
		GtkPopover* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 485 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_cell_get_popover (self);
#line 485 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 485 "../src/sudoku-cell.vala"
		_tmp9_ = gtk_popover_get_child (_tmp8_);
#line 485 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 485 "../src/sudoku-cell.vala"
		_tmp11_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_NUMBER_PICKER, NumberPicker));
#line 485 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 485 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp12_;
#line 2395 "sudoku-cell.c"
	} else {
#line 485 "../src/sudoku-cell.vala"
		_tmp2_ = FALSE;
#line 2399 "sudoku-cell.c"
	}
#line 485 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 486 "../src/sudoku-cell.vala"
		block10_data_unref (_data10_);
#line 486 "../src/sudoku-cell.vala"
		_data10_ = NULL;
#line 486 "../src/sudoku-cell.vala"
		return;
#line 2409 "sudoku-cell.c"
	}
#line 488 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 490 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->game;
#line 490 "../src/sudoku-cell.vala"
	_tmp14_ = number_picker_new (_tmp13_, TRUE);
#line 490 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp14_);
#line 490 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp14_;
#line 491 "../src/sudoku-cell.vala"
	_tmp15_ = _data10_->earmark_picker;
#line 491 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp15_, TRUE);
#line 492 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->game;
#line 492 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 492 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 492 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col)) {
#line 2433 "sudoku-cell.c"
		NumberPicker* _tmp19_;
#line 493 "../src/sudoku-cell.vala"
		_tmp19_ = _data10_->earmark_picker;
#line 493 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp19_, FALSE);
#line 2439 "sudoku-cell.c"
	}
#line 495 "../src/sudoku-cell.vala"
	_tmp20_ = _data10_->earmark_picker;
#line 495 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp20_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 515 "../src/sudoku-cell.vala"
	_tmp21_ = _data10_->earmark_picker;
#line 515 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp21_, self->priv->row, self->priv->col);
#line 516 "../src/sudoku-cell.vala"
	_tmp22_ = sudoku_cell_get_popover (self);
#line 516 "../src/sudoku-cell.vala"
	_tmp23_ = _tmp22_;
#line 516 "../src/sudoku-cell.vala"
	_tmp24_ = _data10_->earmark_picker;
#line 516 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp23_, (GtkWidget*) _tmp24_);
#line 518 "../src/sudoku-cell.vala"
	_tmp25_ = sudoku_cell_get_popover (self);
#line 518 "../src/sudoku-cell.vala"
	_tmp26_ = _tmp25_;
#line 518 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp26_);
#line 482 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 482 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 2467 "sudoku-cell.c"
}

static void
__lambda8_ (SudokuCell* self,
            NumberPicker* o,
            gint number)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	SudokuBoard* _tmp4_;
#line 529 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 530 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 530 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 530 "../src/sudoku-cell.vala"
	gtk_popover_popdown (_tmp1_);
#line 532 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 533 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 533 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 533 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 533 "../src/sudoku-cell.vala"
	sudoku_board_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 2498 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 529 "../src/sudoku-cell.vala"
	__lambda8_ ((SudokuCell*) self, _sender, number);
#line 2508 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	NumberPicker* number_picker = NULL;
	SudokuGame* _tmp11_;
	NumberPicker* _tmp12_;
	NumberPicker* _tmp13_;
	NumberPicker* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GtkPopover* _tmp17_;
	GtkPopover* _tmp18_;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	GtkPopover* _tmp21_;
#line 521 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_popover (self);
#line 523 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 523 "../src/sudoku-cell.vala"
	_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 523 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 523 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 2543 "sudoku-cell.c"
		GtkPopover* _tmp5_;
		GtkPopover* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 523 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_popover (self);
#line 523 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 523 "../src/sudoku-cell.vala"
		_tmp7_ = gtk_popover_get_child (_tmp6_);
#line 523 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 523 "../src/sudoku-cell.vala"
		_tmp9_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_NUMBER_PICKER, NumberPicker));
#line 523 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 523 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp10_;
#line 2564 "sudoku-cell.c"
	} else {
#line 523 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2568 "sudoku-cell.c"
	}
#line 523 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 524 "../src/sudoku-cell.vala"
		return;
#line 2574 "sudoku-cell.c"
	}
#line 526 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 528 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->game;
#line 528 "../src/sudoku-cell.vala"
	_tmp12_ = number_picker_new (_tmp11_, FALSE);
#line 528 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp12_);
#line 528 "../src/sudoku-cell.vala"
	number_picker = _tmp12_;
#line 529 "../src/sudoku-cell.vala"
	_tmp13_ = number_picker;
#line 529 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp13_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
#line 535 "../src/sudoku-cell.vala"
	_tmp14_ = number_picker;
#line 535 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_cell_get_value (self);
#line 535 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 535 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp14_, _tmp16_ != 0);
#line 536 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_cell_get_popover (self);
#line 536 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 536 "../src/sudoku-cell.vala"
	_tmp19_ = number_picker;
#line 536 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp18_, (GtkWidget*) _tmp19_);
#line 538 "../src/sudoku-cell.vala"
	_tmp20_ = sudoku_cell_get_popover (self);
#line 538 "../src/sudoku-cell.vala"
	_tmp21_ = _tmp20_;
#line 538 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp21_);
#line 521 "../src/sudoku-cell.vala"
	_g_object_unref0 (number_picker);
#line 2614 "sudoku-cell.c"
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _error_ = FALSE;
	gint solution = 0;
	SudokuGame* _tmp2_;
	GameMode _tmp3_;
	GameMode _tmp4_;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	SudokuGame* _tmp22_;
	GameMode _tmp23_;
	GameMode _tmp24_;
	SudokuGame* _tmp29_;
	SudokuBoard* _tmp30_;
	SudokuBoard* _tmp31_;
	GeeSet* _tmp32_;
	GeeSet* _tmp33_;
	Coord _tmp34_ = {0};
	gint _tmp35_;
	gint _tmp36_;
	gboolean* marks = NULL;
	SudokuGame* _tmp37_;
	SudokuBoard* _tmp38_;
	SudokuBoard* _tmp39_;
	gint _tmp40_ = 0;
	gboolean* _tmp41_;
	gint marks_length1;
	gint _marks_size_;
#line 541 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_show_warnings (self);
#line 543 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 543 "../src/sudoku-cell.vala"
	if (!_tmp1_) {
#line 544 "../src/sudoku-cell.vala"
		return;
#line 2661 "sudoku-cell.c"
	}
#line 546 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 547 "../src/sudoku-cell.vala"
	solution = 0;
#line 549 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 549 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 549 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 549 "../src/sudoku-cell.vala"
	if (_tmp4_ == GAME_MODE_PLAY) {
#line 2675 "sudoku-cell.c"
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		SudokuBoard* _tmp7_;
#line 550 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 550 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 550 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 550 "../src/sudoku-cell.vala"
		solution = sudoku_board_get_solution (_tmp7_, self->priv->row, self->priv->col);
#line 2687 "sudoku-cell.c"
	}
#line 552 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_value (self);
#line 552 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 552 "../src/sudoku-cell.vala"
	if (_tmp10_ == 0) {
#line 2695 "sudoku-cell.c"
		SudokuGame* _tmp11_;
		SudokuBoard* _tmp12_;
		SudokuBoard* _tmp13_;
#line 552 "../src/sudoku-cell.vala"
		_tmp11_ = self->priv->game;
#line 552 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 552 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 552 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_board_count_possibilities (_tmp13_, self->priv->row, self->priv->col) == 0;
#line 2707 "sudoku-cell.c"
	} else {
#line 552 "../src/sudoku-cell.vala"
		_tmp8_ = FALSE;
#line 2711 "sudoku-cell.c"
	}
#line 552 "../src/sudoku-cell.vala"
	if (_tmp8_) {
#line 2715 "sudoku-cell.c"
		GtkLabel* _tmp14_;
#line 553 "../src/sudoku-cell.vala"
		_tmp14_ = self->priv->value_label;
#line 553 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp14_, "X");
#line 2721 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 555 "../src/sudoku-cell.vala"
		_tmp15_ = self->priv->value_label;
#line 555 "../src/sudoku-cell.vala"
		_tmp16_ = sudoku_cell_get_value (self);
#line 555 "../src/sudoku-cell.vala"
		_tmp17_ = _tmp16_;
#line 555 "../src/sudoku-cell.vala"
		_tmp18_ = g_strdup_printf ("%i", _tmp17_);
#line 555 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_;
#line 555 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp15_, _tmp19_);
#line 555 "../src/sudoku-cell.vala"
		_g_free0 (_tmp19_);
#line 2742 "sudoku-cell.c"
	}
#line 557 "../src/sudoku-cell.vala"
	_tmp22_ = self->priv->game;
#line 557 "../src/sudoku-cell.vala"
	_tmp23_ = sudoku_game_get_mode (_tmp22_);
#line 557 "../src/sudoku-cell.vala"
	_tmp24_ = _tmp23_;
#line 557 "../src/sudoku-cell.vala"
	if (_tmp24_ == GAME_MODE_PLAY) {
#line 557 "../src/sudoku-cell.vala"
		_tmp21_ = sudoku_cell_warn_incorrect_solution (self);
#line 2754 "sudoku-cell.c"
	} else {
#line 557 "../src/sudoku-cell.vala"
		_tmp21_ = FALSE;
#line 2758 "sudoku-cell.c"
	}
#line 557 "../src/sudoku-cell.vala"
	if (_tmp21_) {
#line 2762 "sudoku-cell.c"
		gint _tmp25_;
		gint _tmp26_;
#line 557 "../src/sudoku-cell.vala"
		_tmp25_ = sudoku_cell_get_value (self);
#line 557 "../src/sudoku-cell.vala"
		_tmp26_ = _tmp25_;
#line 557 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp26_ != 0;
#line 2771 "sudoku-cell.c"
	} else {
#line 557 "../src/sudoku-cell.vala"
		_tmp20_ = FALSE;
#line 2775 "sudoku-cell.c"
	}
#line 557 "../src/sudoku-cell.vala"
	if (_tmp20_) {
#line 2779 "sudoku-cell.c"
		gint _tmp27_;
		gint _tmp28_;
#line 558 "../src/sudoku-cell.vala"
		_tmp27_ = sudoku_cell_get_value (self);
#line 558 "../src/sudoku-cell.vala"
		_tmp28_ = _tmp27_;
#line 558 "../src/sudoku-cell.vala"
		_error_ = _tmp28_ != solution;
#line 2788 "sudoku-cell.c"
	}
#line 560 "../src/sudoku-cell.vala"
	_tmp29_ = self->priv->game;
#line 560 "../src/sudoku-cell.vala"
	_tmp30_ = sudoku_game_get_board (_tmp29_);
#line 560 "../src/sudoku-cell.vala"
	_tmp31_ = _tmp30_;
#line 560 "../src/sudoku-cell.vala"
	_tmp32_ = sudoku_board_get_broken_coords (_tmp31_);
#line 560 "../src/sudoku-cell.vala"
	_tmp33_ = _tmp32_;
#line 560 "../src/sudoku-cell.vala"
	coord_init (&_tmp34_, self->priv->row, self->priv->col);
#line 560 "../src/sudoku-cell.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp33_, &_tmp34_)) {
#line 561 "../src/sudoku-cell.vala"
		_error_ = TRUE;
#line 2806 "sudoku-cell.c"
	}
#line 563 "../src/sudoku-cell.vala"
	if (_error_) {
#line 564 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2812 "sudoku-cell.c"
	} else {
#line 566 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2816 "sudoku-cell.c"
	}
#line 568 "../src/sudoku-cell.vala"
	_tmp35_ = sudoku_cell_get_value (self);
#line 568 "../src/sudoku-cell.vala"
	_tmp36_ = _tmp35_;
#line 568 "../src/sudoku-cell.vala"
	if (_tmp36_ != 0) {
#line 569 "../src/sudoku-cell.vala"
		return;
#line 2826 "sudoku-cell.c"
	}
#line 571 "../src/sudoku-cell.vala"
	_tmp37_ = self->priv->game;
#line 571 "../src/sudoku-cell.vala"
	_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 571 "../src/sudoku-cell.vala"
	_tmp39_ = _tmp38_;
#line 571 "../src/sudoku-cell.vala"
	_tmp41_ = sudoku_board_get_earmarks (_tmp39_, self->priv->row, self->priv->col, &_tmp40_);
#line 571 "../src/sudoku-cell.vala"
	marks = _tmp41_;
#line 571 "../src/sudoku-cell.vala"
	marks_length1 = _tmp40_;
#line 571 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 2842 "sudoku-cell.c"
	{
		gint num = 0;
#line 572 "../src/sudoku-cell.vala"
		num = 1;
#line 2847 "sudoku-cell.c"
		{
			gboolean _tmp42_ = FALSE;
#line 572 "../src/sudoku-cell.vala"
			_tmp42_ = TRUE;
#line 572 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2854 "sudoku-cell.c"
				gboolean* _tmp44_;
				gint _tmp44__length1;
				gboolean* _tmp45_;
				gint _tmp45__length1;
				gboolean _tmp46_;
#line 572 "../src/sudoku-cell.vala"
				if (!_tmp42_) {
#line 2862 "sudoku-cell.c"
					gint _tmp43_;
#line 572 "../src/sudoku-cell.vala"
					_tmp43_ = num;
#line 572 "../src/sudoku-cell.vala"
					num = _tmp43_ + 1;
#line 2868 "sudoku-cell.c"
				}
#line 572 "../src/sudoku-cell.vala"
				_tmp42_ = FALSE;
#line 572 "../src/sudoku-cell.vala"
				_tmp44_ = marks;
#line 572 "../src/sudoku-cell.vala"
				_tmp44__length1 = marks_length1;
#line 572 "../src/sudoku-cell.vala"
				if (!(num <= _tmp44__length1)) {
#line 572 "../src/sudoku-cell.vala"
					break;
#line 2880 "sudoku-cell.c"
				}
#line 574 "../src/sudoku-cell.vala"
				_tmp45_ = marks;
#line 574 "../src/sudoku-cell.vala"
				_tmp45__length1 = marks_length1;
#line 574 "../src/sudoku-cell.vala"
				_tmp46_ = _tmp45_[num - 1];
#line 574 "../src/sudoku-cell.vala"
				if (_tmp46_) {
#line 2890 "sudoku-cell.c"
					gboolean _tmp47_ = FALSE;
					SudokuGame* _tmp48_;
					SudokuBoard* _tmp49_;
					SudokuBoard* _tmp50_;
#line 576 "../src/sudoku-cell.vala"
					_tmp48_ = self->priv->game;
#line 576 "../src/sudoku-cell.vala"
					_tmp49_ = sudoku_game_get_board (_tmp48_);
#line 576 "../src/sudoku-cell.vala"
					_tmp50_ = _tmp49_;
#line 576 "../src/sudoku-cell.vala"
					if (!sudoku_board_is_possible (_tmp50_, self->priv->row, self->priv->col, num)) {
#line 576 "../src/sudoku-cell.vala"
						_tmp47_ = TRUE;
#line 2905 "sudoku-cell.c"
					} else {
						gboolean _tmp51_ = FALSE;
						gboolean _tmp52_ = FALSE;
						SudokuGame* _tmp53_;
						GameMode _tmp54_;
						GameMode _tmp55_;
#line 577 "../src/sudoku-cell.vala"
						_tmp53_ = self->priv->game;
#line 577 "../src/sudoku-cell.vala"
						_tmp54_ = sudoku_game_get_mode (_tmp53_);
#line 577 "../src/sudoku-cell.vala"
						_tmp55_ = _tmp54_;
#line 577 "../src/sudoku-cell.vala"
						if (_tmp55_ == GAME_MODE_PLAY) {
#line 577 "../src/sudoku-cell.vala"
							_tmp52_ = sudoku_cell_warn_incorrect_solution (self);
#line 2922 "sudoku-cell.c"
						} else {
#line 577 "../src/sudoku-cell.vala"
							_tmp52_ = FALSE;
#line 2926 "sudoku-cell.c"
						}
#line 577 "../src/sudoku-cell.vala"
						if (_tmp52_) {
#line 577 "../src/sudoku-cell.vala"
							_tmp51_ = num != solution;
#line 2932 "sudoku-cell.c"
						} else {
#line 577 "../src/sudoku-cell.vala"
							_tmp51_ = FALSE;
#line 2936 "sudoku-cell.c"
						}
#line 577 "../src/sudoku-cell.vala"
						_tmp47_ = _tmp51_;
#line 2940 "sudoku-cell.c"
					}
#line 576 "../src/sudoku-cell.vala"
					if (_tmp47_) {
#line 2944 "sudoku-cell.c"
						GtkLabel** _tmp56_;
						gint _tmp56__length1;
						GtkLabel* _tmp57_;
#line 579 "../src/sudoku-cell.vala"
						_tmp56_ = self->priv->earmark_labels;
#line 579 "../src/sudoku-cell.vala"
						_tmp56__length1 = self->priv->earmark_labels_length1;
#line 579 "../src/sudoku-cell.vala"
						_tmp57_ = _tmp56_[num - 1];
#line 579 "../src/sudoku-cell.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp57_, "error");
#line 2956 "sudoku-cell.c"
					} else {
						GtkLabel** _tmp58_;
						gint _tmp58__length1;
						GtkLabel* _tmp59_;
#line 582 "../src/sudoku-cell.vala"
						_tmp58_ = self->priv->earmark_labels;
#line 582 "../src/sudoku-cell.vala"
						_tmp58__length1 = self->priv->earmark_labels_length1;
#line 582 "../src/sudoku-cell.vala"
						_tmp59_ = _tmp58_[num - 1];
#line 582 "../src/sudoku-cell.vala"
						gtk_widget_remove_css_class ((GtkWidget*) _tmp59_, "error");
#line 2969 "sudoku-cell.c"
					}
				}
			}
		}
	}
#line 541 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2977 "sudoku-cell.c"
}

void
sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                    gint value,
                                    gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gint solution = 0;
	SudokuGame* _tmp10_;
	SudokuBoard* _tmp11_;
	SudokuBoard* _tmp12_;
	gboolean _tmp13_ = FALSE;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
#line 587 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 589 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_show_warnings (self);
#line 589 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 589 "../src/sudoku-cell.vala"
	if (!_tmp4_) {
#line 589 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 3008 "sudoku-cell.c"
	} else {
#line 589 "../src/sudoku-cell.vala"
		_tmp2_ = !enabled;
#line 3012 "sudoku-cell.c"
	}
#line 589 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 589 "../src/sudoku-cell.vala"
		_tmp1_ = TRUE;
#line 3018 "sudoku-cell.c"
	} else {
		gint _tmp5_;
		gint _tmp6_;
#line 589 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_value (self);
#line 589 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 589 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp6_ != 0;
#line 3028 "sudoku-cell.c"
	}
#line 589 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 589 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 3034 "sudoku-cell.c"
	} else {
		SudokuGame* _tmp7_;
		GameMode _tmp8_;
		GameMode _tmp9_;
#line 589 "../src/sudoku-cell.vala"
		_tmp7_ = self->priv->game;
#line 589 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 589 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 589 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp9_ != GAME_MODE_PLAY;
#line 3047 "sudoku-cell.c"
	}
#line 589 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 590 "../src/sudoku-cell.vala"
		return;
#line 3053 "sudoku-cell.c"
	}
#line 592 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->game;
#line 592 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 592 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 592 "../src/sudoku-cell.vala"
	solution = sudoku_board_get_solution (_tmp12_, self->priv->row, self->priv->col);
#line 594 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 594 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 594 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 594 "../src/sudoku-cell.vala"
	if (!sudoku_board_is_possible (_tmp16_, self->priv->row, self->priv->col, value)) {
#line 594 "../src/sudoku-cell.vala"
		_tmp13_ = TRUE;
#line 3073 "sudoku-cell.c"
	} else {
		gboolean _tmp17_ = FALSE;
#line 594 "../src/sudoku-cell.vala"
		if (sudoku_cell_warn_incorrect_solution (self)) {
#line 594 "../src/sudoku-cell.vala"
			_tmp17_ = value != solution;
#line 3080 "sudoku-cell.c"
		} else {
#line 594 "../src/sudoku-cell.vala"
			_tmp17_ = FALSE;
#line 3084 "sudoku-cell.c"
		}
#line 594 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp17_;
#line 3088 "sudoku-cell.c"
	}
#line 594 "../src/sudoku-cell.vala"
	if (_tmp13_) {
#line 3092 "sudoku-cell.c"
		GtkLabel** _tmp18_;
		gint _tmp18__length1;
		GtkLabel* _tmp19_;
#line 595 "../src/sudoku-cell.vala"
		_tmp18_ = self->priv->earmark_labels;
#line 595 "../src/sudoku-cell.vala"
		_tmp18__length1 = self->priv->earmark_labels_length1;
#line 595 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_[value - 1];
#line 595 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "error");
#line 3104 "sudoku-cell.c"
	} else {
		GtkLabel** _tmp20_;
		gint _tmp20__length1;
		GtkLabel* _tmp21_;
#line 597 "../src/sudoku-cell.vala"
		_tmp20_ = self->priv->earmark_labels;
#line 597 "../src/sudoku-cell.vala"
		_tmp20__length1 = self->priv->earmark_labels_length1;
#line 597 "../src/sudoku-cell.vala"
		_tmp21_ = _tmp20_[value - 1];
#line 597 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp21_, "error");
#line 3117 "sudoku-cell.c"
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_ = 0;
	gboolean* _tmp4_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 600 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 602 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 602 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 602 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_board_get_earmarks (_tmp2_, self->priv->row, self->priv->col, &_tmp3_);
#line 602 "../src/sudoku-cell.vala"
	marks = _tmp4_;
#line 602 "../src/sudoku-cell.vala"
	marks_length1 = _tmp3_;
#line 602 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 603 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 603 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 603 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 603 "../src/sudoku-cell.vala"
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
#line 603 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 603 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp5_, _tmp9_);
#line 603 "../src/sudoku-cell.vala"
	_g_free0 (_tmp9_);
#line 604 "../src/sudoku-cell.vala"
	gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 3169 "sudoku-cell.c"
	{
		gint num = 0;
#line 605 "../src/sudoku-cell.vala"
		num = 1;
#line 3174 "sudoku-cell.c"
		{
			gboolean _tmp10_ = FALSE;
#line 605 "../src/sudoku-cell.vala"
			_tmp10_ = TRUE;
#line 605 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3181 "sudoku-cell.c"
				gboolean* _tmp12_;
				gint _tmp12__length1;
				GtkLabel** _tmp13_;
				gint _tmp13__length1;
				GtkLabel* _tmp14_;
#line 605 "../src/sudoku-cell.vala"
				if (!_tmp10_) {
#line 3189 "sudoku-cell.c"
					gint _tmp11_;
#line 605 "../src/sudoku-cell.vala"
					_tmp11_ = num;
#line 605 "../src/sudoku-cell.vala"
					num = _tmp11_ + 1;
#line 3195 "sudoku-cell.c"
				}
#line 605 "../src/sudoku-cell.vala"
				_tmp10_ = FALSE;
#line 605 "../src/sudoku-cell.vala"
				_tmp12_ = marks;
#line 605 "../src/sudoku-cell.vala"
				_tmp12__length1 = marks_length1;
#line 605 "../src/sudoku-cell.vala"
				if (!(num <= _tmp12__length1)) {
#line 605 "../src/sudoku-cell.vala"
					break;
#line 3207 "sudoku-cell.c"
				}
#line 606 "../src/sudoku-cell.vala"
				_tmp13_ = self->priv->earmark_labels;
#line 606 "../src/sudoku-cell.vala"
				_tmp13__length1 = self->priv->earmark_labels_length1;
#line 606 "../src/sudoku-cell.vala"
				_tmp14_ = _tmp13_[num - 1];
#line 606 "../src/sudoku-cell.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp14_, "error");
#line 3217 "sudoku-cell.c"
			}
		}
	}
#line 600 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 3223 "sudoku-cell.c"
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 612 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 618 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
#line 618 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 618 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 619 "../src/sudoku-cell.vala"
		_tmp1_ = !self->priv->control_key_pressed;
#line 3244 "sudoku-cell.c"
	} else {
#line 618 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 3248 "sudoku-cell.c"
	}
#line 618 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 3252 "sudoku-cell.c"
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
#line 620 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 620 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 620 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 620 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_solved (_tmp6_);
#line 3264 "sudoku-cell.c"
	} else {
#line 618 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3268 "sudoku-cell.c"
	}
#line 618 "../src/sudoku-cell.vala"
	result = _tmp0_;
#line 618 "../src/sudoku-cell.vala"
	return result;
#line 3274 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 623 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 625 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 627 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 627 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 3290 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 645 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 3298 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	graphene_point_t _tmp4_;
	GskTransform* _tmp5_;
	GtkLabel* _tmp6_;
	GskTransform* _tmp7_;
	GskTransform* _tmp8_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint num = 0;
#line 630 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 634 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 634 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 634 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp1_);
#line 637 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 637 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 639 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 641 "../src/sudoku-cell.vala"
	_tmp2_ = gsk_transform_new ();
#line 641 "../src/sudoku-cell.vala"
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
#line 641 "../src/sudoku-cell.vala"
	_tmp4_ = *graphene_point_init (&_tmp3_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 641 "../src/sudoku-cell.vala"
	_tmp5_ = gsk_transform_translate (_tmp2_, &_tmp4_);
#line 641 "../src/sudoku-cell.vala"
	center = _tmp5_;
#line 645 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->value_label;
#line 645 "../src/sudoku-cell.vala"
	_tmp7_ = center;
#line 645 "../src/sudoku-cell.vala"
	_tmp8_ = _gsk_transform_ref0 (_tmp7_);
#line 645 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp6_, value_width, value_height, baseline, _tmp8_);
#line 648 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 648 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 648 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 648 "../src/sudoku-cell.vala"
	_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
#line 648 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 648 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp13_;
#line 649 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 649 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 649 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 649 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
#line 649 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 649 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp18_;
#line 651 "../src/sudoku-cell.vala"
	num = 0;
#line 3391 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 652 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 3396 "sudoku-cell.c"
		{
			gboolean _tmp19_ = FALSE;
#line 652 "../src/sudoku-cell.vala"
			_tmp19_ = TRUE;
#line 652 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3403 "sudoku-cell.c"
				SudokuGame* _tmp21_;
				SudokuBoard* _tmp22_;
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 652 "../src/sudoku-cell.vala"
				if (!_tmp19_) {
#line 3411 "sudoku-cell.c"
					gint _tmp20_;
#line 652 "../src/sudoku-cell.vala"
					_tmp20_ = row_tmp;
#line 652 "../src/sudoku-cell.vala"
					row_tmp = _tmp20_ + 1;
#line 3417 "sudoku-cell.c"
				}
#line 652 "../src/sudoku-cell.vala"
				_tmp19_ = FALSE;
#line 652 "../src/sudoku-cell.vala"
				_tmp21_ = self->priv->game;
#line 652 "../src/sudoku-cell.vala"
				_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 652 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp22_;
#line 652 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
#line 652 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 652 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp25_)) {
#line 652 "../src/sudoku-cell.vala"
					break;
#line 3435 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 654 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 3441 "sudoku-cell.c"
					{
						gboolean _tmp26_ = FALSE;
#line 654 "../src/sudoku-cell.vala"
						_tmp26_ = TRUE;
#line 654 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 3448 "sudoku-cell.c"
							SudokuGame* _tmp28_;
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp35_;
							graphene_point_t _tmp36_ = {0};
							SudokuGame* _tmp37_;
							SudokuBoard* _tmp38_;
							SudokuBoard* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							graphene_point_t _tmp42_;
							GskTransform* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
							GskTransform* _tmp46_;
							GskTransform* _tmp47_;
#line 654 "../src/sudoku-cell.vala"
							if (!_tmp26_) {
#line 3474 "sudoku-cell.c"
								gint _tmp27_;
#line 654 "../src/sudoku-cell.vala"
								_tmp27_ = col_tmp;
#line 654 "../src/sudoku-cell.vala"
								col_tmp = _tmp27_ + 1;
#line 3480 "sudoku-cell.c"
							}
#line 654 "../src/sudoku-cell.vala"
							_tmp26_ = FALSE;
#line 654 "../src/sudoku-cell.vala"
							_tmp28_ = self->priv->game;
#line 654 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (_tmp28_);
#line 654 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 654 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 654 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 654 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 654 "../src/sudoku-cell.vala"
								break;
#line 3498 "sudoku-cell.c"
							}
#line 656 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 656 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 658 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 658 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 658 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp34_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 660 "../src/sudoku-cell.vala"
							_tmp35_ = gsk_transform_new ();
#line 660 "../src/sudoku-cell.vala"
							memset (&_tmp36_, 0, sizeof (graphene_point_t));
#line 660 "../src/sudoku-cell.vala"
							_tmp37_ = self->priv->game;
#line 660 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 660 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 660 "../src/sudoku-cell.vala"
							_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 660 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_;
#line 660 "../src/sudoku-cell.vala"
							_tmp42_ = *graphene_point_init (&_tmp36_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp41_ - row_tmp) - 1) * earmark_height));
#line 660 "../src/sudoku-cell.vala"
							_tmp43_ = gsk_transform_translate (_tmp35_, &_tmp42_);
#line 660 "../src/sudoku-cell.vala"
							earmark_position = _tmp43_;
#line 665 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 665 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 665 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 665 "../src/sudoku-cell.vala"
							_tmp46_ = earmark_position;
#line 665 "../src/sudoku-cell.vala"
							_tmp47_ = _gsk_transform_ref0 (_tmp46_);
#line 665 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp45_, earmark_width, earmark_height, baseline, _tmp47_);
#line 654 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 3544 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 630 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 3553 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 672 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 3561 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 670 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 672 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 672 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 672 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 673 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 673 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 3590 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 674 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 674 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 674 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 3598 "sudoku-cell.c"
	}
#line 676 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 676 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 676 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 680 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 680 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 670 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 3612 "sudoku-cell.c"
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
#line 683 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 685 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 685 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 3625 "sudoku-cell.c"
		GtkPopover* _tmp1_;
#line 686 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->_popover;
#line 686 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 3631 "sudoku-cell.c"
	}
}

GtkPopover*
sudoku_cell_get_popover (SudokuCell* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 42 "../src/sudoku-cell.vala"
	if (_tmp0_ == NULL) {
#line 3647 "sudoku-cell.c"
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
#line 44 "../src/sudoku-cell.vala"
		_tmp1_ = (GtkPopover*) gtk_popover_new ();
#line 44 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp1_);
#line 44 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->_popover);
#line 44 "../src/sudoku-cell.vala"
		self->priv->_popover = _tmp1_;
#line 45 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->_popover;
#line 45 "../src/sudoku-cell.vala"
		gtk_popover_set_autohide (_tmp2_, FALSE);
#line 3662 "sudoku-cell.c"
	}
#line 47 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->_popover;
#line 47 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 47 "../src/sudoku-cell.vala"
	return result;
#line 3670 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 60 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 60 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 60 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
#line 60 "../src/sudoku-cell.vala"
	return result;
#line 3692 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp2_ = FALSE;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuBoard* _tmp5_;
#line 61 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 3707 "sudoku-cell.c"
		GtkLabel* _tmp0_;
#line 63 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->value_label;
#line 63 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 3713 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp1_;
#line 65 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->value_label;
#line 65 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 3720 "sudoku-cell.c"
	}
#line 67 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 67 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 67 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 67 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp5_, self->priv->row, self->priv->col)) {
#line 67 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 3732 "sudoku-cell.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 68 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_cell_get_is_fixed (self);
#line 68 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 68 "../src/sudoku-cell.vala"
		if (_tmp8_) {
#line 3743 "sudoku-cell.c"
			SudokuGame* _tmp9_;
			GameMode _tmp10_;
			GameMode _tmp11_;
#line 68 "../src/sudoku-cell.vala"
			_tmp9_ = self->priv->game;
#line 68 "../src/sudoku-cell.vala"
			_tmp10_ = sudoku_game_get_mode (_tmp9_);
#line 68 "../src/sudoku-cell.vala"
			_tmp11_ = _tmp10_;
#line 68 "../src/sudoku-cell.vala"
			_tmp6_ = _tmp11_ == GAME_MODE_PLAY;
#line 3755 "sudoku-cell.c"
		} else {
#line 68 "../src/sudoku-cell.vala"
			_tmp6_ = FALSE;
#line 3759 "sudoku-cell.c"
		}
#line 68 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp6_;
#line 3763 "sudoku-cell.c"
	}
#line 67 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 71 "../src/sudoku-cell.vala"
		return;
#line 3769 "sudoku-cell.c"
	}
#line 74 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 3773 "sudoku-cell.c"
		SudokuGame* _tmp12_;
		SudokuBoard* _tmp13_;
		SudokuBoard* _tmp14_;
#line 76 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->game;
#line 76 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 76 "../src/sudoku-cell.vala"
		_tmp14_ = _tmp13_;
#line 76 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp14_, self->priv->row, self->priv->col) != 0) {
#line 3785 "sudoku-cell.c"
			SudokuGame* _tmp15_;
#line 77 "../src/sudoku-cell.vala"
			_tmp15_ = self->priv->game;
#line 77 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp15_, self->priv->row, self->priv->col);
#line 3791 "sudoku-cell.c"
		}
	} else {
		GtkLabel* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		SudokuGame* _tmp19_;
#line 81 "../src/sudoku-cell.vala"
		_tmp16_ = self->priv->value_label;
#line 81 "../src/sudoku-cell.vala"
		_tmp17_ = g_strdup_printf ("%i", value);
#line 81 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 81 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp16_, _tmp18_);
#line 81 "../src/sudoku-cell.vala"
		_g_free0 (_tmp18_);
#line 82 "../src/sudoku-cell.vala"
		_tmp19_ = self->priv->game;
#line 82 "../src/sudoku-cell.vala"
		sudoku_game_insert (_tmp19_, self->priv->row, self->priv->col, value);
#line 3812 "sudoku-cell.c"
	}
#line 61 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 3816 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 89 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 89 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 89 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 89 "../src/sudoku-cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
#line 89 "../src/sudoku-cell.vala"
	return result;
#line 3838 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 94 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 94 "../src/sudoku-cell.vala"
	return result;
#line 3851 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 95 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 98 "../src/sudoku-cell.vala"
	if (value) {
#line 99 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 3866 "sudoku-cell.c"
	} else {
#line 101 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 3870 "sudoku-cell.c"
	}
#line 95 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3874 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 107 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 107 "../src/sudoku-cell.vala"
	return result;
#line 3887 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 108 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 111 "../src/sudoku-cell.vala"
	if (value) {
#line 112 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
#line 3902 "sudoku-cell.c"
	} else {
#line 114 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
#line 3906 "sudoku-cell.c"
	}
#line 108 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3910 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 120 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 120 "../src/sudoku-cell.vala"
	return result;
#line 3923 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 121 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 124 "../src/sudoku-cell.vala"
	if (value) {
#line 124 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 3939 "sudoku-cell.c"
	} else {
#line 124 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3943 "sudoku-cell.c"
	}
#line 124 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 125 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 3949 "sudoku-cell.c"
	} else {
#line 127 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 3953 "sudoku-cell.c"
	}
#line 121 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3957 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
#line 146 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 146 "../src/sudoku-cell.vala"
	result = self->priv->_show_warnings;
#line 146 "../src/sudoku-cell.vala"
	return result;
#line 3970 "sudoku-cell.c"
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
#line 147 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = value;
#line 147 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
#line 3983 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
#line 156 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/sudoku-cell.vala"
	result = self->priv->_show_extra_warnings;
#line 156 "../src/sudoku-cell.vala"
	return result;
#line 3996 "sudoku-cell.c"
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
#line 157 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = value;
#line 160 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 157 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 4011 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_initialize_earmarks (SudokuCell* self)
{
	gboolean result;
#line 171 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/sudoku-cell.vala"
	result = self->priv->_initialize_earmarks;
#line 171 "../src/sudoku-cell.vala"
	return result;
#line 4024 "sudoku-cell.c"
}

void
sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                     gboolean value)
{
#line 172 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/sudoku-cell.vala"
	self->priv->_initialize_earmarks = value;
#line 175 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 172 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY]);
#line 4039 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_POPOVER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_POPOVER_PROPERTY] = g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL] = g_signal_new ("will-open-popover", TYPE_SUDOKU_CELL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 246 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 4082 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel** _tmp4_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 34 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 35 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 36 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 36 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 38 "../src/sudoku-cell.vala"
	self->priv->_popover = NULL;
#line 53 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 53 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 53 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp3_;
#line 56 "../src/sudoku-cell.vala"
	_tmp4_ = g_new0 (GtkLabel*, 8 + 1);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp4_;
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 56 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 92 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 105 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 118 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 143 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = TRUE;
#line 153 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 4136 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 36 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 38 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->_popover);
#line 53 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 4161 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_POPOVER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_object (value, sudoku_cell_get_popover (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_initialize_earmarks (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4250 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4256 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4312 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 4318 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

