/* sudoku-view.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_GAME_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuGame* _game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
	gboolean _has_selection;
};

struct _Block11Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN SudokuView* sudoku_view_new (gint frame_size,
                             SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   gint frame_size,
                                   SudokuGame* game);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void sudoku_view_set_game (SudokuView* self,
                           SudokuGame* value);
VALA_EXTERN SudokuGame* sudoku_view_get_game (SudokuView* self);
static void __lambda10_ (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static void sudoku_view_cell_changed_cb (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint val,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint val,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda11_ (Block12Data* _data12_);
static void _________lambda11__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda12_ (SudokuView* self);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void _________lambda12__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                       gpointer self);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_view_set_value_highlighter (SudokuView* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint val,
                                 gboolean enabled);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_redraw (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean _sudoku_view___lambda13_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint old_row = 0;
	gint _tmp10_;
	gint old_col = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
#line 45 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 47 "../src/sudoku-view.vala"
	if (_tmp1_ == cell_row) {
#line 362 "sudoku-view.c"
		gint _tmp2_;
#line 47 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ == cell_col;
#line 368 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 372 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 48 "../src/sudoku-view.vala"
		return;
#line 378 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 50 "../src/sudoku-view.vala"
	if (_tmp4_ >= 0) {
#line 384 "sudoku-view.c"
		gint _tmp5_;
#line 50 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_ >= 0;
#line 390 "sudoku-view.c"
	} else {
#line 50 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 394 "sudoku-view.c"
	}
#line 50 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 398 "sudoku-view.c"
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint _tmp8_;
		SudokuCell* _tmp9_;
#line 51 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 51 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 51 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->_selected_row;
#line 51 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->_selected_col;
#line 51 "../src/sudoku-view.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 51 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp9_, FALSE);
#line 419 "sudoku-view.c"
	}
#line 53 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->_selected_row;
#line 53 "../src/sudoku-view.vala"
	old_row = _tmp10_;
#line 54 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->_selected_col;
#line 54 "../src/sudoku-view.vala"
	old_col = _tmp11_;
#line 56 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 57 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 59 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 59 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 59 "../src/sudoku-view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp12_, _tmp13_);
#line 61 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->_selected_row;
#line 61 "../src/sudoku-view.vala"
	if (_tmp15_ >= 0) {
#line 443 "sudoku-view.c"
		gint _tmp16_;
#line 61 "../src/sudoku-view.vala"
		_tmp16_ = self->priv->_selected_col;
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = _tmp16_ >= 0;
#line 449 "sudoku-view.c"
	} else {
#line 61 "../src/sudoku-view.vala"
		_tmp14_ = FALSE;
#line 453 "sudoku-view.c"
	}
#line 61 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 457 "sudoku-view.c"
		SudokuCell** _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
		gint _tmp19_;
		SudokuCell* _tmp20_;
#line 62 "../src/sudoku-view.vala"
		_tmp17_ = self->priv->cells;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length1 = self->priv->cells_length1;
#line 62 "../src/sudoku-view.vala"
		_tmp17__length2 = self->priv->cells_length2;
#line 62 "../src/sudoku-view.vala"
		_tmp18_ = self->priv->_selected_row;
#line 62 "../src/sudoku-view.vala"
		_tmp19_ = self->priv->_selected_col;
#line 62 "../src/sudoku-view.vala"
		_tmp20_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 62 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp20_, TRUE);
#line 478 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 65 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 487 "sudoku-view.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 65 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 65 "../src/sudoku-view.vala"
	return _data11_;
#line 497 "sudoku-view.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 65 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 507 "sudoku-view.c"
		SudokuView* self;
#line 65 "../src/sudoku-view.vala"
		self = _data11_->self;
#line 65 "../src/sudoku-view.vala"
		_g_object_unref0 (_data11_->game);
#line 65 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 65 "../src/sudoku-view.vala"
		g_slice_free (Block11Data, _data11_);
#line 517 "sudoku-view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 85 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 526 "sudoku-view.c"
}

static void
__lambda10_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuGame* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	SudokuGame* _tmp14_;
	SudokuGame* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	SudokuGame* _tmp18_;
	SudokuGame* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
#line 85 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused;
#line 85 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 85 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 85 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 86 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 86 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 566 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 87 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 87 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 87 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 574 "sudoku-view.c"
	}
#line 89 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 89 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 89 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 93 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused;
#line 93 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 93 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 94 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused;
#line 94 "../src/sudoku-view.vala"
	_tmp10_ = sudoku_view_get_game (self);
#line 94 "../src/sudoku-view.vala"
	_tmp11_ = _tmp10_;
#line 94 "../src/sudoku-view.vala"
	_tmp12_ = sudoku_game_get_paused (_tmp11_);
#line 94 "../src/sudoku-view.vala"
	_tmp13_ = _tmp12_;
#line 94 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp13_);
#line 96 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_game (self);
#line 96 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 96 "../src/sudoku-view.vala"
	_tmp16_ = sudoku_game_get_paused (_tmp15_);
#line 96 "../src/sudoku-view.vala"
	_tmp17_ = _tmp16_;
#line 96 "../src/sudoku-view.vala"
	if (_tmp17_) {
#line 97 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 612 "sudoku-view.c"
	} else {
#line 99 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 616 "sudoku-view.c"
	}
#line 101 "../src/sudoku-view.vala"
	_tmp18_ = sudoku_view_get_game (self);
#line 101 "../src/sudoku-view.vala"
	_tmp19_ = _tmp18_;
#line 101 "../src/sudoku-view.vala"
	_tmp20_ = sudoku_game_get_paused (_tmp19_);
#line 101 "../src/sudoku-view.vala"
	_tmp21_ = _tmp20_;
#line 101 "../src/sudoku-view.vala"
	sudoku_view_set_has_selection (self, !_tmp21_);
#line 83 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 630 "sudoku-view.c"
}

static void
___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 83 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuView*) self);
#line 639 "sudoku-view.c"
}

static void
_sudoku_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                       gint row,
                                                       gint col,
                                                       gint old_val,
                                                       gint new_val,
                                                       gpointer self)
{
#line 104 "../src/sudoku-view.vala"
	sudoku_view_cell_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 652 "sudoku-view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint val,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 105 "../src/sudoku-view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, val, enabled);
#line 665 "sudoku-view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 106 "../src/sudoku-view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 678 "sudoku-view.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 138 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 138 "../src/sudoku-view.vala"
	return _data12_;
#line 688 "sudoku-view.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 138 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 698 "sudoku-view.c"
		SudokuView* self;
#line 138 "../src/sudoku-view.vala"
		self = _data12_->_data11_->self;
#line 138 "../src/sudoku-view.vala"
		_g_object_unref0 (_data12_->cell);
#line 138 "../src/sudoku-view.vala"
		block11_data_unref (_data12_->_data11_);
#line 138 "../src/sudoku-view.vala"
		_data12_->_data11_ = NULL;
#line 138 "../src/sudoku-view.vala"
		g_slice_free (Block12Data, _data12_);
#line 710 "sudoku-view.c"
	}
}

static void
________lambda11_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 144 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 144 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 145 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data11_->game);
#line 145 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 146 "../src/sudoku-view.vala"
		return;
#line 736 "sudoku-view.c"
	}
#line 148 "../src/sudoku-view.vala"
	_tmp2_ = _data12_->cell;
#line 148 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 148 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 148 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 149 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, _data12_->cell_row, _data12_->cell_col);
#line 748 "sudoku-view.c"
	}
}

static void
_________lambda11__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 144 "../src/sudoku-view.vala"
	________lambda11_ (self);
#line 759 "sudoku-view.c"
}

static void
________lambda12_ (SudokuView* self)
{
#line 153 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (self);
#line 767 "sudoku-view.c"
}

static void
_________lambda12__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                  gpointer self)
{
#line 152 "../src/sudoku-view.vala"
	________lambda12_ ((SudokuView*) self);
#line 776 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       gint frame_size,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block11Data* _data11_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp2_;
	SudokuFrame* _tmp3_;
	SudokuFrame* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* _tmp7_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	SudokuGame* _tmp11_;
	SudokuGame* _tmp12_;
	SudokuGame* _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp19_;
	SudokuBoard* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	SudokuBoard* _tmp23_;
	SudokuBoard* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GtkGrid** _tmp27_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp51_;
	SudokuBoard* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	SudokuBoard* _tmp55_;
	SudokuBoard* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	SudokuCell** _tmp59_;
	GtkOverlay* _tmp97_;
	GtkLabel* _tmp98_;
	GtkOverlay* _tmp99_;
	GtkGrid* _tmp100_;
	GtkGrid* _tmp101_;
	GtkOverlay* _tmp102_;
	GtkLabel* _tmp103_;
#line 65 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 65 "../src/sudoku-view.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 65 "../src/sudoku-view.vala"
	_data11_->_ref_count_ = 1;
#line 65 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (_data11_->game);
#line 65 "../src/sudoku-view.vala"
	_data11_->game = _tmp0_;
#line 65 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 65 "../src/sudoku-view.vala"
	_data11_->self = g_object_ref (self);
#line 67 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 69 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 70 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 72 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 72 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 72 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 72 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 73 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 73 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_frame_new ((GtkWidget*) _tmp2_);
#line 73 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 73 "../src/sudoku-view.vala"
	frame = _tmp3_;
#line 74 "../src/sudoku-view.vala"
	_tmp4_ = frame;
#line 74 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
#line 76 "../src/sudoku-view.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("Paused");
#line 76 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 76 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 76 "../src/sudoku-view.vala"
	self->priv->paused = _tmp5_;
#line 77 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->paused;
#line 77 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "paused");
#line 79 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->grid;
#line 79 "../src/sudoku-view.vala"
	if (_tmp7_ != NULL) {
#line 891 "sudoku-view.c"
		GtkOverlay* _tmp8_;
#line 80 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->overlay;
#line 80 "../src/sudoku-view.vala"
		gtk_overlay_set_child (_tmp8_, NULL);
#line 897 "sudoku-view.c"
	}
#line 82 "../src/sudoku-view.vala"
	sudoku_view_set_game (self, _data11_->game);
#line 83 "../src/sudoku-view.vala"
	_tmp9_ = sudoku_view_get_game (self);
#line 83 "../src/sudoku-view.vala"
	_tmp10_ = _tmp9_;
#line 83 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp10_, "paused-changed", (GCallback) ___lambda10__sudoku_game_paused_changed, self, 0);
#line 104 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_view_get_game (self);
#line 104 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 104 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp12_, "cell-changed", (GCallback) _sudoku_view_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 105 "../src/sudoku-view.vala"
	_tmp13_ = sudoku_view_get_game (self);
#line 105 "../src/sudoku-view.vala"
	_tmp14_ = _tmp13_;
#line 105 "../src/sudoku-view.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 105 "../src/sudoku-view.vala"
	_tmp16_ = _tmp15_;
#line 105 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp16_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 106 "../src/sudoku-view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 108 "../src/sudoku-view.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 108 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp17_, 2);
#line 108 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp17_, 2);
#line 108 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp17_, TRUE);
#line 108 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp17_, TRUE);
#line 108 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp17_, TRUE);
#line 108 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
#line 108 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp17_);
#line 108 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 108 "../src/sudoku-view.vala"
	self->priv->grid = _tmp17_;
#line 116 "../src/sudoku-view.vala"
	_tmp18_ = self->priv->grid;
#line 116 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp18_, "board");
#line 118 "../src/sudoku-view.vala"
	_tmp19_ = sudoku_game_get_board (_data11_->game);
#line 118 "../src/sudoku-view.vala"
	_tmp20_ = _tmp19_;
#line 118 "../src/sudoku-view.vala"
	_tmp21_ = sudoku_board_get_block_rows (_tmp20_);
#line 118 "../src/sudoku-view.vala"
	_tmp22_ = _tmp21_;
#line 118 "../src/sudoku-view.vala"
	_tmp23_ = sudoku_game_get_board (_data11_->game);
#line 118 "../src/sudoku-view.vala"
	_tmp24_ = _tmp23_;
#line 118 "../src/sudoku-view.vala"
	_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
#line 118 "../src/sudoku-view.vala"
	_tmp26_ = _tmp25_;
#line 118 "../src/sudoku-view.vala"
	_tmp27_ = g_new0 (GtkGrid*, (_tmp22_ * _tmp26_) + 1);
#line 118 "../src/sudoku-view.vala"
	blocks = _tmp27_;
#line 118 "../src/sudoku-view.vala"
	blocks_length1 = _tmp22_;
#line 118 "../src/sudoku-view.vala"
	blocks_length2 = _tmp26_;
#line 973 "sudoku-view.c"
	{
		gint block_row = 0;
#line 119 "../src/sudoku-view.vala"
		block_row = 0;
#line 978 "sudoku-view.c"
		{
			gboolean _tmp28_ = FALSE;
#line 119 "../src/sudoku-view.vala"
			_tmp28_ = TRUE;
#line 119 "../src/sudoku-view.vala"
			while (TRUE) {
#line 985 "sudoku-view.c"
				SudokuBoard* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 119 "../src/sudoku-view.vala"
				if (!_tmp28_) {
#line 992 "sudoku-view.c"
					gint _tmp29_;
#line 119 "../src/sudoku-view.vala"
					_tmp29_ = block_row;
#line 119 "../src/sudoku-view.vala"
					block_row = _tmp29_ + 1;
#line 998 "sudoku-view.c"
				}
#line 119 "../src/sudoku-view.vala"
				_tmp28_ = FALSE;
#line 119 "../src/sudoku-view.vala"
				_tmp30_ = sudoku_game_get_board (_data11_->game);
#line 119 "../src/sudoku-view.vala"
				_tmp31_ = _tmp30_;
#line 119 "../src/sudoku-view.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 119 "../src/sudoku-view.vala"
				_tmp33_ = _tmp32_;
#line 119 "../src/sudoku-view.vala"
				if (!(block_row < _tmp33_)) {
#line 119 "../src/sudoku-view.vala"
					break;
#line 1014 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 121 "../src/sudoku-view.vala"
					block_col = 0;
#line 1020 "sudoku-view.c"
					{
						gboolean _tmp34_ = FALSE;
#line 121 "../src/sudoku-view.vala"
						_tmp34_ = TRUE;
#line 121 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1027 "sudoku-view.c"
							SudokuBoard* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
							GtkGrid* _tmp47_;
							GtkGrid** _tmp48_;
							gint _tmp48__length1;
							gint _tmp48__length2;
							GtkGrid* _tmp49_;
							GtkGrid* _tmp50_;
#line 121 "../src/sudoku-view.vala"
							if (!_tmp34_) {
#line 1048 "sudoku-view.c"
								gint _tmp35_;
#line 121 "../src/sudoku-view.vala"
								_tmp35_ = block_col;
#line 121 "../src/sudoku-view.vala"
								block_col = _tmp35_ + 1;
#line 1054 "sudoku-view.c"
							}
#line 121 "../src/sudoku-view.vala"
							_tmp34_ = FALSE;
#line 121 "../src/sudoku-view.vala"
							_tmp36_ = sudoku_game_get_board (_data11_->game);
#line 121 "../src/sudoku-view.vala"
							_tmp37_ = _tmp36_;
#line 121 "../src/sudoku-view.vala"
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
#line 121 "../src/sudoku-view.vala"
							_tmp39_ = _tmp38_;
#line 121 "../src/sudoku-view.vala"
							if (!(block_col < _tmp39_)) {
#line 121 "../src/sudoku-view.vala"
								break;
#line 1070 "sudoku-view.c"
							}
#line 123 "../src/sudoku-view.vala"
							_tmp40_ = (GtkGrid*) gtk_grid_new ();
#line 123 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp40_);
#line 123 "../src/sudoku-view.vala"
							block_grid = _tmp40_;
#line 124 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 124 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp41_, 1);
#line 125 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 125 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp42_, 1);
#line 126 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 126 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp43_, TRUE);
#line 127 "../src/sudoku-view.vala"
							_tmp44_ = block_grid;
#line 127 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp44_, TRUE);
#line 128 "../src/sudoku-view.vala"
							_tmp45_ = block_grid;
#line 128 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "block");
#line 129 "../src/sudoku-view.vala"
							_tmp46_ = self->priv->grid;
#line 129 "../src/sudoku-view.vala"
							_tmp47_ = block_grid;
#line 129 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, block_col, block_row, 1, 1);
#line 131 "../src/sudoku-view.vala"
							_tmp48_ = blocks;
#line 131 "../src/sudoku-view.vala"
							_tmp48__length1 = blocks_length1;
#line 131 "../src/sudoku-view.vala"
							_tmp48__length2 = blocks_length2;
#line 131 "../src/sudoku-view.vala"
							_tmp49_ = block_grid;
#line 131 "../src/sudoku-view.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 131 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp48_[(block_row * _tmp48__length2) + block_col]);
#line 131 "../src/sudoku-view.vala"
							_tmp48_[(block_row * _tmp48__length2) + block_col] = _tmp50_;
#line 121 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 1120 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 135 "../src/sudoku-view.vala"
	_tmp51_ = sudoku_game_get_board (_data11_->game);
#line 135 "../src/sudoku-view.vala"
	_tmp52_ = _tmp51_;
#line 135 "../src/sudoku-view.vala"
	_tmp53_ = sudoku_board_get_rows (_tmp52_);
#line 135 "../src/sudoku-view.vala"
	_tmp54_ = _tmp53_;
#line 135 "../src/sudoku-view.vala"
	_tmp55_ = sudoku_game_get_board (_data11_->game);
#line 135 "../src/sudoku-view.vala"
	_tmp56_ = _tmp55_;
#line 135 "../src/sudoku-view.vala"
	_tmp57_ = sudoku_board_get_cols (_tmp56_);
#line 135 "../src/sudoku-view.vala"
	_tmp58_ = _tmp57_;
#line 135 "../src/sudoku-view.vala"
	_tmp59_ = g_new0 (SudokuCell*, (_tmp54_ * _tmp58_) + 1);
#line 135 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 135 "../src/sudoku-view.vala"
	self->priv->cells = _tmp59_;
#line 135 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp54_;
#line 135 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp58_;
#line 1153 "sudoku-view.c"
	{
		gint row = 0;
#line 136 "../src/sudoku-view.vala"
		row = 0;
#line 1158 "sudoku-view.c"
		{
			gboolean _tmp60_ = FALSE;
#line 136 "../src/sudoku-view.vala"
			_tmp60_ = TRUE;
#line 136 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1165 "sudoku-view.c"
				SudokuBoard* _tmp62_;
				SudokuBoard* _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
#line 136 "../src/sudoku-view.vala"
				if (!_tmp60_) {
#line 1172 "sudoku-view.c"
					gint _tmp61_;
#line 136 "../src/sudoku-view.vala"
					_tmp61_ = row;
#line 136 "../src/sudoku-view.vala"
					row = _tmp61_ + 1;
#line 1178 "sudoku-view.c"
				}
#line 136 "../src/sudoku-view.vala"
				_tmp60_ = FALSE;
#line 136 "../src/sudoku-view.vala"
				_tmp62_ = sudoku_game_get_board (_data11_->game);
#line 136 "../src/sudoku-view.vala"
				_tmp63_ = _tmp62_;
#line 136 "../src/sudoku-view.vala"
				_tmp64_ = sudoku_board_get_rows (_tmp63_);
#line 136 "../src/sudoku-view.vala"
				_tmp65_ = _tmp64_;
#line 136 "../src/sudoku-view.vala"
				if (!(row < _tmp65_)) {
#line 136 "../src/sudoku-view.vala"
					break;
#line 1194 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 138 "../src/sudoku-view.vala"
					col = 0;
#line 1200 "sudoku-view.c"
					{
						gboolean _tmp66_ = FALSE;
#line 138 "../src/sudoku-view.vala"
						_tmp66_ = TRUE;
#line 138 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1207 "sudoku-view.c"
							Block12Data* _data12_;
							SudokuBoard* _tmp68_;
							SudokuBoard* _tmp69_;
							gint _tmp70_;
							gint _tmp71_;
							SudokuCell* _tmp72_;
							SudokuCell* _tmp73_;
							SudokuCell* _tmp74_;
							SudokuCell** _tmp75_;
							gint _tmp75__length1;
							gint _tmp75__length2;
							SudokuCell* _tmp76_;
							SudokuCell* _tmp77_;
							GtkGrid** _tmp78_;
							gint _tmp78__length1;
							gint _tmp78__length2;
							SudokuBoard* _tmp79_;
							SudokuBoard* _tmp80_;
							gint _tmp81_;
							gint _tmp82_;
							SudokuBoard* _tmp83_;
							SudokuBoard* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							GtkGrid* _tmp87_;
							SudokuCell* _tmp88_;
							SudokuBoard* _tmp89_;
							SudokuBoard* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							SudokuBoard* _tmp93_;
							SudokuBoard* _tmp94_;
							gint _tmp95_;
							gint _tmp96_;
#line 138 "../src/sudoku-view.vala"
							_data12_ = g_slice_new0 (Block12Data);
#line 138 "../src/sudoku-view.vala"
							_data12_->_ref_count_ = 1;
#line 138 "../src/sudoku-view.vala"
							_data12_->_data11_ = block11_data_ref (_data11_);
#line 138 "../src/sudoku-view.vala"
							if (!_tmp66_) {
#line 1250 "sudoku-view.c"
								gint _tmp67_;
#line 138 "../src/sudoku-view.vala"
								_tmp67_ = col;
#line 138 "../src/sudoku-view.vala"
								col = _tmp67_ + 1;
#line 1256 "sudoku-view.c"
							}
#line 138 "../src/sudoku-view.vala"
							_tmp66_ = FALSE;
#line 138 "../src/sudoku-view.vala"
							_tmp68_ = sudoku_game_get_board (_data11_->game);
#line 138 "../src/sudoku-view.vala"
							_tmp69_ = _tmp68_;
#line 138 "../src/sudoku-view.vala"
							_tmp70_ = sudoku_board_get_cols (_tmp69_);
#line 138 "../src/sudoku-view.vala"
							_tmp71_ = _tmp70_;
#line 138 "../src/sudoku-view.vala"
							if (!(col < _tmp71_)) {
#line 138 "../src/sudoku-view.vala"
								block12_data_unref (_data12_);
#line 138 "../src/sudoku-view.vala"
								_data12_ = NULL;
#line 138 "../src/sudoku-view.vala"
								break;
#line 1276 "sudoku-view.c"
							}
#line 140 "../src/sudoku-view.vala"
							_tmp72_ = sudoku_cell_new (row, col, &self->priv->_game);
#line 140 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp72_);
#line 140 "../src/sudoku-view.vala"
							_data12_->cell = _tmp72_;
#line 141 "../src/sudoku-view.vala"
							_data12_->cell_row = row;
#line 142 "../src/sudoku-view.vala"
							_data12_->cell_col = col;
#line 144 "../src/sudoku-view.vala"
							_tmp73_ = _data12_->cell;
#line 144 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp73_, "notify::has-focus", (GCallback) _________lambda11__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 152 "../src/sudoku-view.vala"
							_tmp74_ = _data12_->cell;
#line 152 "../src/sudoku-view.vala"
							g_signal_connect_object (_tmp74_, "will-open-popover", (GCallback) _________lambda12__sudoku_cell_will_open_popover, self, 0);
#line 156 "../src/sudoku-view.vala"
							_tmp75_ = self->priv->cells;
#line 156 "../src/sudoku-view.vala"
							_tmp75__length1 = self->priv->cells_length1;
#line 156 "../src/sudoku-view.vala"
							_tmp75__length2 = self->priv->cells_length2;
#line 156 "../src/sudoku-view.vala"
							_tmp76_ = _data12_->cell;
#line 156 "../src/sudoku-view.vala"
							_tmp77_ = _g_object_ref0 (_tmp76_);
#line 156 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp75_[(row * _tmp75__length2) + col]);
#line 156 "../src/sudoku-view.vala"
							_tmp75_[(row * _tmp75__length2) + col] = _tmp77_;
#line 158 "../src/sudoku-view.vala"
							_tmp78_ = blocks;
#line 158 "../src/sudoku-view.vala"
							_tmp78__length1 = blocks_length1;
#line 158 "../src/sudoku-view.vala"
							_tmp78__length2 = blocks_length2;
#line 158 "../src/sudoku-view.vala"
							_tmp79_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp80_ = _tmp79_;
#line 158 "../src/sudoku-view.vala"
							_tmp81_ = sudoku_board_get_block_rows (_tmp80_);
#line 158 "../src/sudoku-view.vala"
							_tmp82_ = _tmp81_;
#line 158 "../src/sudoku-view.vala"
							_tmp83_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp84_ = _tmp83_;
#line 158 "../src/sudoku-view.vala"
							_tmp85_ = sudoku_board_get_block_cols (_tmp84_);
#line 158 "../src/sudoku-view.vala"
							_tmp86_ = _tmp85_;
#line 158 "../src/sudoku-view.vala"
							_tmp87_ = _tmp78_[((row / _tmp82_) * _tmp78__length2) + (col / _tmp86_)];
#line 158 "../src/sudoku-view.vala"
							_tmp88_ = _data12_->cell;
#line 158 "../src/sudoku-view.vala"
							_tmp89_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp90_ = _tmp89_;
#line 158 "../src/sudoku-view.vala"
							_tmp91_ = sudoku_board_get_block_cols (_tmp90_);
#line 158 "../src/sudoku-view.vala"
							_tmp92_ = _tmp91_;
#line 158 "../src/sudoku-view.vala"
							_tmp93_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp94_ = _tmp93_;
#line 158 "../src/sudoku-view.vala"
							_tmp95_ = sudoku_board_get_block_rows (_tmp94_);
#line 158 "../src/sudoku-view.vala"
							_tmp96_ = _tmp95_;
#line 158 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp88_, col % _tmp92_, row % _tmp96_, 1, 1);
#line 138 "../src/sudoku-view.vala"
							block12_data_unref (_data12_);
#line 138 "../src/sudoku-view.vala"
							_data12_ = NULL;
#line 1358 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 162 "../src/sudoku-view.vala"
	_tmp97_ = self->priv->overlay;
#line 162 "../src/sudoku-view.vala"
	_tmp98_ = self->priv->paused;
#line 162 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp97_, (GtkWidget*) _tmp98_);
#line 163 "../src/sudoku-view.vala"
	_tmp99_ = self->priv->overlay;
#line 163 "../src/sudoku-view.vala"
	_tmp100_ = self->priv->grid;
#line 163 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp99_, (GtkWidget*) _tmp100_);
#line 164 "../src/sudoku-view.vala"
	_tmp101_ = self->priv->grid;
#line 164 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp101_);
#line 165 "../src/sudoku-view.vala"
	_tmp102_ = self->priv->overlay;
#line 165 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp102_);
#line 166 "../src/sudoku-view.vala"
	_tmp103_ = self->priv->paused;
#line 166 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp103_, FALSE);
#line 65 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 65 "../src/sudoku-view.vala"
	_g_object_unref0 (frame);
#line 65 "../src/sudoku-view.vala"
	block11_data_unref (_data11_);
#line 65 "../src/sudoku-view.vala"
	_data11_ = NULL;
#line 65 "../src/sudoku-view.vala"
	return self;
#line 1399 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (gint frame_size,
                 SudokuGame* game)
{
#line 65 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, frame_size, game);
#line 1408 "sudoku-view.c"
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 237 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 239 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 240 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 241 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 241 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 241 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 241 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(old_row * _tmp0__length2) + old_col];
#line 241 "../src/sudoku-view.vala"
	sudoku_cell_dismiss_popover (_tmp1_);
#line 1438 "sudoku-view.c"
}

static void
sudoku_view_cell_changed_cb (SudokuView* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 244 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 246 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 246 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 246 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 246 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 246 "../src/sudoku-view.vala"
	sudoku_cell_update_value (_tmp1_);
#line 248 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, old_val, FALSE);
#line 249 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, new_val, TRUE);
#line 250 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 1470 "sudoku-view.c"
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint val,
                                gboolean enabled)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 253 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 255 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 255 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 255 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 255 "../src/sudoku-view.vala"
	sudoku_cell_update_earmark (_tmp1_, val, enabled);
#line 1496 "sudoku-view.c"
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 258 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 260 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 260 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 261 "../src/sudoku-view.vala"
		return;
#line 1523 "sudoku-view.c"
	}
#line 263 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->cells;
#line 263 "../src/sudoku-view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 263 "../src/sudoku-view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 263 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 263 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 263 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 1537 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 265 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1542 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 265 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 265 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1549 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuGame* _tmp8_;
				SudokuBoard* _tmp9_;
				SudokuBoard* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 265 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1558 "sudoku-view.c"
					gint _tmp6_;
#line 265 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 265 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1564 "sudoku-view.c"
				}
#line 265 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 265 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_view_get_game (self);
#line 265 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 265 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 265 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 265 "../src/sudoku-view.vala"
				_tmp11_ = sudoku_board_get_cols (_tmp10_);
#line 265 "../src/sudoku-view.vala"
				_tmp12_ = _tmp11_;
#line 265 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp12_)) {
#line 265 "../src/sudoku-view.vala"
					break;
#line 1584 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 267 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1590 "sudoku-view.c"
					{
						gboolean _tmp13_ = FALSE;
#line 267 "../src/sudoku-view.vala"
						_tmp13_ = TRUE;
#line 267 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1597 "sudoku-view.c"
							SudokuGame* _tmp15_;
							SudokuGame* _tmp16_;
							SudokuBoard* _tmp17_;
							SudokuBoard* _tmp18_;
							gint _tmp19_;
							gint _tmp20_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							SudokuCell* _tmp24_;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							gboolean _tmp43_ = FALSE;
							SudokuCell* _tmp44_;
							gboolean _tmp45_;
							gboolean _tmp46_;
#line 267 "../src/sudoku-view.vala"
							if (!_tmp13_) {
#line 1621 "sudoku-view.c"
								gint _tmp14_;
#line 267 "../src/sudoku-view.vala"
								_tmp14_ = row_tmp;
#line 267 "../src/sudoku-view.vala"
								row_tmp = _tmp14_ + 1;
#line 1627 "sudoku-view.c"
							}
#line 267 "../src/sudoku-view.vala"
							_tmp13_ = FALSE;
#line 267 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_view_get_game (self);
#line 267 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 267 "../src/sudoku-view.vala"
							_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 267 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_;
#line 267 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_board_get_rows (_tmp18_);
#line 267 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 267 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp20_)) {
#line 267 "../src/sudoku-view.vala"
								break;
#line 1647 "sudoku-view.c"
							}
#line 269 "../src/sudoku-view.vala"
							_tmp21_ = self->priv->cells;
#line 269 "../src/sudoku-view.vala"
							_tmp21__length1 = self->priv->cells_length1;
#line 269 "../src/sudoku-view.vala"
							_tmp21__length2 = self->priv->cells_length2;
#line 269 "../src/sudoku-view.vala"
							_tmp22_ = _tmp21_[(row_tmp * _tmp21__length2) + col_tmp];
#line 269 "../src/sudoku-view.vala"
							_tmp23_ = _g_object_ref0 (_tmp22_);
#line 269 "../src/sudoku-view.vala"
							cell_tmp = _tmp23_;
#line 271 "../src/sudoku-view.vala"
							_tmp24_ = cell;
#line 271 "../src/sudoku-view.vala"
							_tmp25_ = cell_tmp;
#line 271 "../src/sudoku-view.vala"
							if (_tmp24_ == _tmp25_) {
#line 272 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 272 "../src/sudoku-view.vala"
								continue;
#line 1671 "sudoku-view.c"
							}
#line 274 "../src/sudoku-view.vala"
							_tmp26_ = cell;
#line 274 "../src/sudoku-view.vala"
							_tmp27_ = sudoku_cell_get_value (_tmp26_);
#line 274 "../src/sudoku-view.vala"
							_tmp28_ = _tmp27_;
#line 274 "../src/sudoku-view.vala"
							if (_tmp28_ > 0) {
#line 1681 "sudoku-view.c"
								SudokuCell* _tmp29_;
								gint _tmp30_;
								gint _tmp31_;
								SudokuCell* _tmp32_;
								gint _tmp33_;
								gint _tmp34_;
#line 276 "../src/sudoku-view.vala"
								_tmp29_ = cell;
#line 276 "../src/sudoku-view.vala"
								_tmp30_ = sudoku_cell_get_value (_tmp29_);
#line 276 "../src/sudoku-view.vala"
								_tmp31_ = _tmp30_;
#line 276 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 276 "../src/sudoku-view.vala"
								_tmp33_ = sudoku_cell_get_value (_tmp32_);
#line 276 "../src/sudoku-view.vala"
								_tmp34_ = _tmp33_;
#line 276 "../src/sudoku-view.vala"
								if (_tmp31_ == _tmp34_) {
#line 1702 "sudoku-view.c"
									SudokuCell* _tmp35_;
#line 277 "../src/sudoku-view.vala"
									_tmp35_ = cell_tmp;
#line 277 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp35_, enabled);
#line 1708 "sudoku-view.c"
								} else {
									SudokuCell* _tmp36_;
									gint _tmp37_;
									gint _tmp38_;
#line 278 "../src/sudoku-view.vala"
									_tmp36_ = cell_tmp;
#line 278 "../src/sudoku-view.vala"
									_tmp37_ = sudoku_cell_get_value (_tmp36_);
#line 278 "../src/sudoku-view.vala"
									_tmp38_ = _tmp37_;
#line 278 "../src/sudoku-view.vala"
									if (_tmp38_ == 0) {
#line 1721 "sudoku-view.c"
										SudokuCell* _tmp39_;
										SudokuCell* _tmp40_;
										gint _tmp41_;
										gint _tmp42_;
#line 279 "../src/sudoku-view.vala"
										_tmp39_ = cell_tmp;
#line 279 "../src/sudoku-view.vala"
										_tmp40_ = cell;
#line 279 "../src/sudoku-view.vala"
										_tmp41_ = sudoku_cell_get_value (_tmp40_);
#line 279 "../src/sudoku-view.vala"
										_tmp42_ = _tmp41_;
#line 279 "../src/sudoku-view.vala"
										sudoku_cell_set_earmark_highlight (_tmp39_, _tmp42_, enabled);
#line 1736 "sudoku-view.c"
									}
								}
							}
#line 282 "../src/sudoku-view.vala"
							_tmp44_ = cell_tmp;
#line 282 "../src/sudoku-view.vala"
							_tmp45_ = sudoku_cell_get_is_fixed (_tmp44_);
#line 282 "../src/sudoku-view.vala"
							_tmp46_ = _tmp45_;
#line 282 "../src/sudoku-view.vala"
							if (!_tmp46_) {
#line 1748 "sudoku-view.c"
								gboolean _tmp47_ = FALSE;
								gboolean _tmp48_ = FALSE;
#line 283 "../src/sudoku-view.vala"
								if (row_tmp == row) {
#line 283 "../src/sudoku-view.vala"
									_tmp48_ = TRUE;
#line 1755 "sudoku-view.c"
								} else {
#line 283 "../src/sudoku-view.vala"
									_tmp48_ = col_tmp == col;
#line 1759 "sudoku-view.c"
								}
#line 283 "../src/sudoku-view.vala"
								if (_tmp48_) {
#line 283 "../src/sudoku-view.vala"
									_tmp47_ = TRUE;
#line 1765 "sudoku-view.c"
								} else {
									gboolean _tmp49_ = FALSE;
									SudokuGame* _tmp50_;
									SudokuGame* _tmp51_;
									SudokuBoard* _tmp52_;
									SudokuBoard* _tmp53_;
									gint _tmp54_;
									gint _tmp55_;
									SudokuGame* _tmp56_;
									SudokuGame* _tmp57_;
									SudokuBoard* _tmp58_;
									SudokuBoard* _tmp59_;
									gint _tmp60_;
									gint _tmp61_;
#line 284 "../src/sudoku-view.vala"
									_tmp50_ = sudoku_view_get_game (self);
#line 284 "../src/sudoku-view.vala"
									_tmp51_ = _tmp50_;
#line 284 "../src/sudoku-view.vala"
									_tmp52_ = sudoku_game_get_board (_tmp51_);
#line 284 "../src/sudoku-view.vala"
									_tmp53_ = _tmp52_;
#line 284 "../src/sudoku-view.vala"
									_tmp54_ = sudoku_board_get_block_cols (_tmp53_);
#line 284 "../src/sudoku-view.vala"
									_tmp55_ = _tmp54_;
#line 284 "../src/sudoku-view.vala"
									_tmp56_ = sudoku_view_get_game (self);
#line 284 "../src/sudoku-view.vala"
									_tmp57_ = _tmp56_;
#line 284 "../src/sudoku-view.vala"
									_tmp58_ = sudoku_game_get_board (_tmp57_);
#line 284 "../src/sudoku-view.vala"
									_tmp59_ = _tmp58_;
#line 284 "../src/sudoku-view.vala"
									_tmp60_ = sudoku_board_get_block_cols (_tmp59_);
#line 284 "../src/sudoku-view.vala"
									_tmp61_ = _tmp60_;
#line 284 "../src/sudoku-view.vala"
									if ((row_tmp / _tmp55_) == (row / _tmp61_)) {
#line 1806 "sudoku-view.c"
										SudokuGame* _tmp62_;
										SudokuGame* _tmp63_;
										SudokuBoard* _tmp64_;
										SudokuBoard* _tmp65_;
										gint _tmp66_;
										gint _tmp67_;
										SudokuGame* _tmp68_;
										SudokuGame* _tmp69_;
										SudokuBoard* _tmp70_;
										SudokuBoard* _tmp71_;
										gint _tmp72_;
										gint _tmp73_;
#line 285 "../src/sudoku-view.vala"
										_tmp62_ = sudoku_view_get_game (self);
#line 285 "../src/sudoku-view.vala"
										_tmp63_ = _tmp62_;
#line 285 "../src/sudoku-view.vala"
										_tmp64_ = sudoku_game_get_board (_tmp63_);
#line 285 "../src/sudoku-view.vala"
										_tmp65_ = _tmp64_;
#line 285 "../src/sudoku-view.vala"
										_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 285 "../src/sudoku-view.vala"
										_tmp67_ = _tmp66_;
#line 285 "../src/sudoku-view.vala"
										_tmp68_ = sudoku_view_get_game (self);
#line 285 "../src/sudoku-view.vala"
										_tmp69_ = _tmp68_;
#line 285 "../src/sudoku-view.vala"
										_tmp70_ = sudoku_game_get_board (_tmp69_);
#line 285 "../src/sudoku-view.vala"
										_tmp71_ = _tmp70_;
#line 285 "../src/sudoku-view.vala"
										_tmp72_ = sudoku_board_get_block_rows (_tmp71_);
#line 285 "../src/sudoku-view.vala"
										_tmp73_ = _tmp72_;
#line 285 "../src/sudoku-view.vala"
										_tmp49_ = (col_tmp / _tmp67_) == (col / _tmp73_);
#line 1845 "sudoku-view.c"
									} else {
#line 284 "../src/sudoku-view.vala"
										_tmp49_ = FALSE;
#line 1849 "sudoku-view.c"
									}
#line 284 "../src/sudoku-view.vala"
									_tmp47_ = _tmp49_;
#line 1853 "sudoku-view.c"
								}
#line 283 "../src/sudoku-view.vala"
								_tmp43_ = _tmp47_;
#line 1857 "sudoku-view.c"
							} else {
#line 282 "../src/sudoku-view.vala"
								_tmp43_ = FALSE;
#line 1861 "sudoku-view.c"
							}
#line 282 "../src/sudoku-view.vala"
							if (_tmp43_) {
#line 1865 "sudoku-view.c"
								SudokuCell* _tmp74_;
#line 287 "../src/sudoku-view.vala"
								_tmp74_ = cell_tmp;
#line 287 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp74_, enabled);
#line 1871 "sudoku-view.c"
							}
#line 267 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 1875 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 258 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 1884 "sudoku-view.c"
}

static void
sudoku_view_set_value_highlighter (SudokuView* self,
                                   gint val,
                                   gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp4_;
	gint _tmp5_;
	SudokuCell* _tmp6_;
	SudokuCell* _tmp7_;
#line 293 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_view_get_highlighter (self);
#line 295 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 295 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 295 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1913 "sudoku-view.c"
	} else {
#line 295 "../src/sudoku-view.vala"
		_tmp0_ = val == 0;
#line 1917 "sudoku-view.c"
	}
#line 295 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 296 "../src/sudoku-view.vala"
		return;
#line 1923 "sudoku-view.c"
	}
#line 298 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 298 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 298 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 298 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 298 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_col;
#line 298 "../src/sudoku-view.vala"
	_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 298 "../src/sudoku-view.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 298 "../src/sudoku-view.vala"
	cell = _tmp7_;
#line 1941 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 300 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1946 "sudoku-view.c"
		{
			gboolean _tmp8_ = FALSE;
#line 300 "../src/sudoku-view.vala"
			_tmp8_ = TRUE;
#line 300 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1953 "sudoku-view.c"
				SudokuGame* _tmp10_;
				SudokuGame* _tmp11_;
				SudokuBoard* _tmp12_;
				SudokuBoard* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 300 "../src/sudoku-view.vala"
				if (!_tmp8_) {
#line 1962 "sudoku-view.c"
					gint _tmp9_;
#line 300 "../src/sudoku-view.vala"
					_tmp9_ = col_tmp;
#line 300 "../src/sudoku-view.vala"
					col_tmp = _tmp9_ + 1;
#line 1968 "sudoku-view.c"
				}
#line 300 "../src/sudoku-view.vala"
				_tmp8_ = FALSE;
#line 300 "../src/sudoku-view.vala"
				_tmp10_ = sudoku_view_get_game (self);
#line 300 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_;
#line 300 "../src/sudoku-view.vala"
				_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 300 "../src/sudoku-view.vala"
				_tmp13_ = _tmp12_;
#line 300 "../src/sudoku-view.vala"
				_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 300 "../src/sudoku-view.vala"
				_tmp15_ = _tmp14_;
#line 300 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp15_)) {
#line 300 "../src/sudoku-view.vala"
					break;
#line 1988 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 302 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1994 "sudoku-view.c"
					{
						gboolean _tmp16_ = FALSE;
#line 302 "../src/sudoku-view.vala"
						_tmp16_ = TRUE;
#line 302 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2001 "sudoku-view.c"
							SudokuGame* _tmp18_;
							SudokuGame* _tmp19_;
							SudokuBoard* _tmp20_;
							SudokuBoard* _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							SudokuCell* _tmp28_;
							SudokuCell* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
#line 302 "../src/sudoku-view.vala"
							if (!_tmp16_) {
#line 2021 "sudoku-view.c"
								gint _tmp17_;
#line 302 "../src/sudoku-view.vala"
								_tmp17_ = row_tmp;
#line 302 "../src/sudoku-view.vala"
								row_tmp = _tmp17_ + 1;
#line 2027 "sudoku-view.c"
							}
#line 302 "../src/sudoku-view.vala"
							_tmp16_ = FALSE;
#line 302 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_view_get_game (self);
#line 302 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 302 "../src/sudoku-view.vala"
							_tmp20_ = sudoku_game_get_board (_tmp19_);
#line 302 "../src/sudoku-view.vala"
							_tmp21_ = _tmp20_;
#line 302 "../src/sudoku-view.vala"
							_tmp22_ = sudoku_board_get_rows (_tmp21_);
#line 302 "../src/sudoku-view.vala"
							_tmp23_ = _tmp22_;
#line 302 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp23_)) {
#line 302 "../src/sudoku-view.vala"
								break;
#line 2047 "sudoku-view.c"
							}
#line 304 "../src/sudoku-view.vala"
							_tmp24_ = self->priv->cells;
#line 304 "../src/sudoku-view.vala"
							_tmp24__length1 = self->priv->cells_length1;
#line 304 "../src/sudoku-view.vala"
							_tmp24__length2 = self->priv->cells_length2;
#line 304 "../src/sudoku-view.vala"
							_tmp25_ = _tmp24_[(row_tmp * _tmp24__length2) + col_tmp];
#line 304 "../src/sudoku-view.vala"
							_tmp26_ = _g_object_ref0 (_tmp25_);
#line 304 "../src/sudoku-view.vala"
							cell_tmp = _tmp26_;
#line 306 "../src/sudoku-view.vala"
							_tmp27_ = cell;
#line 306 "../src/sudoku-view.vala"
							_tmp28_ = cell_tmp;
#line 306 "../src/sudoku-view.vala"
							if (_tmp27_ == _tmp28_) {
#line 307 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 307 "../src/sudoku-view.vala"
								continue;
#line 2071 "sudoku-view.c"
							}
#line 309 "../src/sudoku-view.vala"
							_tmp29_ = cell_tmp;
#line 309 "../src/sudoku-view.vala"
							_tmp30_ = sudoku_cell_get_value (_tmp29_);
#line 309 "../src/sudoku-view.vala"
							_tmp31_ = _tmp30_;
#line 309 "../src/sudoku-view.vala"
							if (val == _tmp31_) {
#line 2081 "sudoku-view.c"
								SudokuCell* _tmp32_;
#line 310 "../src/sudoku-view.vala"
								_tmp32_ = cell_tmp;
#line 310 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_value (_tmp32_, enabled);
#line 2087 "sudoku-view.c"
							} else {
								SudokuCell* _tmp33_;
								gint _tmp34_;
								gint _tmp35_;
#line 311 "../src/sudoku-view.vala"
								_tmp33_ = cell_tmp;
#line 311 "../src/sudoku-view.vala"
								_tmp34_ = sudoku_cell_get_value (_tmp33_);
#line 311 "../src/sudoku-view.vala"
								_tmp35_ = _tmp34_;
#line 311 "../src/sudoku-view.vala"
								if (_tmp35_ == 0) {
#line 2100 "sudoku-view.c"
									SudokuCell* _tmp36_;
#line 312 "../src/sudoku-view.vala"
									_tmp36_ = cell_tmp;
#line 312 "../src/sudoku-view.vala"
									sudoku_cell_set_earmark_highlight (_tmp36_, val, enabled);
#line 2106 "sudoku-view.c"
								}
							}
#line 302 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 2111 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 293 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 2120 "sudoku-view.c"
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 317 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 319 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 319 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 320 "../src/sudoku-view.vala"
		return;
#line 2138 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 322 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2144 "sudoku-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 322 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 322 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2151 "sudoku-view.c"
				SudokuGame* _tmp4_;
				SudokuGame* _tmp5_;
				SudokuBoard* _tmp6_;
				SudokuBoard* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 322 "../src/sudoku-view.vala"
				if (!_tmp2_) {
#line 2160 "sudoku-view.c"
					gint _tmp3_;
#line 322 "../src/sudoku-view.vala"
					_tmp3_ = col_tmp;
#line 322 "../src/sudoku-view.vala"
					col_tmp = _tmp3_ + 1;
#line 2166 "sudoku-view.c"
				}
#line 322 "../src/sudoku-view.vala"
				_tmp2_ = FALSE;
#line 322 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_view_get_game (self);
#line 322 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 322 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 322 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 322 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_board_get_cols (_tmp7_);
#line 322 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 322 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp9_)) {
#line 322 "../src/sudoku-view.vala"
					break;
#line 2186 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 323 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2192 "sudoku-view.c"
					{
						gboolean _tmp10_ = FALSE;
#line 323 "../src/sudoku-view.vala"
						_tmp10_ = TRUE;
#line 323 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2199 "sudoku-view.c"
							SudokuGame* _tmp12_;
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							SudokuBoard* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
#line 323 "../src/sudoku-view.vala"
							if (!_tmp10_) {
#line 2212 "sudoku-view.c"
								gint _tmp11_;
#line 323 "../src/sudoku-view.vala"
								_tmp11_ = row_tmp;
#line 323 "../src/sudoku-view.vala"
								row_tmp = _tmp11_ + 1;
#line 2218 "sudoku-view.c"
							}
#line 323 "../src/sudoku-view.vala"
							_tmp10_ = FALSE;
#line 323 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_view_get_game (self);
#line 323 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 323 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_game_get_board (_tmp13_);
#line 323 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 323 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_board_get_rows (_tmp15_);
#line 323 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 323 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp17_)) {
#line 323 "../src/sudoku-view.vala"
								break;
#line 2238 "sudoku-view.c"
							}
#line 324 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->cells;
#line 324 "../src/sudoku-view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 324 "../src/sudoku-view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 324 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_[(row_tmp * _tmp18__length2) + col_tmp];
#line 324 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp19_);
#line 2250 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 327 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2264 "sudoku-view.c"
	{
		gint i = 0;
#line 329 "../src/sudoku-view.vala"
		i = 0;
#line 2269 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 329 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 329 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2276 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 329 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2285 "sudoku-view.c"
					gint _tmp1_;
#line 329 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 329 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2291 "sudoku-view.c"
				}
#line 329 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 329 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 329 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 329 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 329 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 329 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 329 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 329 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 329 "../src/sudoku-view.vala"
					break;
#line 2311 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 330 "../src/sudoku-view.vala"
					j = 0;
#line 2317 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 330 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 330 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2324 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuGame* _tmp16_;
							SudokuGame* _tmp17_;
							SudokuBoard* _tmp18_;
							SudokuBoard* _tmp19_;
#line 330 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2337 "sudoku-view.c"
								gint _tmp9_;
#line 330 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 330 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2343 "sudoku-view.c"
							}
#line 330 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 330 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 330 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 330 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 330 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 330 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 330 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 330 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 330 "../src/sudoku-view.vala"
								break;
#line 2363 "sudoku-view.c"
							}
#line 331 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_view_get_game (self);
#line 331 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 331 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_game_get_board (_tmp17_);
#line 331 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 331 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp19_, i, j);
#line 2375 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 334 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2389 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 336 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2394 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 336 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 336 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2401 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 336 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2410 "sudoku-view.c"
					gint _tmp1_;
#line 336 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 336 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2416 "sudoku-view.c"
				}
#line 336 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 336 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 336 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 336 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 336 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 336 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_cols (_tmp5_);
#line 336 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 336 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp7_)) {
#line 336 "../src/sudoku-view.vala"
					break;
#line 2436 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 337 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2442 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 337 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 337 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2449 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 337 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2462 "sudoku-view.c"
								gint _tmp9_;
#line 337 "../src/sudoku-view.vala"
								_tmp9_ = row_tmp;
#line 337 "../src/sudoku-view.vala"
								row_tmp = _tmp9_ + 1;
#line 2468 "sudoku-view.c"
							}
#line 337 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 337 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 337 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 337 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 337 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 337 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 337 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 337 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp15_)) {
#line 337 "../src/sudoku-view.vala"
								break;
#line 2488 "sudoku-view.c"
							}
#line 339 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 339 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row_tmp * _tmp16__length2) + col_tmp];
#line 339 "../src/sudoku-view.vala"
							sudoku_cell_clear_warnings (_tmp17_);
#line 2500 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_redraw (SudokuView* self)
{
#line 343 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2514 "sudoku-view.c"
	{
		gint i = 0;
#line 345 "../src/sudoku-view.vala"
		i = 0;
#line 2519 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 345 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 345 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2526 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 345 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2535 "sudoku-view.c"
					gint _tmp1_;
#line 345 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 345 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2541 "sudoku-view.c"
				}
#line 345 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 345 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 345 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 345 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 345 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 345 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 345 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 345 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 345 "../src/sudoku-view.vala"
					break;
#line 2561 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 346 "../src/sudoku-view.vala"
					j = 0;
#line 2567 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 346 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 346 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2574 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 346 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2587 "sudoku-view.c"
								gint _tmp9_;
#line 346 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 346 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2593 "sudoku-view.c"
							}
#line 346 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 346 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 346 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 346 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 346 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 346 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 346 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 346 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 346 "../src/sudoku-view.vala"
								break;
#line 2613 "sudoku-view.c"
							}
#line 347 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 347 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 347 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 347 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 347 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp17_);
#line 2625 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 434 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2639 "sudoku-view.c"
	{
		gint i = 0;
#line 436 "../src/sudoku-view.vala"
		i = 0;
#line 2644 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 436 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 436 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2651 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 436 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2660 "sudoku-view.c"
					gint _tmp1_;
#line 436 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 436 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2666 "sudoku-view.c"
				}
#line 436 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 436 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 436 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 436 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 436 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 436 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 436 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 436 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 436 "../src/sudoku-view.vala"
					break;
#line 2686 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 437 "../src/sudoku-view.vala"
					j = 0;
#line 2692 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 437 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 437 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2699 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 437 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2712 "sudoku-view.c"
								gint _tmp9_;
#line 437 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 437 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2718 "sudoku-view.c"
							}
#line 437 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 437 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 437 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 437 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 437 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 437 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 437 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 437 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 437 "../src/sudoku-view.vala"
								break;
#line 2738 "sudoku-view.c"
							}
#line 438 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 438 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 438 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 438 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 438 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp17_);
#line 2750 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

SudokuGame*
sudoku_view_get_game (SudokuView* self)
{
	SudokuGame* result;
	SudokuGame* _tmp0_;
#line 31 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_game;
#line 31 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 31 "../src/sudoku-view.vala"
	return result;
#line 2772 "sudoku-view.c"
}

static void
sudoku_view_set_game (SudokuView* self,
                      SudokuGame* value)
{
	SudokuGame* _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 32 "../src/sudoku-view.vala"
	self->priv->_game = _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY]);
#line 2790 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 41 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 41 "../src/sudoku-view.vala"
	return result;
#line 2803 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 41 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 41 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 41 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 41 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2821 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 42 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 42 "../src/sudoku-view.vala"
	return result;
#line 2835 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 42 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 42 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 42 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 42 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 2853 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 353 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 353 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 353 "../src/sudoku-view.vala"
	return result;
#line 2867 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp18_;
	gboolean _tmp19_;
#line 354 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 2880 "sudoku-view.c"
	{
		gint i = 0;
#line 356 "../src/sudoku-view.vala"
		i = 0;
#line 2885 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 356 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 356 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2892 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 356 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2901 "sudoku-view.c"
					gint _tmp1_;
#line 356 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 356 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2907 "sudoku-view.c"
				}
#line 356 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 356 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 356 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 356 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 356 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 356 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 356 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 356 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 356 "../src/sudoku-view.vala"
					break;
#line 2927 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 357 "../src/sudoku-view.vala"
					j = 0;
#line 2933 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 357 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 357 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2940 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 357 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2953 "sudoku-view.c"
								gint _tmp9_;
#line 357 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 357 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2959 "sudoku-view.c"
							}
#line 357 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 357 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 357 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 357 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 357 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 357 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 357 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 357 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 357 "../src/sudoku-view.vala"
								break;
#line 2979 "sudoku-view.c"
							}
#line 358 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 358 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 358 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 358 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 358 "../src/sudoku-view.vala"
							sudoku_cell_set_show_warnings (_tmp17_, self->priv->_show_warnings);
#line 2991 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 360 "../src/sudoku-view.vala"
	_tmp18_ = sudoku_view_get_show_warnings (self);
#line 360 "../src/sudoku-view.vala"
	_tmp19_ = _tmp18_;
#line 360 "../src/sudoku-view.vala"
	if (_tmp19_) {
#line 361 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 3006 "sudoku-view.c"
	} else {
#line 363 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 3010 "sudoku-view.c"
	}
#line 354 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 3014 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 370 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 370 "../src/sudoku-view.vala"
	return result;
#line 3027 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
#line 371 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 3038 "sudoku-view.c"
	{
		gint i = 0;
#line 373 "../src/sudoku-view.vala"
		i = 0;
#line 3043 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 373 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 373 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3050 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 373 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 3059 "sudoku-view.c"
					gint _tmp1_;
#line 373 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 373 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 3065 "sudoku-view.c"
				}
#line 373 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 373 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 373 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 373 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 373 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 373 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 373 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 373 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 373 "../src/sudoku-view.vala"
					break;
#line 3085 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 374 "../src/sudoku-view.vala"
					j = 0;
#line 3091 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 374 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 374 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3098 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 374 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 3111 "sudoku-view.c"
								gint _tmp9_;
#line 374 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 374 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 3117 "sudoku-view.c"
							}
#line 374 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 374 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 374 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 374 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 374 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 374 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 374 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 374 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 374 "../src/sudoku-view.vala"
								break;
#line 3137 "sudoku-view.c"
							}
#line 375 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 375 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 375 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 375 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 375 "../src/sudoku-view.vala"
							sudoku_cell_set_show_extra_warnings (_tmp17_, self->priv->_show_extra_warnings);
#line 3149 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 371 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3158 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 382 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 382 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 382 "../src/sudoku-view.vala"
	return result;
#line 3171 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 383 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 384 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 3182 "sudoku-view.c"
	{
		gint i = 0;
#line 385 "../src/sudoku-view.vala"
		i = 0;
#line 3187 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 385 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 385 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3194 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 385 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 3203 "sudoku-view.c"
					gint _tmp1_;
#line 385 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 385 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 3209 "sudoku-view.c"
				}
#line 385 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 385 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 385 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 385 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 385 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 385 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 385 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 385 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 385 "../src/sudoku-view.vala"
					break;
#line 3229 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 386 "../src/sudoku-view.vala"
					j = 0;
#line 3235 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 386 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 386 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3242 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 386 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 3255 "sudoku-view.c"
								gint _tmp9_;
#line 386 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 386 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 3261 "sudoku-view.c"
							}
#line 386 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 386 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 386 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 386 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 386 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 386 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 386 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 386 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 386 "../src/sudoku-view.vala"
								break;
#line 3281 "sudoku-view.c"
							}
#line 387 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 387 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 387 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 387 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 387 "../src/sudoku-view.vala"
							_tmp17_->show_possibilities = value;
#line 3293 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 383 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3302 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 394 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 394 "../src/sudoku-view.vala"
	return result;
#line 3315 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 395 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 396 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 3326 "sudoku-view.c"
	{
		gint i = 0;
#line 397 "../src/sudoku-view.vala"
		i = 0;
#line 3331 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 397 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 397 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3338 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 397 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 3347 "sudoku-view.c"
					gint _tmp1_;
#line 397 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 397 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 3353 "sudoku-view.c"
				}
#line 397 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 397 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 397 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 397 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 397 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 397 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 397 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 397 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 397 "../src/sudoku-view.vala"
					break;
#line 3373 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 398 "../src/sudoku-view.vala"
					j = 0;
#line 3379 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 398 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 398 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3386 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 398 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 3399 "sudoku-view.c"
								gint _tmp9_;
#line 398 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 398 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 3405 "sudoku-view.c"
							}
#line 398 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 398 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 398 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 398 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 398 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 398 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 398 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 398 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 398 "../src/sudoku-view.vala"
								break;
#line 3425 "sudoku-view.c"
							}
#line 399 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 399 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 399 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 399 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 399 "../src/sudoku-view.vala"
							sudoku_cell_set_initialize_earmarks (_tmp17_, value);
#line 3437 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 395 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 3446 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 406 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 406 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 406 "../src/sudoku-view.vala"
	return result;
#line 3459 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 407 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 408 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/sudoku-view.vala"
	if (value == _tmp1_) {
#line 409 "../src/sudoku-view.vala"
		return;
#line 3482 "sudoku-view.c"
	}
#line 411 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 411 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 411 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, FALSE);
#line 412 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 413 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 413 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_col;
#line 413 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp4_, _tmp5_, TRUE);
#line 407 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3500 "sudoku-view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 420 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 420 "../src/sudoku-view.vala"
	result = self->priv->_has_selection;
#line 420 "../src/sudoku-view.vala"
	return result;
#line 3513 "sudoku-view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* cell = NULL;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 421 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/sudoku-view.vala"
	self->priv->_has_selection = value;
#line 423 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 423 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 423 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 423 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 423 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 423 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 423 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 423 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 424 "../src/sudoku-view.vala"
	_tmp5_ = cell;
#line 424 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_has_selection (self);
#line 424 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 424 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp5_, _tmp7_);
#line 425 "../src/sudoku-view.vala"
	_tmp8_ = sudoku_view_get_has_selection (self);
#line 425 "../src/sudoku-view.vala"
	_tmp9_ = _tmp8_;
#line 425 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 3571 "sudoku-view.c"
		SudokuCell* _tmp10_;
#line 426 "../src/sudoku-view.vala"
		_tmp10_ = cell;
#line 426 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 3577 "sudoku-view.c"
	} else {
		SudokuCell* _tmp11_;
#line 428 "../src/sudoku-view.vala"
		_tmp11_ = cell;
#line 428 "../src/sudoku-view.vala"
		sudoku_cell_dismiss_popover (_tmp11_);
#line 3584 "sudoku-view.c"
	}
#line 430 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 430 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 430 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_has_selection (self);
#line 430 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 430 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp12_, _tmp13_, _tmp15_);
#line 421 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 421 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3600 "sudoku-view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/sudoku-view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/sudoku-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/sudoku-view.vala"
		data1 = closure->data;
#line 26 "../src/sudoku-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3625 "sudoku-view.c"
	} else {
#line 26 "../src/sudoku-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/sudoku-view.vala"
		data2 = closure->data;
#line 3631 "sudoku-view.c"
	}
#line 26 "../src/sudoku-view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/sudoku-view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3637 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda13_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 170 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 171 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 171 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 173 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 173 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 173 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 173 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3665 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 173 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 173 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 173 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3675 "sudoku-view.c"
	}
#line 173 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 174 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 174 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 174 "../src/sudoku-view.vala"
		return result;
#line 3685 "sudoku-view.c"
	}
#line 176 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 176 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 176 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3693 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 177 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 177 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 177 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 177 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 177 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 177 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3717 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 179 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 179 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 179 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 179 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 179 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 179 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 179 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3748 "sudoku-view.c"
	}
#line 181 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 181 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 181 "../src/sudoku-view.vala"
	return result;
#line 3756 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda13_ (widget);
#line 170 "../src/sudoku-view.vala"
	return result;
#line 3768 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 183 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 184 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 184 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 186 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 186 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 186 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 186 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3796 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 186 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 186 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 186 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3806 "sudoku-view.c"
	}
#line 186 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 187 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 187 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 187 "../src/sudoku-view.vala"
		return result;
#line 3816 "sudoku-view.c"
	}
#line 189 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 189 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 189 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3824 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 190 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 190 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 190 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 190 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 190 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 190 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 190 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 190 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3848 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 192 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 192 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 192 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 192 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 192 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 192 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 192 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 192 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 192 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 192 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3879 "sudoku-view.c"
	}
#line 194 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 194 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 194 "../src/sudoku-view.vala"
	return result;
#line 3887 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
#line 183 "../src/sudoku-view.vala"
	return result;
#line 3899 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 196 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 197 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 197 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 199 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 199 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 199 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 199 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3927 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 199 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 199 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 199 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3937 "sudoku-view.c"
	}
#line 199 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 200 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 200 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 200 "../src/sudoku-view.vala"
		return result;
#line 3947 "sudoku-view.c"
	}
#line 202 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 202 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 202 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3955 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 203 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 203 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 203 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 203 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 203 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 203 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 203 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 203 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3979 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 205 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 205 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 205 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 205 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 205 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 205 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 205 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 4010 "sudoku-view.c"
	}
#line 207 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 207 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 207 "../src/sudoku-view.vala"
	return result;
#line 4018 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
#line 196 "../src/sudoku-view.vala"
	return result;
#line 4030 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 209 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 210 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 210 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 212 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 212 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 212 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 212 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 4058 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 212 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 212 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 212 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 4068 "sudoku-view.c"
	}
#line 212 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 213 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 213 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 213 "../src/sudoku-view.vala"
		return result;
#line 4078 "sudoku-view.c"
	}
#line 215 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 215 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 215 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 4086 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 216 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 216 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 216 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 216 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 216 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 216 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 216 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 216 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 4110 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 218 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 218 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 218 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 218 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 218 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 218 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 218 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 218 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 218 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 218 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 4141 "sudoku-view.c"
	}
#line 220 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 220 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 220 "../src/sudoku-view.vala"
	return result;
#line 4149 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
#line 209 "../src/sudoku-view.vala"
	return result;
#line 4161 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_GAME_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_SUDOKU_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 170 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda13__gtk_shortcut_func;
#line 170 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 170 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 183 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda14__gtk_shortcut_func;
#line 183 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 183 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 196 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda15__gtk_shortcut_func;
#line 196 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 196 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 209 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda16__gtk_shortcut_func;
#line 209 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 209 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 223 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 223 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 223 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 224 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 224 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 224 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 225 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 225 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 225 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 226 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 226 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 226 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 227 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 227 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 227 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 228 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 228 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 228 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 229 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 229 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 229 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 230 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 230 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 230 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 231 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 231 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 231 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 232 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 232 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 232 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 233 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 233 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 233 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 234 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 234 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 234 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 169 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	right_func = NULL;
#line 169 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	left_func = NULL;
#line 169 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	down_func = NULL;
#line 169 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	up_func = NULL;
#line 169 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 4362 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 41 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 42 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 350 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 367 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 379 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 391 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 403 "../src/sudoku-view.vala"
	self->priv->_highlighter = TRUE;
#line 417 "../src/sudoku-view.vala"
	self->priv->_has_selection = TRUE;
#line 4387 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 35 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 36 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 38 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 39 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 4408 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_object (value, sudoku_view_get_game (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4497 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4503 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_game (self, g_value_get_object (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4571 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4577 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

