/* sudoku-board.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "libsudoku.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <glib-object.h>
#include <qqwing-wrapper.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

enum  {
	SUDOKU_BOARD_0_PROPERTY,
	SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY,
	SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY,
	SUDOKU_BOARD_BLOCK_ROWS_PROPERTY,
	SUDOKU_BOARD_BLOCK_COLS_PROPERTY,
	SUDOKU_BOARD_ROWS_PROPERTY,
	SUDOKU_BOARD_COLS_PROPERTY,
	SUDOKU_BOARD_MAX_VAL_PROPERTY,
	SUDOKU_BOARD_BROKEN_PROPERTY,
	SUDOKU_BOARD_FILLED_PROPERTY,
	SUDOKU_BOARD_FIXED_PROPERTY,
	SUDOKU_BOARD_SIZE_PROPERTY,
	SUDOKU_BOARD_COMPLETE_PROPERTY,
	SUDOKU_BOARD_BROKEN_COORDS_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY,
	SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY,
	SUDOKU_BOARD_NUM_PROPERTIES
};
static GParamSpec* sudoku_board_properties[SUDOKU_BOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _coord_free0(var) ((var == NULL) ? NULL : (var = (coord_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SUDOKU_BOARD_COMPLETED_SIGNAL,
	SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL,
	SUDOKU_BOARD_NUM_SIGNALS
};
static guint sudoku_board_signals[SUDOKU_BOARD_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuBoardPrivate {
	gint* cells;
	gint cells_length1;
	gint cells_length2;
	gint* solution;
	gint solution_length1;
	gint solution_length2;
	gboolean* is_fixed;
	gint is_fixed_length1;
	gint is_fixed_length2;
	gboolean* possible_in_row;
	gint possible_in_row_length1;
	gint possible_in_row_length2;
	gboolean* possible_in_col;
	gint possible_in_col_length1;
	gint possible_in_col_length2;
	gboolean* possible_in_block;
	gint possible_in_block_length1;
	gint possible_in_block_length2;
	gint possible_in_block_length3;
	gboolean* earmarks;
	gint earmarks_length1;
	gint earmarks_length2;
	gint earmarks_length3;
	gint n_earmarks;
	gdouble _previous_played_time;
	DifficultyCategory _difficulty_category;
	gint _block_rows;
	gint _block_cols;
	gint _rows;
	gint _cols;
	gint _filled;
	gint _fixed;
	GeeSet* _broken_coords;
	GeeList* _coords_for_col;
	GeeList* _coords_for_row;
	GeeMap* _coords_for_block;
};

static gint SudokuBoard_private_offset;
static gpointer sudoku_board_parent_class = NULL;

static void sudoku_board_set_cols (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_rows (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_block_rows (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_block_cols (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_broken_coords (SudokuBoard* self,
                                     GeeSet* value);
static void sudoku_board_set_coords_for_col (SudokuBoard* self,
                                      GeeList* value);
static void sudoku_board_set_coords_for_row (SudokuBoard* self,
                                      GeeList* value);
static void sudoku_board_set_coords_for_block (SudokuBoard* self,
                                        GeeMap* value);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static gint* _vala_array_dup2 (gint* self,
                        gssize length);
static gboolean* _vala_array_dup3 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup4 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup5 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup6 (gboolean* self,
                            gssize length);
static void sudoku_board_set_filled (SudokuBoard* self,
                              gint value);
static void sudoku_board_set_fixed (SudokuBoard* self,
                             gint value);
static gboolean* _vala_array_dup7 (gboolean* self,
                            gssize length);
static gint* _vala_array_dup8 (gint* self,
                        gssize length);
static void sudoku_board_mark_breakages_for (SudokuBoard* self,
                                      GeeList* coords,
                                      gint val);
static void sudoku_board_remove_breakages_for (SudokuBoard* self,
                                        GeeList* coords,
                                        gint val);
static gint* sudoku_board_fixed_cells_only (SudokuBoard* self,
                                     gint* result_length1,
                                     gint* result_length2);
static gint* sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                                     gint* ints_2d,
                                     gint ints_2d_length1,
                                     gint ints_2d_length2,
                                     gint* result_length1);
static gint* sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                                     gint* ints_1d,
                                     gint ints_1d_length1,
                                     gint* result_length1,
                                     gint* result_length2);
static gint* _vala_array_dup9 (gint* self,
                        gssize length);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static void sudoku_board_finalize (GObject * obj);
static GType sudoku_board_get_type_once (void);
static void _vala_sudoku_board_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_board_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_board_get_instance_private (SudokuBoard* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuBoard_private_offset);
}

gboolean
sudoku_board_is_empty (SudokuBoard* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 81 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 83 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_fixed;
#line 83 "../lib/sudoku-board.vala"
	if (_tmp1_ == _tmp2_) {
#line 83 "../lib/sudoku-board.vala"
		_tmp0_ = self->priv->n_earmarks == 0;
#line 221 "sudoku-board.c"
	} else {
#line 83 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 225 "sudoku-board.c"
	}
#line 83 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 83 "../lib/sudoku-board.vala"
	return result;
#line 231 "sudoku-board.c"
}

gboolean
sudoku_board_is_fully_filled (SudokuBoard* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 86 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_filled;
#line 88 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 88 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_rows;
#line 88 "../lib/sudoku-board.vala"
	result = _tmp0_ == (_tmp1_ * _tmp2_);
#line 88 "../lib/sudoku-board.vala"
	return result;
#line 253 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_construct (GType object_type,
                        gint block_rows,
                        gint block_cols)
{
	SudokuBoard * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean* _tmp11_;
	gboolean* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean* _tmp17_;
	GeeHashSet* _tmp37_;
	GeeHashSet* _tmp38_;
	GeeArrayList* _tmp39_;
	GeeArrayList* _tmp40_;
	GeeList* _tmp61_;
	GeeList* _tmp62_;
	GeeList* _tmp63_;
	GeeList* _tmp64_;
	GeeArrayList* _tmp65_;
	GeeArrayList* _tmp66_;
	GeeList* _tmp87_;
	GeeList* _tmp88_;
	GeeList* _tmp89_;
	GeeList* _tmp90_;
	GeeHashMap* _tmp91_;
	GeeHashMap* _tmp92_;
	GeeMap* _tmp125_;
	GeeMap* _tmp126_;
	GeeMap* _tmp127_;
	GeeMap* _tmp128_;
#line 106 "../lib/sudoku-board.vala"
	self = (SudokuBoard*) g_object_new (object_type, NULL);
#line 108 "../lib/sudoku-board.vala"
	sudoku_board_set_cols (self, block_rows * block_cols);
#line 108 "../lib/sudoku-board.vala"
	sudoku_board_set_rows (self, block_rows * block_cols);
#line 109 "../lib/sudoku-board.vala"
	sudoku_board_set_block_rows (self, block_rows);
#line 110 "../lib/sudoku-board.vala"
	sudoku_board_set_block_cols (self, block_cols);
#line 111 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 111 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 111 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 111 "../lib/sudoku-board.vala"
	self->priv->cells = (g_free (self->priv->cells), NULL);
#line 111 "../lib/sudoku-board.vala"
	self->priv->cells = _tmp2_;
#line 111 "../lib/sudoku-board.vala"
	self->priv->cells_length1 = _tmp0_;
#line 111 "../lib/sudoku-board.vala"
	self->priv->cells_length2 = _tmp1_;
#line 112 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 112 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->_cols;
#line 112 "../lib/sudoku-board.vala"
	_tmp5_ = g_new0 (gboolean, _tmp3_ * _tmp4_);
#line 112 "../lib/sudoku-board.vala"
	self->priv->is_fixed = (g_free (self->priv->is_fixed), NULL);
#line 112 "../lib/sudoku-board.vala"
	self->priv->is_fixed = _tmp5_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->is_fixed_length1 = _tmp3_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->is_fixed_length2 = _tmp4_;
#line 113 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->_rows;
#line 113 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_cols;
#line 113 "../lib/sudoku-board.vala"
	_tmp8_ = g_new0 (gboolean, _tmp6_ * _tmp7_);
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = _tmp8_;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length1 = _tmp6_;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length2 = _tmp7_;
#line 114 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->_cols;
#line 114 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->_rows;
#line 114 "../lib/sudoku-board.vala"
	_tmp11_ = g_new0 (gboolean, _tmp9_ * _tmp10_);
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = _tmp11_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length1 = _tmp9_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length2 = _tmp10_;
#line 115 "../lib/sudoku-board.vala"
	_tmp12_ = g_new0 (gboolean, (block_rows * block_cols) * (block_rows * block_cols));
#line 115 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 115 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = _tmp12_;
#line 115 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length1 = block_rows;
#line 115 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length2 = block_cols;
#line 115 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length3 = block_rows * block_cols;
#line 116 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->_rows;
#line 116 "../lib/sudoku-board.vala"
	_tmp14_ = self->priv->_cols;
#line 116 "../lib/sudoku-board.vala"
	_tmp15_ = sudoku_board_get_max_val (self);
#line 116 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_;
#line 116 "../lib/sudoku-board.vala"
	_tmp17_ = g_new0 (gboolean, (_tmp13_ * _tmp14_) * _tmp16_);
#line 116 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 116 "../lib/sudoku-board.vala"
	self->priv->earmarks = _tmp17_;
#line 116 "../lib/sudoku-board.vala"
	self->priv->earmarks_length1 = _tmp13_;
#line 116 "../lib/sudoku-board.vala"
	self->priv->earmarks_length2 = _tmp14_;
#line 116 "../lib/sudoku-board.vala"
	self->priv->earmarks_length3 = _tmp16_;
#line 398 "sudoku-board.c"
	{
		gint l1 = 0;
#line 118 "../lib/sudoku-board.vala"
		l1 = 0;
#line 403 "sudoku-board.c"
		{
			gboolean _tmp18_ = FALSE;
#line 118 "../lib/sudoku-board.vala"
			_tmp18_ = TRUE;
#line 118 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 410 "sudoku-board.c"
				gint _tmp20_;
#line 118 "../lib/sudoku-board.vala"
				if (!_tmp18_) {
#line 414 "sudoku-board.c"
					gint _tmp19_;
#line 118 "../lib/sudoku-board.vala"
					_tmp19_ = l1;
#line 118 "../lib/sudoku-board.vala"
					l1 = _tmp19_ + 1;
#line 420 "sudoku-board.c"
				}
#line 118 "../lib/sudoku-board.vala"
				_tmp18_ = FALSE;
#line 118 "../lib/sudoku-board.vala"
				_tmp20_ = self->priv->_rows;
#line 118 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp20_)) {
#line 118 "../lib/sudoku-board.vala"
					break;
#line 430 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 120 "../lib/sudoku-board.vala"
					l2 = 0;
#line 436 "sudoku-board.c"
					{
						gboolean _tmp21_ = FALSE;
#line 120 "../lib/sudoku-board.vala"
						_tmp21_ = TRUE;
#line 120 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 443 "sudoku-board.c"
							gint _tmp23_;
							gint* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							gboolean* _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							gboolean* _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							gboolean* _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
#line 120 "../lib/sudoku-board.vala"
							if (!_tmp21_) {
#line 459 "sudoku-board.c"
								gint _tmp22_;
#line 120 "../lib/sudoku-board.vala"
								_tmp22_ = l2;
#line 120 "../lib/sudoku-board.vala"
								l2 = _tmp22_ + 1;
#line 465 "sudoku-board.c"
							}
#line 120 "../lib/sudoku-board.vala"
							_tmp21_ = FALSE;
#line 120 "../lib/sudoku-board.vala"
							_tmp23_ = self->priv->_cols;
#line 120 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp23_)) {
#line 120 "../lib/sudoku-board.vala"
								break;
#line 475 "sudoku-board.c"
							}
#line 122 "../lib/sudoku-board.vala"
							_tmp24_ = self->priv->cells;
#line 122 "../lib/sudoku-board.vala"
							_tmp24__length1 = self->priv->cells_length1;
#line 122 "../lib/sudoku-board.vala"
							_tmp24__length2 = self->priv->cells_length2;
#line 122 "../lib/sudoku-board.vala"
							_tmp24_[(l1 * _tmp24__length2) + l2] = 0;
#line 123 "../lib/sudoku-board.vala"
							_tmp25_ = self->priv->is_fixed;
#line 123 "../lib/sudoku-board.vala"
							_tmp25__length1 = self->priv->is_fixed_length1;
#line 123 "../lib/sudoku-board.vala"
							_tmp25__length2 = self->priv->is_fixed_length2;
#line 123 "../lib/sudoku-board.vala"
							_tmp25_[(l1 * _tmp25__length2) + l2] = FALSE;
#line 124 "../lib/sudoku-board.vala"
							_tmp26_ = self->priv->possible_in_row;
#line 124 "../lib/sudoku-board.vala"
							_tmp26__length1 = self->priv->possible_in_row_length1;
#line 124 "../lib/sudoku-board.vala"
							_tmp26__length2 = self->priv->possible_in_row_length2;
#line 124 "../lib/sudoku-board.vala"
							_tmp26_[(l1 * _tmp26__length2) + l2] = TRUE;
#line 125 "../lib/sudoku-board.vala"
							_tmp27_ = self->priv->possible_in_col;
#line 125 "../lib/sudoku-board.vala"
							_tmp27__length1 = self->priv->possible_in_col_length1;
#line 125 "../lib/sudoku-board.vala"
							_tmp27__length2 = self->priv->possible_in_col_length2;
#line 125 "../lib/sudoku-board.vala"
							_tmp27_[(l2 * _tmp27__length2) + l1] = TRUE;
#line 509 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint l1 = 0;
#line 128 "../lib/sudoku-board.vala"
		l1 = 0;
#line 520 "sudoku-board.c"
		{
			gboolean _tmp28_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
			_tmp28_ = TRUE;
#line 128 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 128 "../lib/sudoku-board.vala"
				if (!_tmp28_) {
#line 529 "sudoku-board.c"
					gint _tmp29_;
#line 128 "../lib/sudoku-board.vala"
					_tmp29_ = l1;
#line 128 "../lib/sudoku-board.vala"
					l1 = _tmp29_ + 1;
#line 535 "sudoku-board.c"
				}
#line 128 "../lib/sudoku-board.vala"
				_tmp28_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
				if (!(l1 < block_rows)) {
#line 128 "../lib/sudoku-board.vala"
					break;
#line 543 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 129 "../lib/sudoku-board.vala"
					l2 = 0;
#line 549 "sudoku-board.c"
					{
						gboolean _tmp30_ = FALSE;
#line 129 "../lib/sudoku-board.vala"
						_tmp30_ = TRUE;
#line 129 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 129 "../lib/sudoku-board.vala"
							if (!_tmp30_) {
#line 558 "sudoku-board.c"
								gint _tmp31_;
#line 129 "../lib/sudoku-board.vala"
								_tmp31_ = l2;
#line 129 "../lib/sudoku-board.vala"
								l2 = _tmp31_ + 1;
#line 564 "sudoku-board.c"
							}
#line 129 "../lib/sudoku-board.vala"
							_tmp30_ = FALSE;
#line 129 "../lib/sudoku-board.vala"
							if (!(l2 < block_cols)) {
#line 129 "../lib/sudoku-board.vala"
								break;
#line 572 "sudoku-board.c"
							}
							{
								gint l3 = 0;
#line 130 "../lib/sudoku-board.vala"
								l3 = 0;
#line 578 "sudoku-board.c"
								{
									gboolean _tmp32_ = FALSE;
#line 130 "../lib/sudoku-board.vala"
									_tmp32_ = TRUE;
#line 130 "../lib/sudoku-board.vala"
									while (TRUE) {
#line 585 "sudoku-board.c"
										gint _tmp34_;
										gint _tmp35_;
										gboolean* _tmp36_;
										gint _tmp36__length1;
										gint _tmp36__length2;
										gint _tmp36__length3;
#line 130 "../lib/sudoku-board.vala"
										if (!_tmp32_) {
#line 594 "sudoku-board.c"
											gint _tmp33_;
#line 130 "../lib/sudoku-board.vala"
											_tmp33_ = l3;
#line 130 "../lib/sudoku-board.vala"
											l3 = _tmp33_ + 1;
#line 600 "sudoku-board.c"
										}
#line 130 "../lib/sudoku-board.vala"
										_tmp32_ = FALSE;
#line 130 "../lib/sudoku-board.vala"
										_tmp34_ = sudoku_board_get_max_val (self);
#line 130 "../lib/sudoku-board.vala"
										_tmp35_ = _tmp34_;
#line 130 "../lib/sudoku-board.vala"
										if (!(l3 < _tmp35_)) {
#line 130 "../lib/sudoku-board.vala"
											break;
#line 612 "sudoku-board.c"
										}
#line 131 "../lib/sudoku-board.vala"
										_tmp36_ = self->priv->possible_in_block;
#line 131 "../lib/sudoku-board.vala"
										_tmp36__length1 = self->priv->possible_in_block_length1;
#line 131 "../lib/sudoku-board.vala"
										_tmp36__length2 = self->priv->possible_in_block_length2;
#line 131 "../lib/sudoku-board.vala"
										_tmp36__length3 = self->priv->possible_in_block_length3;
#line 131 "../lib/sudoku-board.vala"
										_tmp36_[(((l1 * _tmp36__length2) + l2) * _tmp36__length3) + l3] = TRUE;
#line 624 "sudoku-board.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 133 "../lib/sudoku-board.vala"
	_tmp37_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 133 "../lib/sudoku-board.vala"
	_tmp38_ = _tmp37_;
#line 133 "../lib/sudoku-board.vala"
	sudoku_board_set_broken_coords (self, (GeeSet*) _tmp38_);
#line 133 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp38_);
#line 135 "../lib/sudoku-board.vala"
	_tmp39_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 135 "../lib/sudoku-board.vala"
	_tmp40_ = _tmp39_;
#line 135 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_col (self, (GeeList*) _tmp40_);
#line 135 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp40_);
#line 650 "sudoku-board.c"
	{
		gint col = 0;
#line 136 "../lib/sudoku-board.vala"
		col = 0;
#line 655 "sudoku-board.c"
		{
			gboolean _tmp41_ = FALSE;
#line 136 "../lib/sudoku-board.vala"
			_tmp41_ = TRUE;
#line 136 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 662 "sudoku-board.c"
				gint _tmp43_;
				GeeList* _tmp44_;
				GeeArrayList* _tmp45_;
				GeeArrayList* _tmp46_;
				GeeList* _tmp54_;
				GeeList* _tmp55_;
				gpointer _tmp56_;
				GeeList* _tmp57_;
				GeeList* _tmp58_;
				GeeList* _tmp59_;
				GeeList* _tmp60_;
#line 136 "../lib/sudoku-board.vala"
				if (!_tmp41_) {
#line 676 "sudoku-board.c"
					gint _tmp42_;
#line 136 "../lib/sudoku-board.vala"
					_tmp42_ = col;
#line 136 "../lib/sudoku-board.vala"
					col = _tmp42_ + 1;
#line 682 "sudoku-board.c"
				}
#line 136 "../lib/sudoku-board.vala"
				_tmp41_ = FALSE;
#line 136 "../lib/sudoku-board.vala"
				_tmp43_ = self->priv->_cols;
#line 136 "../lib/sudoku-board.vala"
				if (!(col < _tmp43_)) {
#line 136 "../lib/sudoku-board.vala"
					break;
#line 692 "sudoku-board.c"
				}
#line 138 "../lib/sudoku-board.vala"
				_tmp44_ = self->priv->_coords_for_col;
#line 138 "../lib/sudoku-board.vala"
				_tmp45_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 138 "../lib/sudoku-board.vala"
				_tmp46_ = _tmp45_;
#line 138 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp44_, (GeeList*) _tmp46_);
#line 138 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp46_);
#line 704 "sudoku-board.c"
				{
					gint row = 0;
#line 139 "../lib/sudoku-board.vala"
					row = 0;
#line 709 "sudoku-board.c"
					{
						gboolean _tmp47_ = FALSE;
#line 139 "../lib/sudoku-board.vala"
						_tmp47_ = TRUE;
#line 139 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 716 "sudoku-board.c"
							gint _tmp49_;
							GeeList* _tmp50_;
							gpointer _tmp51_;
							GeeList* _tmp52_;
							Coord _tmp53_ = {0};
#line 139 "../lib/sudoku-board.vala"
							if (!_tmp47_) {
#line 724 "sudoku-board.c"
								gint _tmp48_;
#line 139 "../lib/sudoku-board.vala"
								_tmp48_ = row;
#line 139 "../lib/sudoku-board.vala"
								row = _tmp48_ + 1;
#line 730 "sudoku-board.c"
							}
#line 139 "../lib/sudoku-board.vala"
							_tmp47_ = FALSE;
#line 139 "../lib/sudoku-board.vala"
							_tmp49_ = self->priv->_rows;
#line 139 "../lib/sudoku-board.vala"
							if (!(row < _tmp49_)) {
#line 139 "../lib/sudoku-board.vala"
								break;
#line 740 "sudoku-board.c"
							}
#line 140 "../lib/sudoku-board.vala"
							_tmp50_ = self->priv->_coords_for_col;
#line 140 "../lib/sudoku-board.vala"
							_tmp51_ = gee_list_get (_tmp50_, col);
#line 140 "../lib/sudoku-board.vala"
							_tmp52_ = (GeeList*) _tmp51_;
#line 140 "../lib/sudoku-board.vala"
							coord_init (&_tmp53_, row, col);
#line 140 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp52_, &_tmp53_);
#line 140 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp52_);
#line 754 "sudoku-board.c"
						}
					}
				}
#line 142 "../lib/sudoku-board.vala"
				_tmp54_ = self->priv->_coords_for_col;
#line 142 "../lib/sudoku-board.vala"
				_tmp55_ = self->priv->_coords_for_col;
#line 142 "../lib/sudoku-board.vala"
				_tmp56_ = gee_list_get (_tmp55_, col);
#line 142 "../lib/sudoku-board.vala"
				_tmp57_ = (GeeList*) _tmp56_;
#line 142 "../lib/sudoku-board.vala"
				_tmp58_ = gee_list_get_read_only_view (_tmp57_);
#line 142 "../lib/sudoku-board.vala"
				_tmp59_ = _tmp58_;
#line 142 "../lib/sudoku-board.vala"
				_tmp60_ = _tmp59_;
#line 142 "../lib/sudoku-board.vala"
				gee_list_set (_tmp54_, col, _tmp60_);
#line 142 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp60_);
#line 142 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp57_);
#line 778 "sudoku-board.c"
			}
		}
	}
#line 144 "../lib/sudoku-board.vala"
	_tmp61_ = self->priv->_coords_for_col;
#line 144 "../lib/sudoku-board.vala"
	_tmp62_ = gee_list_get_read_only_view (_tmp61_);
#line 144 "../lib/sudoku-board.vala"
	_tmp63_ = _tmp62_;
#line 144 "../lib/sudoku-board.vala"
	_tmp64_ = _tmp63_;
#line 144 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_col (self, _tmp64_);
#line 144 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp64_);
#line 146 "../lib/sudoku-board.vala"
	_tmp65_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 146 "../lib/sudoku-board.vala"
	_tmp66_ = _tmp65_;
#line 146 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_row (self, (GeeList*) _tmp66_);
#line 146 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp66_);
#line 802 "sudoku-board.c"
	{
		gint row = 0;
#line 147 "../lib/sudoku-board.vala"
		row = 0;
#line 807 "sudoku-board.c"
		{
			gboolean _tmp67_ = FALSE;
#line 147 "../lib/sudoku-board.vala"
			_tmp67_ = TRUE;
#line 147 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 814 "sudoku-board.c"
				gint _tmp69_;
				GeeList* _tmp70_;
				GeeArrayList* _tmp71_;
				GeeArrayList* _tmp72_;
				GeeList* _tmp80_;
				GeeList* _tmp81_;
				gpointer _tmp82_;
				GeeList* _tmp83_;
				GeeList* _tmp84_;
				GeeList* _tmp85_;
				GeeList* _tmp86_;
#line 147 "../lib/sudoku-board.vala"
				if (!_tmp67_) {
#line 828 "sudoku-board.c"
					gint _tmp68_;
#line 147 "../lib/sudoku-board.vala"
					_tmp68_ = row;
#line 147 "../lib/sudoku-board.vala"
					row = _tmp68_ + 1;
#line 834 "sudoku-board.c"
				}
#line 147 "../lib/sudoku-board.vala"
				_tmp67_ = FALSE;
#line 147 "../lib/sudoku-board.vala"
				_tmp69_ = self->priv->_rows;
#line 147 "../lib/sudoku-board.vala"
				if (!(row < _tmp69_)) {
#line 147 "../lib/sudoku-board.vala"
					break;
#line 844 "sudoku-board.c"
				}
#line 149 "../lib/sudoku-board.vala"
				_tmp70_ = self->priv->_coords_for_row;
#line 149 "../lib/sudoku-board.vala"
				_tmp71_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 149 "../lib/sudoku-board.vala"
				_tmp72_ = _tmp71_;
#line 149 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp70_, (GeeList*) _tmp72_);
#line 149 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp72_);
#line 856 "sudoku-board.c"
				{
					gint col = 0;
#line 150 "../lib/sudoku-board.vala"
					col = 0;
#line 861 "sudoku-board.c"
					{
						gboolean _tmp73_ = FALSE;
#line 150 "../lib/sudoku-board.vala"
						_tmp73_ = TRUE;
#line 150 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 868 "sudoku-board.c"
							gint _tmp75_;
							GeeList* _tmp76_;
							gpointer _tmp77_;
							GeeList* _tmp78_;
							Coord _tmp79_ = {0};
#line 150 "../lib/sudoku-board.vala"
							if (!_tmp73_) {
#line 876 "sudoku-board.c"
								gint _tmp74_;
#line 150 "../lib/sudoku-board.vala"
								_tmp74_ = col;
#line 150 "../lib/sudoku-board.vala"
								col = _tmp74_ + 1;
#line 882 "sudoku-board.c"
							}
#line 150 "../lib/sudoku-board.vala"
							_tmp73_ = FALSE;
#line 150 "../lib/sudoku-board.vala"
							_tmp75_ = self->priv->_cols;
#line 150 "../lib/sudoku-board.vala"
							if (!(col < _tmp75_)) {
#line 150 "../lib/sudoku-board.vala"
								break;
#line 892 "sudoku-board.c"
							}
#line 151 "../lib/sudoku-board.vala"
							_tmp76_ = self->priv->_coords_for_row;
#line 151 "../lib/sudoku-board.vala"
							_tmp77_ = gee_list_get (_tmp76_, row);
#line 151 "../lib/sudoku-board.vala"
							_tmp78_ = (GeeList*) _tmp77_;
#line 151 "../lib/sudoku-board.vala"
							coord_init (&_tmp79_, row, col);
#line 151 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp78_, &_tmp79_);
#line 151 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp78_);
#line 906 "sudoku-board.c"
						}
					}
				}
#line 153 "../lib/sudoku-board.vala"
				_tmp80_ = self->priv->_coords_for_row;
#line 153 "../lib/sudoku-board.vala"
				_tmp81_ = self->priv->_coords_for_row;
#line 153 "../lib/sudoku-board.vala"
				_tmp82_ = gee_list_get (_tmp81_, row);
#line 153 "../lib/sudoku-board.vala"
				_tmp83_ = (GeeList*) _tmp82_;
#line 153 "../lib/sudoku-board.vala"
				_tmp84_ = gee_list_get_read_only_view (_tmp83_);
#line 153 "../lib/sudoku-board.vala"
				_tmp85_ = _tmp84_;
#line 153 "../lib/sudoku-board.vala"
				_tmp86_ = _tmp85_;
#line 153 "../lib/sudoku-board.vala"
				gee_list_set (_tmp80_, row, _tmp86_);
#line 153 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp86_);
#line 153 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp83_);
#line 930 "sudoku-board.c"
			}
		}
	}
#line 155 "../lib/sudoku-board.vala"
	_tmp87_ = self->priv->_coords_for_row;
#line 155 "../lib/sudoku-board.vala"
	_tmp88_ = gee_list_get_read_only_view (_tmp87_);
#line 155 "../lib/sudoku-board.vala"
	_tmp89_ = _tmp88_;
#line 155 "../lib/sudoku-board.vala"
	_tmp90_ = _tmp89_;
#line 155 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_row (self, _tmp90_);
#line 155 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp90_);
#line 157 "../lib/sudoku-board.vala"
	_tmp91_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 157 "../lib/sudoku-board.vala"
	_tmp92_ = _tmp91_;
#line 157 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_block (self, (GeeMap*) _tmp92_);
#line 157 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp92_);
#line 954 "sudoku-board.c"
	{
		gint col = 0;
#line 158 "../lib/sudoku-board.vala"
		col = 0;
#line 959 "sudoku-board.c"
		{
			gboolean _tmp93_ = FALSE;
#line 158 "../lib/sudoku-board.vala"
			_tmp93_ = TRUE;
#line 158 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 158 "../lib/sudoku-board.vala"
				if (!_tmp93_) {
#line 968 "sudoku-board.c"
					gint _tmp94_;
#line 158 "../lib/sudoku-board.vala"
					_tmp94_ = col;
#line 158 "../lib/sudoku-board.vala"
					col = _tmp94_ + 1;
#line 974 "sudoku-board.c"
				}
#line 158 "../lib/sudoku-board.vala"
				_tmp93_ = FALSE;
#line 158 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 158 "../lib/sudoku-board.vala"
					break;
#line 982 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 159 "../lib/sudoku-board.vala"
					row = 0;
#line 988 "sudoku-board.c"
					{
						gboolean _tmp95_ = FALSE;
#line 159 "../lib/sudoku-board.vala"
						_tmp95_ = TRUE;
#line 159 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 995 "sudoku-board.c"
							GeeMap* _tmp97_;
							Coord _tmp98_ = {0};
							GeeArrayList* _tmp99_;
							GeeArrayList* _tmp100_;
#line 159 "../lib/sudoku-board.vala"
							if (!_tmp95_) {
#line 1002 "sudoku-board.c"
								gint _tmp96_;
#line 159 "../lib/sudoku-board.vala"
								_tmp96_ = row;
#line 159 "../lib/sudoku-board.vala"
								row = _tmp96_ + 1;
#line 1008 "sudoku-board.c"
							}
#line 159 "../lib/sudoku-board.vala"
							_tmp95_ = FALSE;
#line 159 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 159 "../lib/sudoku-board.vala"
								break;
#line 1016 "sudoku-board.c"
							}
#line 160 "../lib/sudoku-board.vala"
							_tmp97_ = self->priv->_coords_for_block;
#line 160 "../lib/sudoku-board.vala"
							coord_init (&_tmp98_, row, col);
#line 160 "../lib/sudoku-board.vala"
							_tmp99_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 160 "../lib/sudoku-board.vala"
							_tmp100_ = _tmp99_;
#line 160 "../lib/sudoku-board.vala"
							gee_map_set (_tmp97_, &_tmp98_, (GeeList*) _tmp100_);
#line 160 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp100_);
#line 1030 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 162 "../lib/sudoku-board.vala"
		col = 0;
#line 1041 "sudoku-board.c"
		{
			gboolean _tmp101_ = FALSE;
#line 162 "../lib/sudoku-board.vala"
			_tmp101_ = TRUE;
#line 162 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1048 "sudoku-board.c"
				gint _tmp103_;
#line 162 "../lib/sudoku-board.vala"
				if (!_tmp101_) {
#line 1052 "sudoku-board.c"
					gint _tmp102_;
#line 162 "../lib/sudoku-board.vala"
					_tmp102_ = col;
#line 162 "../lib/sudoku-board.vala"
					col = _tmp102_ + 1;
#line 1058 "sudoku-board.c"
				}
#line 162 "../lib/sudoku-board.vala"
				_tmp101_ = FALSE;
#line 162 "../lib/sudoku-board.vala"
				_tmp103_ = self->priv->_cols;
#line 162 "../lib/sudoku-board.vala"
				if (!(col < _tmp103_)) {
#line 162 "../lib/sudoku-board.vala"
					break;
#line 1068 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 163 "../lib/sudoku-board.vala"
					row = 0;
#line 1074 "sudoku-board.c"
					{
						gboolean _tmp104_ = FALSE;
#line 163 "../lib/sudoku-board.vala"
						_tmp104_ = TRUE;
#line 163 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1081 "sudoku-board.c"
							gint _tmp106_;
							GeeMap* _tmp107_;
							Coord _tmp108_ = {0};
							gpointer _tmp109_;
							GeeList* _tmp110_;
							Coord _tmp111_ = {0};
#line 163 "../lib/sudoku-board.vala"
							if (!_tmp104_) {
#line 1090 "sudoku-board.c"
								gint _tmp105_;
#line 163 "../lib/sudoku-board.vala"
								_tmp105_ = row;
#line 163 "../lib/sudoku-board.vala"
								row = _tmp105_ + 1;
#line 1096 "sudoku-board.c"
							}
#line 163 "../lib/sudoku-board.vala"
							_tmp104_ = FALSE;
#line 163 "../lib/sudoku-board.vala"
							_tmp106_ = self->priv->_rows;
#line 163 "../lib/sudoku-board.vala"
							if (!(row < _tmp106_)) {
#line 163 "../lib/sudoku-board.vala"
								break;
#line 1106 "sudoku-board.c"
							}
#line 164 "../lib/sudoku-board.vala"
							_tmp107_ = self->priv->_coords_for_block;
#line 164 "../lib/sudoku-board.vala"
							coord_init (&_tmp108_, row / block_rows, col / block_cols);
#line 164 "../lib/sudoku-board.vala"
							_tmp109_ = gee_map_get (_tmp107_, &_tmp108_);
#line 164 "../lib/sudoku-board.vala"
							_tmp110_ = (GeeList*) _tmp109_;
#line 164 "../lib/sudoku-board.vala"
							coord_init (&_tmp111_, row, col);
#line 164 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp110_, &_tmp111_);
#line 164 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp110_);
#line 1122 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 166 "../lib/sudoku-board.vala"
		col = 0;
#line 1133 "sudoku-board.c"
		{
			gboolean _tmp112_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
			_tmp112_ = TRUE;
#line 166 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 166 "../lib/sudoku-board.vala"
				if (!_tmp112_) {
#line 1142 "sudoku-board.c"
					gint _tmp113_;
#line 166 "../lib/sudoku-board.vala"
					_tmp113_ = col;
#line 166 "../lib/sudoku-board.vala"
					col = _tmp113_ + 1;
#line 1148 "sudoku-board.c"
				}
#line 166 "../lib/sudoku-board.vala"
				_tmp112_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 166 "../lib/sudoku-board.vala"
					break;
#line 1156 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 167 "../lib/sudoku-board.vala"
					row = 0;
#line 1162 "sudoku-board.c"
					{
						gboolean _tmp114_ = FALSE;
#line 167 "../lib/sudoku-board.vala"
						_tmp114_ = TRUE;
#line 167 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1169 "sudoku-board.c"
							GeeMap* _tmp116_;
							Coord _tmp117_ = {0};
							GeeMap* _tmp118_;
							Coord _tmp119_ = {0};
							gpointer _tmp120_;
							GeeList* _tmp121_;
							GeeList* _tmp122_;
							GeeList* _tmp123_;
							GeeList* _tmp124_;
#line 167 "../lib/sudoku-board.vala"
							if (!_tmp114_) {
#line 1181 "sudoku-board.c"
								gint _tmp115_;
#line 167 "../lib/sudoku-board.vala"
								_tmp115_ = row;
#line 167 "../lib/sudoku-board.vala"
								row = _tmp115_ + 1;
#line 1187 "sudoku-board.c"
							}
#line 167 "../lib/sudoku-board.vala"
							_tmp114_ = FALSE;
#line 167 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 167 "../lib/sudoku-board.vala"
								break;
#line 1195 "sudoku-board.c"
							}
#line 168 "../lib/sudoku-board.vala"
							_tmp116_ = self->priv->_coords_for_block;
#line 168 "../lib/sudoku-board.vala"
							coord_init (&_tmp117_, row, col);
#line 168 "../lib/sudoku-board.vala"
							_tmp118_ = self->priv->_coords_for_block;
#line 168 "../lib/sudoku-board.vala"
							coord_init (&_tmp119_, row, col);
#line 168 "../lib/sudoku-board.vala"
							_tmp120_ = gee_map_get (_tmp118_, &_tmp119_);
#line 168 "../lib/sudoku-board.vala"
							_tmp121_ = (GeeList*) _tmp120_;
#line 168 "../lib/sudoku-board.vala"
							_tmp122_ = gee_list_get_read_only_view (_tmp121_);
#line 168 "../lib/sudoku-board.vala"
							_tmp123_ = _tmp122_;
#line 168 "../lib/sudoku-board.vala"
							_tmp124_ = _tmp123_;
#line 168 "../lib/sudoku-board.vala"
							gee_map_set (_tmp116_, &_tmp117_, _tmp124_);
#line 168 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp124_);
#line 168 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp121_);
#line 1221 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 170 "../lib/sudoku-board.vala"
	_tmp125_ = self->priv->_coords_for_block;
#line 170 "../lib/sudoku-board.vala"
	_tmp126_ = gee_map_get_read_only_view (_tmp125_);
#line 170 "../lib/sudoku-board.vala"
	_tmp127_ = _tmp126_;
#line 170 "../lib/sudoku-board.vala"
	_tmp128_ = _tmp127_;
#line 170 "../lib/sudoku-board.vala"
	sudoku_board_set_coords_for_block (self, _tmp128_);
#line 170 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp128_);
#line 106 "../lib/sudoku-board.vala"
	return self;
#line 1242 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_new (gint block_rows,
                  gint block_cols)
{
#line 106 "../lib/sudoku-board.vala"
	return sudoku_board_construct (TYPE_SUDOKU_BOARD, block_rows, block_cols);
#line 1251 "sudoku-board.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 176 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 176 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1262 "sudoku-board.c"
	}
#line 176 "../lib/sudoku-board.vala"
	return NULL;
#line 1266 "sudoku-board.c"
}

static gint*
_vala_array_dup2 (gint* self,
                  gssize length)
{
#line 177 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 177 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1277 "sudoku-board.c"
	}
#line 177 "../lib/sudoku-board.vala"
	return NULL;
#line 1281 "sudoku-board.c"
}

static gboolean*
_vala_array_dup3 (gboolean* self,
                  gssize length)
{
#line 178 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 178 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1292 "sudoku-board.c"
	}
#line 178 "../lib/sudoku-board.vala"
	return NULL;
#line 1296 "sudoku-board.c"
}

static gboolean*
_vala_array_dup4 (gboolean* self,
                  gssize length)
{
#line 179 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 179 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1307 "sudoku-board.c"
	}
#line 179 "../lib/sudoku-board.vala"
	return NULL;
#line 1311 "sudoku-board.c"
}

static gboolean*
_vala_array_dup5 (gboolean* self,
                  gssize length)
{
#line 180 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 180 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1322 "sudoku-board.c"
	}
#line 180 "../lib/sudoku-board.vala"
	return NULL;
#line 1326 "sudoku-board.c"
}

static gboolean*
_vala_array_dup6 (gboolean* self,
                  gssize length)
{
#line 181 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 181 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1337 "sudoku-board.c"
	}
#line 181 "../lib/sudoku-board.vala"
	return NULL;
#line 1341 "sudoku-board.c"
}

static gboolean*
_vala_array_dup7 (gboolean* self,
                  gssize length)
{
#line 186 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 186 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1352 "sudoku-board.c"
	}
#line 186 "../lib/sudoku-board.vala"
	return NULL;
#line 1356 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_clone (SudokuBoard* self)
{
	SudokuBoard* board = NULL;
	gint _tmp0_;
	gint _tmp1_;
	SudokuBoard* _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gboolean* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gboolean* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gboolean* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	gint _tmp13__length3;
	gboolean* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	gint _tmp14__length3;
	gint _tmp15_;
	gint _tmp16_;
	GeeSet* _tmp17_;
	GeeSet* _tmp18_;
	gboolean* _tmp19_;
	gint _tmp19__length1;
	gint _tmp19__length2;
	gint _tmp19__length3;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	DifficultyCategory _tmp21_;
	SudokuBoard* result;
#line 173 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 175 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 175 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 175 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_new (_tmp0_, _tmp1_);
#line 175 "../lib/sudoku-board.vala"
	board = _tmp2_;
#line 176 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->cells;
#line 176 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 176 "../lib/sudoku-board.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1 * _tmp3__length2) : _tmp3_;
#line 176 "../lib/sudoku-board.vala"
	_tmp4__length1 = _tmp3__length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp4__length2 = _tmp3__length2;
#line 176 "../lib/sudoku-board.vala"
	board->priv->cells = (g_free (board->priv->cells), NULL);
#line 176 "../lib/sudoku-board.vala"
	board->priv->cells = _tmp4_;
#line 176 "../lib/sudoku-board.vala"
	board->priv->cells_length1 = _tmp4__length1;
#line 176 "../lib/sudoku-board.vala"
	board->priv->cells_length2 = _tmp4__length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp5_ = self->priv->solution;
#line 177 "../lib/sudoku-board.vala"
	_tmp5__length1 = self->priv->solution_length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp5__length2 = self->priv->solution_length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 177 "../lib/sudoku-board.vala"
	_tmp6__length1 = _tmp5__length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp6__length2 = _tmp5__length2;
#line 177 "../lib/sudoku-board.vala"
	board->priv->solution = (g_free (board->priv->solution), NULL);
#line 177 "../lib/sudoku-board.vala"
	board->priv->solution = _tmp6_;
#line 177 "../lib/sudoku-board.vala"
	board->priv->solution_length1 = _tmp6__length1;
#line 177 "../lib/sudoku-board.vala"
	board->priv->solution_length2 = _tmp6__length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->is_fixed;
#line 178 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->is_fixed_length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->is_fixed_length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup3 (_tmp7_, _tmp7__length1 * _tmp7__length2) : _tmp7_;
#line 178 "../lib/sudoku-board.vala"
	_tmp8__length1 = _tmp7__length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp8__length2 = _tmp7__length2;
#line 178 "../lib/sudoku-board.vala"
	board->priv->is_fixed = (g_free (board->priv->is_fixed), NULL);
#line 178 "../lib/sudoku-board.vala"
	board->priv->is_fixed = _tmp8_;
#line 178 "../lib/sudoku-board.vala"
	board->priv->is_fixed_length1 = _tmp8__length1;
#line 178 "../lib/sudoku-board.vala"
	board->priv->is_fixed_length2 = _tmp8__length2;
#line 179 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->possible_in_row;
#line 179 "../lib/sudoku-board.vala"
	_tmp9__length1 = self->priv->possible_in_row_length1;
#line 179 "../lib/sudoku-board.vala"
	_tmp9__length2 = self->priv->possible_in_row_length2;
#line 179 "../lib/sudoku-board.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup4 (_tmp9_, _tmp9__length1 * _tmp9__length2) : _tmp9_;
#line 179 "../lib/sudoku-board.vala"
	_tmp10__length1 = _tmp9__length1;
#line 179 "../lib/sudoku-board.vala"
	_tmp10__length2 = _tmp9__length2;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = (g_free (board->priv->possible_in_row), NULL);
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = _tmp10_;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length1 = _tmp10__length1;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length2 = _tmp10__length2;
#line 180 "../lib/sudoku-board.vala"
	_tmp11_ = self->priv->possible_in_col;
#line 180 "../lib/sudoku-board.vala"
	_tmp11__length1 = self->priv->possible_in_col_length1;
#line 180 "../lib/sudoku-board.vala"
	_tmp11__length2 = self->priv->possible_in_col_length2;
#line 180 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup5 (_tmp11_, _tmp11__length1 * _tmp11__length2) : _tmp11_;
#line 180 "../lib/sudoku-board.vala"
	_tmp12__length1 = _tmp11__length1;
#line 180 "../lib/sudoku-board.vala"
	_tmp12__length2 = _tmp11__length2;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = (g_free (board->priv->possible_in_col), NULL);
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = _tmp12_;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length1 = _tmp12__length1;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length2 = _tmp12__length2;
#line 181 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->possible_in_block;
#line 181 "../lib/sudoku-board.vala"
	_tmp13__length1 = self->priv->possible_in_block_length1;
#line 181 "../lib/sudoku-board.vala"
	_tmp13__length2 = self->priv->possible_in_block_length2;
#line 181 "../lib/sudoku-board.vala"
	_tmp13__length3 = self->priv->possible_in_block_length3;
#line 181 "../lib/sudoku-board.vala"
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup6 (_tmp13_, (_tmp13__length1 * _tmp13__length2) * _tmp13__length3) : _tmp13_;
#line 181 "../lib/sudoku-board.vala"
	_tmp14__length1 = _tmp13__length1;
#line 181 "../lib/sudoku-board.vala"
	_tmp14__length2 = _tmp13__length2;
#line 181 "../lib/sudoku-board.vala"
	_tmp14__length3 = _tmp13__length3;
#line 181 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = (g_free (board->priv->possible_in_block), NULL);
#line 181 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = _tmp14_;
#line 181 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length1 = _tmp14__length1;
#line 181 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length2 = _tmp14__length2;
#line 181 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length3 = _tmp14__length3;
#line 182 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->_filled;
#line 182 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (board, _tmp15_);
#line 183 "../lib/sudoku-board.vala"
	_tmp16_ = self->priv->_fixed;
#line 183 "../lib/sudoku-board.vala"
	sudoku_board_set_fixed (board, _tmp16_);
#line 184 "../lib/sudoku-board.vala"
	board->priv->n_earmarks = self->priv->n_earmarks;
#line 185 "../lib/sudoku-board.vala"
	_tmp17_ = board->priv->_broken_coords;
#line 185 "../lib/sudoku-board.vala"
	_tmp18_ = self->priv->_broken_coords;
#line 185 "../lib/sudoku-board.vala"
	gee_collection_add_all ((GeeCollection*) _tmp17_, (GeeCollection*) _tmp18_);
#line 186 "../lib/sudoku-board.vala"
	_tmp19_ = self->priv->earmarks;
#line 186 "../lib/sudoku-board.vala"
	_tmp19__length1 = self->priv->earmarks_length1;
#line 186 "../lib/sudoku-board.vala"
	_tmp19__length2 = self->priv->earmarks_length2;
#line 186 "../lib/sudoku-board.vala"
	_tmp19__length3 = self->priv->earmarks_length3;
#line 186 "../lib/sudoku-board.vala"
	_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup7 (_tmp19_, (_tmp19__length1 * _tmp19__length2) * _tmp19__length3) : _tmp19_;
#line 186 "../lib/sudoku-board.vala"
	_tmp20__length1 = _tmp19__length1;
#line 186 "../lib/sudoku-board.vala"
	_tmp20__length2 = _tmp19__length2;
#line 186 "../lib/sudoku-board.vala"
	_tmp20__length3 = _tmp19__length3;
#line 186 "../lib/sudoku-board.vala"
	board->priv->earmarks = (g_free (board->priv->earmarks), NULL);
#line 186 "../lib/sudoku-board.vala"
	board->priv->earmarks = _tmp20_;
#line 186 "../lib/sudoku-board.vala"
	board->priv->earmarks_length1 = _tmp20__length1;
#line 186 "../lib/sudoku-board.vala"
	board->priv->earmarks_length2 = _tmp20__length2;
#line 186 "../lib/sudoku-board.vala"
	board->priv->earmarks_length3 = _tmp20__length3;
#line 187 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_difficulty_category;
#line 187 "../lib/sudoku-board.vala"
	sudoku_board_set_difficulty_category (board, _tmp21_);
#line 189 "../lib/sudoku-board.vala"
	result = board;
#line 189 "../lib/sudoku-board.vala"
	return result;
#line 1604 "sudoku-board.c"
}

gboolean
sudoku_board_get_is_fixed (SudokuBoard* self,
                           gint row,
                           gint column)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean _tmp1_;
	gboolean result;
#line 192 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 194 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->is_fixed;
#line 194 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->is_fixed_length1;
#line 194 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->is_fixed_length2;
#line 194 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + column];
#line 194 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 194 "../lib/sudoku-board.vala"
	return result;
#line 1631 "sudoku-board.c"
}

void
sudoku_board_set_is_fixed (SudokuBoard* self,
                           gint row,
                           gint column,
                           gboolean _value)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 197 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 199 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->is_fixed;
#line 199 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->is_fixed_length1;
#line 199 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->is_fixed_length2;
#line 199 "../lib/sudoku-board.vala"
	_tmp0_[(row * _tmp0__length2) + column] = _value;
#line 1653 "sudoku-board.c"
}

void
sudoku_board_enable_earmark (SudokuBoard* self,
                             gint row,
                             gint column,
                             gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 202 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 205 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 205 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 205 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 205 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 205 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 205 "../lib/sudoku-board.vala"
	if (!_tmp1_) {
#line 1681 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 207 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 207 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 207 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 207 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 207 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = TRUE;
#line 208 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 208 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ + 1;
#line 209 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL], 0, row, column, digit, TRUE);
#line 1703 "sudoku-board.c"
	}
#line 202 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks > 0, "n_earmarks > 0");
#line 1707 "sudoku-board.c"
}

void
sudoku_board_disable_earmark (SudokuBoard* self,
                              gint row,
                              gint column,
                              gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 213 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 216 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 216 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 216 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 216 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 216 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 216 "../lib/sudoku-board.vala"
	if (_tmp1_) {
#line 1735 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 218 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 218 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 218 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 218 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 218 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = FALSE;
#line 219 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 219 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ - 1;
#line 220 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL], 0, row, column, digit, FALSE);
#line 1757 "sudoku-board.c"
	}
#line 213 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1761 "sudoku-board.c"
}

void
sudoku_board_disable_all_earmarks (SudokuBoard* self,
                                   gint row,
                                   gint column)
{
#line 224 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 1771 "sudoku-board.c"
	{
		gint i = 0;
#line 227 "../lib/sudoku-board.vala"
		i = 1;
#line 1776 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 227 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 227 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1783 "sudoku-board.c"
				gint _tmp2_;
				gint _tmp3_;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp4__length3;
				gboolean _tmp5_;
#line 227 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 1793 "sudoku-board.c"
					gint _tmp1_;
#line 227 "../lib/sudoku-board.vala"
					_tmp1_ = i;
#line 227 "../lib/sudoku-board.vala"
					i = _tmp1_ + 1;
#line 1799 "sudoku-board.c"
				}
#line 227 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 227 "../lib/sudoku-board.vala"
				_tmp2_ = sudoku_board_get_max_val (self);
#line 227 "../lib/sudoku-board.vala"
				_tmp3_ = _tmp2_;
#line 227 "../lib/sudoku-board.vala"
				if (!(i <= _tmp3_)) {
#line 227 "../lib/sudoku-board.vala"
					break;
#line 1811 "sudoku-board.c"
				}
#line 228 "../lib/sudoku-board.vala"
				_tmp4_ = self->priv->earmarks;
#line 228 "../lib/sudoku-board.vala"
				_tmp4__length1 = self->priv->earmarks_length1;
#line 228 "../lib/sudoku-board.vala"
				_tmp4__length2 = self->priv->earmarks_length2;
#line 228 "../lib/sudoku-board.vala"
				_tmp4__length3 = self->priv->earmarks_length3;
#line 228 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (i - 1)];
#line 228 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 229 "../lib/sudoku-board.vala"
					sudoku_board_disable_earmark (self, row, column, i);
#line 1827 "sudoku-board.c"
				}
			}
		}
	}
#line 224 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1834 "sudoku-board.c"
}

gboolean
sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                 gint row,
                                 gint column,
                                 gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
	gboolean result;
#line 232 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 234 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 234 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 234 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 234 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 234 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 234 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 234 "../lib/sudoku-board.vala"
	return result;
#line 1865 "sudoku-board.c"
}

gboolean
sudoku_board_is_possible (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gboolean _tmp4_;
	gboolean result;
#line 237 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../lib/sudoku-board.vala"
	_tmp0_ = val;
#line 239 "../lib/sudoku-board.vala"
	val = _tmp0_ - 1;
#line 240 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->possible_in_row;
#line 240 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->possible_in_row_length1;
#line 240 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->possible_in_row_length2;
#line 240 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + val];
#line 240 "../lib/sudoku-board.vala"
	if (_tmp4_) {
#line 1898 "sudoku-board.c"
		gboolean* _tmp5_;
		gint _tmp5__length1;
		gint _tmp5__length2;
		gboolean _tmp6_;
#line 240 "../lib/sudoku-board.vala"
		_tmp5_ = self->priv->possible_in_col;
#line 240 "../lib/sudoku-board.vala"
		_tmp5__length1 = self->priv->possible_in_col_length1;
#line 240 "../lib/sudoku-board.vala"
		_tmp5__length2 = self->priv->possible_in_col_length2;
#line 240 "../lib/sudoku-board.vala"
		_tmp6_ = _tmp5_[(col * _tmp5__length2) + val];
#line 240 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp6_;
#line 1913 "sudoku-board.c"
	} else {
#line 240 "../lib/sudoku-board.vala"
		_tmp2_ = FALSE;
#line 1917 "sudoku-board.c"
	}
#line 240 "../lib/sudoku-board.vala"
	if (_tmp2_) {
#line 1921 "sudoku-board.c"
		gboolean* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp7__length3;
		gint _tmp8_;
		gint _tmp9_;
		gboolean _tmp10_;
#line 240 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->possible_in_block;
#line 240 "../lib/sudoku-board.vala"
		_tmp7__length1 = self->priv->possible_in_block_length1;
#line 240 "../lib/sudoku-board.vala"
		_tmp7__length2 = self->priv->possible_in_block_length2;
#line 240 "../lib/sudoku-board.vala"
		_tmp7__length3 = self->priv->possible_in_block_length3;
#line 240 "../lib/sudoku-board.vala"
		_tmp8_ = self->priv->_block_cols;
#line 240 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_block_rows;
#line 240 "../lib/sudoku-board.vala"
		_tmp10_ = _tmp7_[((((row / _tmp8_) * _tmp7__length2) + (col / _tmp9_)) * _tmp7__length3) + val];
#line 240 "../lib/sudoku-board.vala"
		_tmp1_ = _tmp10_;
#line 1945 "sudoku-board.c"
	} else {
#line 240 "../lib/sudoku-board.vala"
		_tmp1_ = FALSE;
#line 1949 "sudoku-board.c"
	}
#line 240 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 240 "../lib/sudoku-board.vala"
	return result;
#line 1955 "sudoku-board.c"
}

gint
sudoku_board_count_possibilities (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result;
#line 243 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 245 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_possibilities (self, row, col, &_tmp0_);
#line 245 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 245 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp0_;
#line 245 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp0_;
#line 245 "../lib/sudoku-board.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 245 "../lib/sudoku-board.vala"
	result = _tmp3_;
#line 245 "../lib/sudoku-board.vala"
	return result;
#line 1985 "sudoku-board.c"
}

static gint*
_vala_array_dup8 (gint* self,
                  gssize length)
{
#line 264 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 264 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1996 "sudoku-board.c"
	}
#line 264 "../lib/sudoku-board.vala"
	return NULL;
#line 2000 "sudoku-board.c"
}

gint*
sudoku_board_get_possibilities (SudokuBoard* self,
                                gint row,
                                gint col,
                                gint* result_length1)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* possibilities = NULL;
	gint* _tmp4_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gint count = 0;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* _tmp13_;
	gint _tmp13__length1;
	gint* result;
#line 248 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 250 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 250 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 250 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 250 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 250 "../lib/sudoku-board.vala"
	if (_tmp1_ != 0) {
#line 2037 "sudoku-board.c"
		gint* _tmp2_;
		gint* _tmp3_;
		gint _tmp3__length1;
#line 251 "../lib/sudoku-board.vala"
		_tmp2_ = g_new0 (gint, 0);
#line 251 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 251 "../lib/sudoku-board.vala"
		_tmp3__length1 = 0;
#line 251 "../lib/sudoku-board.vala"
		if (result_length1) {
#line 251 "../lib/sudoku-board.vala"
			*result_length1 = _tmp3__length1;
#line 2051 "sudoku-board.c"
		}
#line 251 "../lib/sudoku-board.vala"
		result = _tmp3_;
#line 251 "../lib/sudoku-board.vala"
		return result;
#line 2057 "sudoku-board.c"
	}
#line 253 "../lib/sudoku-board.vala"
	_tmp4_ = g_new0 (gint, 9);
#line 253 "../lib/sudoku-board.vala"
	possibilities = _tmp4_;
#line 253 "../lib/sudoku-board.vala"
	possibilities_length1 = 9;
#line 253 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 254 "../lib/sudoku-board.vala"
	count = 0;
#line 2069 "sudoku-board.c"
	{
		gint l = 0;
#line 256 "../lib/sudoku-board.vala"
		l = 1;
#line 2074 "sudoku-board.c"
		{
			gboolean _tmp5_ = FALSE;
#line 256 "../lib/sudoku-board.vala"
			_tmp5_ = TRUE;
#line 256 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2081 "sudoku-board.c"
				gint _tmp7_;
				gint _tmp8_;
#line 256 "../lib/sudoku-board.vala"
				if (!_tmp5_) {
#line 2086 "sudoku-board.c"
					gint _tmp6_;
#line 256 "../lib/sudoku-board.vala"
					_tmp6_ = l;
#line 256 "../lib/sudoku-board.vala"
					l = _tmp6_ + 1;
#line 2092 "sudoku-board.c"
				}
#line 256 "../lib/sudoku-board.vala"
				_tmp5_ = FALSE;
#line 256 "../lib/sudoku-board.vala"
				_tmp7_ = sudoku_board_get_max_val (self);
#line 256 "../lib/sudoku-board.vala"
				_tmp8_ = _tmp7_;
#line 256 "../lib/sudoku-board.vala"
				if (!(l <= _tmp8_)) {
#line 256 "../lib/sudoku-board.vala"
					break;
#line 2104 "sudoku-board.c"
				}
#line 258 "../lib/sudoku-board.vala"
				if (sudoku_board_is_possible (self, row, col, l)) {
#line 2108 "sudoku-board.c"
					gint* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
#line 260 "../lib/sudoku-board.vala"
					_tmp9_ = possibilities;
#line 260 "../lib/sudoku-board.vala"
					_tmp9__length1 = possibilities_length1;
#line 260 "../lib/sudoku-board.vala"
					_tmp9_[count] = l;
#line 261 "../lib/sudoku-board.vala"
					_tmp10_ = count;
#line 261 "../lib/sudoku-board.vala"
					count = _tmp10_ + 1;
#line 2122 "sudoku-board.c"
				}
			}
		}
	}
#line 264 "../lib/sudoku-board.vala"
	_tmp11_ = possibilities;
#line 264 "../lib/sudoku-board.vala"
	_tmp11__length1 = possibilities_length1;
#line 264 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup8 (_tmp11_ + 0, count - 0) : _tmp11_;
#line 264 "../lib/sudoku-board.vala"
	_tmp12__length1 = count - 0;
#line 264 "../lib/sudoku-board.vala"
	_tmp13_ = _tmp12_;
#line 264 "../lib/sudoku-board.vala"
	_tmp13__length1 = _tmp12__length1;
#line 264 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 264 "../lib/sudoku-board.vala"
		*result_length1 = _tmp13__length1;
#line 2143 "sudoku-board.c"
	}
#line 264 "../lib/sudoku-board.vala"
	result = _tmp13_;
#line 264 "../lib/sudoku-board.vala"
	possibilities = (g_free (possibilities), NULL);
#line 264 "../lib/sudoku-board.vala"
	return result;
#line 2151 "sudoku-board.c"
}

gboolean*
sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self,
                                              gint row,
                                              gint col,
                                              gint* result_length1)
{
	gboolean* possibilities = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result;
#line 267 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 269 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 269 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 269 "../lib/sudoku-board.vala"
	possibilities = _tmp2_;
#line 269 "../lib/sudoku-board.vala"
	possibilities_length1 = _tmp1_;
#line 269 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 2183 "sudoku-board.c"
	{
		gint l = 0;
#line 271 "../lib/sudoku-board.vala"
		l = 1;
#line 2188 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 271 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 271 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2195 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
#line 271 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 2202 "sudoku-board.c"
					gint _tmp4_;
#line 271 "../lib/sudoku-board.vala"
					_tmp4_ = l;
#line 271 "../lib/sudoku-board.vala"
					l = _tmp4_ + 1;
#line 2208 "sudoku-board.c"
				}
#line 271 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 271 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 271 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 271 "../lib/sudoku-board.vala"
				if (!(l <= _tmp6_)) {
#line 271 "../lib/sudoku-board.vala"
					break;
#line 2220 "sudoku-board.c"
				}
#line 272 "../lib/sudoku-board.vala"
				_tmp7_ = possibilities;
#line 272 "../lib/sudoku-board.vala"
				_tmp7__length1 = possibilities_length1;
#line 272 "../lib/sudoku-board.vala"
				_tmp7_[l - 1] = sudoku_board_is_possible (self, row, col, l);
#line 2228 "sudoku-board.c"
			}
		}
	}
#line 274 "../lib/sudoku-board.vala"
	_tmp8_ = possibilities;
#line 274 "../lib/sudoku-board.vala"
	_tmp8__length1 = possibilities_length1;
#line 274 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 274 "../lib/sudoku-board.vala"
		*result_length1 = _tmp8__length1;
#line 2240 "sudoku-board.c"
	}
#line 274 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 274 "../lib/sudoku-board.vala"
	return result;
#line 2246 "sudoku-board.c"
}

void
sudoku_board_get_block_for (SudokuBoard* self,
                            gint row,
                            gint col,
                            Coord* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Coord _tmp2_ = {0};
#line 277 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 279 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 279 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 279 "../lib/sudoku-board.vala"
	coord_init (&_tmp2_, row / _tmp0_, col / _tmp1_);
#line 279 "../lib/sudoku-board.vala"
	*result = _tmp2_;
#line 279 "../lib/sudoku-board.vala"
	return;
#line 2270 "sudoku-board.c"
}

void
sudoku_board_insert (SudokuBoard* self,
                     gint row,
                     gint col,
                     gint val,
                     gboolean is_fixed)
{
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gint _tmp8_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean _tmp11_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	gboolean _tmp16_;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	gint _tmp30_;
	gboolean* _tmp31_;
	gint _tmp31__length1;
	gint _tmp31__length2;
	gboolean* _tmp32_;
	gint _tmp32__length1;
	gint _tmp32__length2;
	gboolean* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	gint _tmp33__length3;
	gint _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
#line 282 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 282 "../lib/sudoku-board.vala"
	_vala_return_if_fail (val > 0, "val > 0");
#line 282 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 282 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 282 "../lib/sudoku-board.vala"
	_vala_return_if_fail (val <= _tmp1_, "val <= max_val");
#line 287 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2335 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 288 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->is_fixed;
#line 288 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->is_fixed_length1;
#line 288 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->is_fixed_length2;
#line 288 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 288 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2350 "sudoku-board.c"
	}
#line 291 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->cells;
#line 291 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 291 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 291 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 291 "../lib/sudoku-board.vala"
	if (_tmp5_ != 0) {
#line 292 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, is_fixed);
#line 2364 "sudoku-board.c"
	}
#line 294 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->cells;
#line 294 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 294 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 294 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = val;
#line 295 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->is_fixed;
#line 295 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->priv->is_fixed_length1;
#line 295 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->priv->is_fixed_length2;
#line 295 "../lib/sudoku-board.vala"
	_tmp7_[(row * _tmp7__length2) + col] = is_fixed;
#line 296 "../lib/sudoku-board.vala"
	_tmp8_ = self->priv->_filled;
#line 296 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp8_ + 1);
#line 297 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2388 "sudoku-board.c"
		gint _tmp9_;
#line 298 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_fixed;
#line 298 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp9_ + 1);
#line 2394 "sudoku-board.c"
	}
#line 300 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->possible_in_row;
#line 300 "../lib/sudoku-board.vala"
	_tmp10__length1 = self->priv->possible_in_row_length1;
#line 300 "../lib/sudoku-board.vala"
	_tmp10__length2 = self->priv->possible_in_row_length2;
#line 300 "../lib/sudoku-board.vala"
	_tmp11_ = _tmp10_[(row * _tmp10__length2) + (val - 1)];
#line 300 "../lib/sudoku-board.vala"
	if (!_tmp11_) {
#line 2406 "sudoku-board.c"
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
#line 301 "../lib/sudoku-board.vala"
		_tmp12_ = self->priv->_coords_for_row;
#line 301 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, row);
#line 301 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 301 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp14_, val);
#line 301 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 2420 "sudoku-board.c"
	}
#line 303 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->possible_in_col;
#line 303 "../lib/sudoku-board.vala"
	_tmp15__length1 = self->priv->possible_in_col_length1;
#line 303 "../lib/sudoku-board.vala"
	_tmp15__length2 = self->priv->possible_in_col_length2;
#line 303 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_[(col * _tmp15__length2) + (val - 1)];
#line 303 "../lib/sudoku-board.vala"
	if (!_tmp16_) {
#line 2432 "sudoku-board.c"
		GeeList* _tmp17_;
		gpointer _tmp18_;
		GeeList* _tmp19_;
#line 304 "../lib/sudoku-board.vala"
		_tmp17_ = self->priv->_coords_for_col;
#line 304 "../lib/sudoku-board.vala"
		_tmp18_ = gee_list_get (_tmp17_, col);
#line 304 "../lib/sudoku-board.vala"
		_tmp19_ = (GeeList*) _tmp18_;
#line 304 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp19_, val);
#line 304 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp19_);
#line 2446 "sudoku-board.c"
	}
#line 306 "../lib/sudoku-board.vala"
	_tmp20_ = self->priv->possible_in_block;
#line 306 "../lib/sudoku-board.vala"
	_tmp20__length1 = self->priv->possible_in_block_length1;
#line 306 "../lib/sudoku-board.vala"
	_tmp20__length2 = self->priv->possible_in_block_length2;
#line 306 "../lib/sudoku-board.vala"
	_tmp20__length3 = self->priv->possible_in_block_length3;
#line 306 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_block_cols;
#line 306 "../lib/sudoku-board.vala"
	_tmp22_ = self->priv->_block_rows;
#line 306 "../lib/sudoku-board.vala"
	_tmp23_ = _tmp20_[((((row / _tmp21_) * _tmp20__length2) + (col / _tmp22_)) * _tmp20__length3) + (val - 1)];
#line 306 "../lib/sudoku-board.vala"
	if (!_tmp23_) {
#line 2464 "sudoku-board.c"
		GeeMap* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		Coord _tmp27_ = {0};
		gpointer _tmp28_;
		GeeList* _tmp29_;
#line 307 "../lib/sudoku-board.vala"
		_tmp24_ = self->priv->_coords_for_block;
#line 307 "../lib/sudoku-board.vala"
		_tmp25_ = self->priv->_block_cols;
#line 307 "../lib/sudoku-board.vala"
		_tmp26_ = self->priv->_block_rows;
#line 307 "../lib/sudoku-board.vala"
		coord_init (&_tmp27_, row / _tmp25_, col / _tmp26_);
#line 307 "../lib/sudoku-board.vala"
		_tmp28_ = gee_map_get (_tmp24_, &_tmp27_);
#line 307 "../lib/sudoku-board.vala"
		_tmp29_ = (GeeList*) _tmp28_;
#line 307 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp29_, val);
#line 307 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp29_);
#line 2487 "sudoku-board.c"
	}
#line 310 "../lib/sudoku-board.vala"
	_tmp30_ = val;
#line 310 "../lib/sudoku-board.vala"
	val = _tmp30_ - 1;
#line 311 "../lib/sudoku-board.vala"
	_tmp31_ = self->priv->possible_in_row;
#line 311 "../lib/sudoku-board.vala"
	_tmp31__length1 = self->priv->possible_in_row_length1;
#line 311 "../lib/sudoku-board.vala"
	_tmp31__length2 = self->priv->possible_in_row_length2;
#line 311 "../lib/sudoku-board.vala"
	_tmp31_[(row * _tmp31__length2) + val] = FALSE;
#line 312 "../lib/sudoku-board.vala"
	_tmp32_ = self->priv->possible_in_col;
#line 312 "../lib/sudoku-board.vala"
	_tmp32__length1 = self->priv->possible_in_col_length1;
#line 312 "../lib/sudoku-board.vala"
	_tmp32__length2 = self->priv->possible_in_col_length2;
#line 312 "../lib/sudoku-board.vala"
	_tmp32_[(col * _tmp32__length2) + val] = FALSE;
#line 313 "../lib/sudoku-board.vala"
	_tmp33_ = self->priv->possible_in_block;
#line 313 "../lib/sudoku-board.vala"
	_tmp33__length1 = self->priv->possible_in_block_length1;
#line 313 "../lib/sudoku-board.vala"
	_tmp33__length2 = self->priv->possible_in_block_length2;
#line 313 "../lib/sudoku-board.vala"
	_tmp33__length3 = self->priv->possible_in_block_length3;
#line 313 "../lib/sudoku-board.vala"
	_tmp34_ = self->priv->_block_cols;
#line 313 "../lib/sudoku-board.vala"
	_tmp35_ = self->priv->_block_rows;
#line 313 "../lib/sudoku-board.vala"
	_tmp33_[((((row / _tmp34_) * _tmp33__length2) + (col / _tmp35_)) * _tmp33__length3) + val] = FALSE;
#line 315 "../lib/sudoku-board.vala"
	_tmp36_ = sudoku_board_get_complete (self);
#line 315 "../lib/sudoku-board.vala"
	_tmp37_ = _tmp36_;
#line 315 "../lib/sudoku-board.vala"
	if (_tmp37_) {
#line 316 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL], 0);
#line 2531 "sudoku-board.c"
	}
}

void
sudoku_board_set (SudokuBoard* self,
                  gint row,
                  gint col,
                  gint val)
{
#line 319 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 321 "../lib/sudoku-board.vala"
	if (val == 0) {
#line 322 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, FALSE);
#line 2547 "sudoku-board.c"
	} else {
		gboolean _tmp0_ = FALSE;
#line 323 "../lib/sudoku-board.vala"
		if (val > 0) {
#line 2552 "sudoku-board.c"
			gint _tmp1_;
			gint _tmp2_;
#line 323 "../lib/sudoku-board.vala"
			_tmp1_ = sudoku_board_get_max_val (self);
#line 323 "../lib/sudoku-board.vala"
			_tmp2_ = _tmp1_;
#line 323 "../lib/sudoku-board.vala"
			_tmp0_ = val <= _tmp2_;
#line 2561 "sudoku-board.c"
		} else {
#line 323 "../lib/sudoku-board.vala"
			_tmp0_ = FALSE;
#line 2565 "sudoku-board.c"
		}
#line 323 "../lib/sudoku-board.vala"
		if (_tmp0_) {
#line 324 "../lib/sudoku-board.vala"
			sudoku_board_insert (self, row, col, val, FALSE);
#line 2571 "sudoku-board.c"
		} else {
#line 326 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 2575 "sudoku-board.c"
		}
	}
}

gint
sudoku_board_get (SudokuBoard* self,
                  gint row,
                  gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint result;
#line 329 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 331 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 331 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 331 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 331 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 331 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 331 "../lib/sudoku-board.vala"
	return result;
#line 2604 "sudoku-board.c"
}

void
sudoku_board_remove (SudokuBoard* self,
                     gint row,
                     gint col,
                     gboolean is_fixed)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint previous_val = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GeeSet* _tmp7_;
	Coord _tmp8_ = {0};
	gint _tmp70_;
#line 334 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 334 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 334 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 334 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 334 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 334 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp1_ > 0, "cells[row, col] > 0");
#line 338 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2642 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 339 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->is_fixed;
#line 339 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->is_fixed_length1;
#line 339 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->is_fixed_length2;
#line 339 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 339 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2657 "sudoku-board.c"
	}
#line 341 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->cells;
#line 341 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 341 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 341 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 341 "../lib/sudoku-board.vala"
	previous_val = _tmp5_;
#line 342 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->cells;
#line 342 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 342 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 342 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = 0;
#line 344 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_broken_coords;
#line 344 "../lib/sudoku-board.vala"
	coord_init (&_tmp8_, row, col);
#line 344 "../lib/sudoku-board.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp7_, &_tmp8_)) {
#line 2683 "sudoku-board.c"
		GeeList* _tmp9_;
		gpointer _tmp10_;
		GeeList* _tmp11_;
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
		GeeMap* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		Coord _tmp18_ = {0};
		gpointer _tmp19_;
		GeeList* _tmp20_;
		GeeSet* _tmp21_;
		Coord _tmp22_ = {0};
		GeeList* _tmp23_;
		gpointer _tmp24_;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
		gpointer _tmp27_;
		GeeList* _tmp28_;
		GeeMap* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		Coord _tmp32_ = {0};
		gpointer _tmp33_;
		GeeList* _tmp34_;
		gboolean* _tmp35_;
		gint _tmp35__length1;
		gint _tmp35__length2;
		GeeList* _tmp36_;
		gpointer _tmp37_;
		GeeList* _tmp38_;
		GeeSet* _tmp39_;
		GeeSet* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gboolean* _tmp43_;
		gint _tmp43__length1;
		gint _tmp43__length2;
		GeeList* _tmp44_;
		gpointer _tmp45_;
		GeeList* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		gboolean* _tmp51_;
		gint _tmp51__length1;
		gint _tmp51__length2;
		gint _tmp51__length3;
		gint _tmp52_;
		gint _tmp53_;
		GeeMap* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		Coord _tmp57_ = {0};
		gpointer _tmp58_;
		GeeList* _tmp59_;
		GeeSet* _tmp60_;
		GeeSet* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
#line 347 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_coords_for_row;
#line 347 "../lib/sudoku-board.vala"
		_tmp10_ = gee_list_get (_tmp9_, row);
#line 347 "../lib/sudoku-board.vala"
		_tmp11_ = (GeeList*) _tmp10_;
#line 347 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp11_, previous_val);
#line 347 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp11_);
#line 348 "../lib/sudoku-board.vala"
		_tmp12_ = self->priv->_coords_for_col;
#line 348 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, col);
#line 348 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 348 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp14_, previous_val);
#line 348 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 349 "../lib/sudoku-board.vala"
		_tmp15_ = self->priv->_coords_for_block;
#line 349 "../lib/sudoku-board.vala"
		_tmp16_ = self->priv->_block_rows;
#line 349 "../lib/sudoku-board.vala"
		_tmp17_ = self->priv->_block_cols;
#line 349 "../lib/sudoku-board.vala"
		coord_init (&_tmp18_, row / _tmp16_, col / _tmp17_);
#line 349 "../lib/sudoku-board.vala"
		_tmp19_ = gee_map_get (_tmp15_, &_tmp18_);
#line 349 "../lib/sudoku-board.vala"
		_tmp20_ = (GeeList*) _tmp19_;
#line 349 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp20_, previous_val);
#line 349 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp20_);
#line 350 "../lib/sudoku-board.vala"
		_tmp21_ = self->priv->_broken_coords;
#line 350 "../lib/sudoku-board.vala"
		coord_init (&_tmp22_, row, col);
#line 350 "../lib/sudoku-board.vala"
		gee_collection_remove ((GeeCollection*) _tmp21_, &_tmp22_);
#line 353 "../lib/sudoku-board.vala"
		_tmp23_ = self->priv->_coords_for_row;
#line 353 "../lib/sudoku-board.vala"
		_tmp24_ = gee_list_get (_tmp23_, row);
#line 353 "../lib/sudoku-board.vala"
		_tmp25_ = (GeeList*) _tmp24_;
#line 353 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp25_, previous_val);
#line 353 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp25_);
#line 354 "../lib/sudoku-board.vala"
		_tmp26_ = self->priv->_coords_for_col;
#line 354 "../lib/sudoku-board.vala"
		_tmp27_ = gee_list_get (_tmp26_, col);
#line 354 "../lib/sudoku-board.vala"
		_tmp28_ = (GeeList*) _tmp27_;
#line 354 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp28_, previous_val);
#line 354 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp28_);
#line 355 "../lib/sudoku-board.vala"
		_tmp29_ = self->priv->_coords_for_block;
#line 355 "../lib/sudoku-board.vala"
		_tmp30_ = self->priv->_block_rows;
#line 355 "../lib/sudoku-board.vala"
		_tmp31_ = self->priv->_block_cols;
#line 355 "../lib/sudoku-board.vala"
		coord_init (&_tmp32_, row / _tmp30_, col / _tmp31_);
#line 355 "../lib/sudoku-board.vala"
		_tmp33_ = gee_map_get (_tmp29_, &_tmp32_);
#line 355 "../lib/sudoku-board.vala"
		_tmp34_ = (GeeList*) _tmp33_;
#line 355 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp34_, previous_val);
#line 355 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp34_);
#line 358 "../lib/sudoku-board.vala"
		_tmp35_ = self->priv->possible_in_row;
#line 358 "../lib/sudoku-board.vala"
		_tmp35__length1 = self->priv->possible_in_row_length1;
#line 358 "../lib/sudoku-board.vala"
		_tmp35__length2 = self->priv->possible_in_row_length2;
#line 358 "../lib/sudoku-board.vala"
		_tmp36_ = self->priv->_coords_for_row;
#line 358 "../lib/sudoku-board.vala"
		_tmp37_ = gee_list_get (_tmp36_, row);
#line 358 "../lib/sudoku-board.vala"
		_tmp38_ = (GeeList*) _tmp37_;
#line 358 "../lib/sudoku-board.vala"
		_tmp39_ = sudoku_board_get_occurances (self, _tmp38_, previous_val);
#line 358 "../lib/sudoku-board.vala"
		_tmp40_ = _tmp39_;
#line 358 "../lib/sudoku-board.vala"
		_tmp41_ = gee_collection_get_size ((GeeCollection*) _tmp40_);
#line 358 "../lib/sudoku-board.vala"
		_tmp42_ = _tmp41_;
#line 358 "../lib/sudoku-board.vala"
		_tmp35_[(row * _tmp35__length2) + (previous_val - 1)] = _tmp42_ == 0;
#line 358 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp40_);
#line 358 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp38_);
#line 359 "../lib/sudoku-board.vala"
		_tmp43_ = self->priv->possible_in_col;
#line 359 "../lib/sudoku-board.vala"
		_tmp43__length1 = self->priv->possible_in_col_length1;
#line 359 "../lib/sudoku-board.vala"
		_tmp43__length2 = self->priv->possible_in_col_length2;
#line 359 "../lib/sudoku-board.vala"
		_tmp44_ = self->priv->_coords_for_col;
#line 359 "../lib/sudoku-board.vala"
		_tmp45_ = gee_list_get (_tmp44_, col);
#line 359 "../lib/sudoku-board.vala"
		_tmp46_ = (GeeList*) _tmp45_;
#line 359 "../lib/sudoku-board.vala"
		_tmp47_ = sudoku_board_get_occurances (self, _tmp46_, previous_val);
#line 359 "../lib/sudoku-board.vala"
		_tmp48_ = _tmp47_;
#line 359 "../lib/sudoku-board.vala"
		_tmp49_ = gee_collection_get_size ((GeeCollection*) _tmp48_);
#line 359 "../lib/sudoku-board.vala"
		_tmp50_ = _tmp49_;
#line 359 "../lib/sudoku-board.vala"
		_tmp43_[(col * _tmp43__length2) + (previous_val - 1)] = _tmp50_ == 0;
#line 359 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp48_);
#line 359 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp46_);
#line 360 "../lib/sudoku-board.vala"
		_tmp51_ = self->priv->possible_in_block;
#line 360 "../lib/sudoku-board.vala"
		_tmp51__length1 = self->priv->possible_in_block_length1;
#line 360 "../lib/sudoku-board.vala"
		_tmp51__length2 = self->priv->possible_in_block_length2;
#line 360 "../lib/sudoku-board.vala"
		_tmp51__length3 = self->priv->possible_in_block_length3;
#line 360 "../lib/sudoku-board.vala"
		_tmp52_ = self->priv->_block_cols;
#line 360 "../lib/sudoku-board.vala"
		_tmp53_ = self->priv->_block_rows;
#line 360 "../lib/sudoku-board.vala"
		_tmp54_ = self->priv->_coords_for_block;
#line 360 "../lib/sudoku-board.vala"
		_tmp55_ = self->priv->_block_rows;
#line 360 "../lib/sudoku-board.vala"
		_tmp56_ = self->priv->_block_cols;
#line 360 "../lib/sudoku-board.vala"
		coord_init (&_tmp57_, row / _tmp55_, col / _tmp56_);
#line 360 "../lib/sudoku-board.vala"
		_tmp58_ = gee_map_get (_tmp54_, &_tmp57_);
#line 360 "../lib/sudoku-board.vala"
		_tmp59_ = (GeeList*) _tmp58_;
#line 360 "../lib/sudoku-board.vala"
		_tmp60_ = sudoku_board_get_occurances (self, _tmp59_, previous_val);
#line 360 "../lib/sudoku-board.vala"
		_tmp61_ = _tmp60_;
#line 360 "../lib/sudoku-board.vala"
		_tmp62_ = gee_collection_get_size ((GeeCollection*) _tmp61_);
#line 360 "../lib/sudoku-board.vala"
		_tmp63_ = _tmp62_;
#line 360 "../lib/sudoku-board.vala"
		_tmp51_[((((row / _tmp52_) * _tmp51__length2) + (col / _tmp53_)) * _tmp51__length3) + (previous_val - 1)] = _tmp63_ == 0;
#line 360 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp61_);
#line 360 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp59_);
#line 2914 "sudoku-board.c"
	} else {
		gint _tmp64_;
		gboolean* _tmp65_;
		gint _tmp65__length1;
		gint _tmp65__length2;
		gboolean* _tmp66_;
		gint _tmp66__length1;
		gint _tmp66__length2;
		gboolean* _tmp67_;
		gint _tmp67__length1;
		gint _tmp67__length2;
		gint _tmp67__length3;
		gint _tmp68_;
		gint _tmp69_;
#line 364 "../lib/sudoku-board.vala"
		_tmp64_ = previous_val;
#line 364 "../lib/sudoku-board.vala"
		previous_val = _tmp64_ - 1;
#line 366 "../lib/sudoku-board.vala"
		_tmp65_ = self->priv->possible_in_row;
#line 366 "../lib/sudoku-board.vala"
		_tmp65__length1 = self->priv->possible_in_row_length1;
#line 366 "../lib/sudoku-board.vala"
		_tmp65__length2 = self->priv->possible_in_row_length2;
#line 366 "../lib/sudoku-board.vala"
		_tmp65_[(row * _tmp65__length2) + previous_val] = TRUE;
#line 367 "../lib/sudoku-board.vala"
		_tmp66_ = self->priv->possible_in_col;
#line 367 "../lib/sudoku-board.vala"
		_tmp66__length1 = self->priv->possible_in_col_length1;
#line 367 "../lib/sudoku-board.vala"
		_tmp66__length2 = self->priv->possible_in_col_length2;
#line 367 "../lib/sudoku-board.vala"
		_tmp66_[(col * _tmp66__length2) + previous_val] = TRUE;
#line 368 "../lib/sudoku-board.vala"
		_tmp67_ = self->priv->possible_in_block;
#line 368 "../lib/sudoku-board.vala"
		_tmp67__length1 = self->priv->possible_in_block_length1;
#line 368 "../lib/sudoku-board.vala"
		_tmp67__length2 = self->priv->possible_in_block_length2;
#line 368 "../lib/sudoku-board.vala"
		_tmp67__length3 = self->priv->possible_in_block_length3;
#line 368 "../lib/sudoku-board.vala"
		_tmp68_ = self->priv->_block_cols;
#line 368 "../lib/sudoku-board.vala"
		_tmp69_ = self->priv->_block_rows;
#line 368 "../lib/sudoku-board.vala"
		_tmp67_[((((row / _tmp68_) * _tmp67__length2) + (col / _tmp69_)) * _tmp67__length3) + previous_val] = TRUE;
#line 2963 "sudoku-board.c"
	}
#line 371 "../lib/sudoku-board.vala"
	_tmp70_ = self->priv->_filled;
#line 371 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp70_ - 1);
#line 373 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2971 "sudoku-board.c"
		gint _tmp71_;
#line 374 "../lib/sudoku-board.vala"
		_tmp71_ = self->priv->_fixed;
#line 374 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp71_ - 1);
#line 2977 "sudoku-board.c"
	}
}

void
sudoku_board_set_solution (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
#line 377 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 377 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->solution;
#line 377 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->solution_length1;
#line 377 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->solution_length2;
#line 377 "../lib/sudoku-board.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "solution != null");
#line 380 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->solution;
#line 380 "../lib/sudoku-board.vala"
	_tmp1__length1 = self->priv->solution_length1;
#line 380 "../lib/sudoku-board.vala"
	_tmp1__length2 = self->priv->solution_length2;
#line 380 "../lib/sudoku-board.vala"
	_tmp1_[(row * _tmp1__length2) + col] = val;
#line 3011 "sudoku-board.c"
}

gint
sudoku_board_get_solution (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint _tmp2_;
	gint result;
#line 383 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 383 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->solution;
#line 383 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->solution_length1;
#line 383 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->solution_length2;
#line 383 "../lib/sudoku-board.vala"
	_vala_return_val_if_fail (_tmp0_ != NULL, "solution != null", 0);
#line 386 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->solution;
#line 386 "../lib/sudoku-board.vala"
	_tmp1__length1 = self->priv->solution_length1;
#line 386 "../lib/sudoku-board.vala"
	_tmp1__length2 = self->priv->solution_length2;
#line 386 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 386 "../lib/sudoku-board.vala"
	result = _tmp2_;
#line 386 "../lib/sudoku-board.vala"
	return result;
#line 3049 "sudoku-board.c"
}

static gint*
sudoku_board_fixed_cells_only (SudokuBoard* self,
                               gint* result_length1,
                               gint* result_length2)
{
	gint* _result_ = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _result__length1;
	gint _result__length2;
	gint* _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	gint* result;
#line 389 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 391 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 391 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 391 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 391 "../lib/sudoku-board.vala"
	_result_ = _tmp2_;
#line 391 "../lib/sudoku-board.vala"
	_result__length1 = _tmp0_;
#line 391 "../lib/sudoku-board.vala"
	_result__length2 = _tmp1_;
#line 3081 "sudoku-board.c"
	{
		gint row = 0;
#line 393 "../lib/sudoku-board.vala"
		row = 0;
#line 3086 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 393 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 393 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3093 "sudoku-board.c"
				gint _tmp5_;
#line 393 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 3097 "sudoku-board.c"
					gint _tmp4_;
#line 393 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 393 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 3103 "sudoku-board.c"
				}
#line 393 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 393 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 393 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 393 "../lib/sudoku-board.vala"
					break;
#line 3113 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 395 "../lib/sudoku-board.vala"
					col = 0;
#line 3119 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 395 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 395 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3126 "sudoku-board.c"
							gint _tmp8_;
							gboolean* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gboolean _tmp10_;
#line 395 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 3134 "sudoku-board.c"
								gint _tmp7_;
#line 395 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 395 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 3140 "sudoku-board.c"
							}
#line 395 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 395 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 395 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 395 "../lib/sudoku-board.vala"
								break;
#line 3150 "sudoku-board.c"
							}
#line 397 "../lib/sudoku-board.vala"
							_tmp9_ = self->priv->is_fixed;
#line 397 "../lib/sudoku-board.vala"
							_tmp9__length1 = self->priv->is_fixed_length1;
#line 397 "../lib/sudoku-board.vala"
							_tmp9__length2 = self->priv->is_fixed_length2;
#line 397 "../lib/sudoku-board.vala"
							_tmp10_ = _tmp9_[(row * _tmp9__length2) + col];
#line 397 "../lib/sudoku-board.vala"
							if (_tmp10_) {
#line 3162 "sudoku-board.c"
								gint* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								gint* _tmp12_;
								gint _tmp12__length1;
								gint _tmp12__length2;
								gint _tmp13_;
#line 398 "../lib/sudoku-board.vala"
								_tmp11_ = _result_;
#line 398 "../lib/sudoku-board.vala"
								_tmp11__length1 = _result__length1;
#line 398 "../lib/sudoku-board.vala"
								_tmp11__length2 = _result__length2;
#line 398 "../lib/sudoku-board.vala"
								_tmp12_ = self->priv->cells;
#line 398 "../lib/sudoku-board.vala"
								_tmp12__length1 = self->priv->cells_length1;
#line 398 "../lib/sudoku-board.vala"
								_tmp12__length2 = self->priv->cells_length2;
#line 398 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_[(row * _tmp12__length2) + col];
#line 398 "../lib/sudoku-board.vala"
								_tmp11_[(row * _tmp11__length2) + col] = _tmp13_;
#line 3186 "sudoku-board.c"
							} else {
								gint* _tmp14_;
								gint _tmp14__length1;
								gint _tmp14__length2;
#line 400 "../lib/sudoku-board.vala"
								_tmp14_ = _result_;
#line 400 "../lib/sudoku-board.vala"
								_tmp14__length1 = _result__length1;
#line 400 "../lib/sudoku-board.vala"
								_tmp14__length2 = _result__length2;
#line 400 "../lib/sudoku-board.vala"
								_tmp14_[(row * _tmp14__length2) + col] = 0;
#line 3199 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 404 "../lib/sudoku-board.vala"
	_tmp15_ = _result_;
#line 404 "../lib/sudoku-board.vala"
	_tmp15__length1 = _result__length1;
#line 404 "../lib/sudoku-board.vala"
	_tmp15__length2 = _result__length2;
#line 404 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 404 "../lib/sudoku-board.vala"
		*result_length1 = _tmp15__length1;
#line 3217 "sudoku-board.c"
	}
#line 404 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 404 "../lib/sudoku-board.vala"
		*result_length2 = _tmp15__length2;
#line 3223 "sudoku-board.c"
	}
#line 404 "../lib/sudoku-board.vala"
	result = _tmp15_;
#line 404 "../lib/sudoku-board.vala"
	return result;
#line 3229 "sudoku-board.c"
}

void
sudoku_board_solve (SudokuBoard* self)
{
	gint* fixed_cells = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint fixed_cells_length1;
	gint fixed_cells_length2;
	gint* solution_1d = NULL;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint solution_1d_length1;
	gint _solution_1d_size_;
	gint* _tmp6_;
	gint _tmp6__length1;
#line 407 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 409 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_fixed_cells_only (self, &_tmp0_, &_tmp1_);
#line 409 "../lib/sudoku-board.vala"
	fixed_cells = _tmp2_;
#line 409 "../lib/sudoku-board.vala"
	fixed_cells_length1 = _tmp0_;
#line 409 "../lib/sudoku-board.vala"
	fixed_cells_length2 = _tmp1_;
#line 410 "../lib/sudoku-board.vala"
	_tmp3_ = fixed_cells;
#line 410 "../lib/sudoku-board.vala"
	_tmp3__length1 = fixed_cells_length1;
#line 410 "../lib/sudoku-board.vala"
	_tmp3__length2 = fixed_cells_length2;
#line 410 "../lib/sudoku-board.vala"
	_tmp5_ = sudoku_board_convert_2d_to_1d (self, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2, &_tmp4_);
#line 410 "../lib/sudoku-board.vala"
	solution_1d = _tmp5_;
#line 410 "../lib/sudoku-board.vala"
	solution_1d_length1 = _tmp4_;
#line 410 "../lib/sudoku-board.vala"
	_solution_1d_size_ = solution_1d_length1;
#line 412 "../lib/sudoku-board.vala"
	_tmp6_ = solution_1d;
#line 412 "../lib/sudoku-board.vala"
	_tmp6__length1 = solution_1d_length1;
#line 412 "../lib/sudoku-board.vala"
	if (qqwing_solve_puzzle (_tmp6_)) {
#line 3281 "sudoku-board.c"
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint* _tmp10_;
#line 413 "../lib/sudoku-board.vala"
		_tmp7_ = solution_1d;
#line 413 "../lib/sudoku-board.vala"
		_tmp7__length1 = solution_1d_length1;
#line 413 "../lib/sudoku-board.vala"
		_tmp10_ = sudoku_board_convert_1d_to_2d (self, _tmp7_, (gint) _tmp7__length1, &_tmp8_, &_tmp9_);
#line 413 "../lib/sudoku-board.vala"
		self->priv->solution = (g_free (self->priv->solution), NULL);
#line 413 "../lib/sudoku-board.vala"
		self->priv->solution = _tmp10_;
#line 413 "../lib/sudoku-board.vala"
		self->priv->solution_length1 = _tmp8_;
#line 413 "../lib/sudoku-board.vala"
		self->priv->solution_length2 = _tmp9_;
#line 3301 "sudoku-board.c"
	} else {
#line 415 "../lib/sudoku-board.vala"
		self->priv->solution = (g_free (self->priv->solution), NULL);
#line 415 "../lib/sudoku-board.vala"
		self->priv->solution = NULL;
#line 415 "../lib/sudoku-board.vala"
		self->priv->solution_length1 = 0;
#line 415 "../lib/sudoku-board.vala"
		self->priv->solution_length2 = 0;
#line 3311 "sudoku-board.c"
	}
#line 407 "../lib/sudoku-board.vala"
	solution_1d = (g_free (solution_1d), NULL);
#line 407 "../lib/sudoku-board.vala"
	fixed_cells = (g_free (fixed_cells), NULL);
#line 3317 "sudoku-board.c"
}

gboolean
sudoku_board_solved (SudokuBoard* self)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean result;
#line 418 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 420 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->solution;
#line 420 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->solution_length1;
#line 420 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->solution_length2;
#line 420 "../lib/sudoku-board.vala"
	result = _tmp0_ != NULL;
#line 420 "../lib/sudoku-board.vala"
	return result;
#line 3339 "sudoku-board.c"
}

gint
sudoku_board_count_solutions_limited (SudokuBoard* self)
{
	gint* cells_1d = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint cells_1d_length1;
	gint _cells_1d_size_;
	gint result;
#line 423 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 425 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 425 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 425 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 425 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_convert_2d_to_1d (self, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, &_tmp1_);
#line 425 "../lib/sudoku-board.vala"
	cells_1d = _tmp2_;
#line 425 "../lib/sudoku-board.vala"
	cells_1d_length1 = _tmp1_;
#line 425 "../lib/sudoku-board.vala"
	_cells_1d_size_ = cells_1d_length1;
#line 427 "../lib/sudoku-board.vala"
	result = qqwing_count_solutions_limited (cells_1d);
#line 427 "../lib/sudoku-board.vala"
	cells_1d = (g_free (cells_1d), NULL);
#line 427 "../lib/sudoku-board.vala"
	return result;
#line 3376 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_occurances (SudokuBoard* self,
                             GeeList* coords,
                             gint val)
{
	GeeSet* occurances = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* result;
#line 430 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 430 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coords != NULL, NULL);
#line 432 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 432 "../lib/sudoku-board.vala"
	occurances = (GeeSet*) _tmp0_;
#line 3395 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _coord_index = 0;
#line 433 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 433 "../lib/sudoku-board.vala"
		_tmp1_ = _coord_list;
#line 433 "../lib/sudoku-board.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 433 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 433 "../lib/sudoku-board.vala"
		_coord_size = _tmp3_;
#line 433 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 433 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3417 "sudoku-board.c"
			gint _tmp4_;
			gint _tmp5_;
			Coord coord = {0};
			GeeList* _tmp6_;
			gpointer _tmp7_;
			Coord* _tmp8_;
			Coord _tmp9_;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			Coord _tmp11_;
			Coord _tmp12_;
			gint _tmp13_;
#line 433 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 433 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_index;
#line 433 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_size;
#line 433 "../lib/sudoku-board.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 433 "../lib/sudoku-board.vala"
				break;
#line 3441 "sudoku-board.c"
			}
#line 433 "../lib/sudoku-board.vala"
			_tmp6_ = _coord_list;
#line 433 "../lib/sudoku-board.vala"
			_tmp7_ = gee_list_get (_tmp6_, _coord_index);
#line 433 "../lib/sudoku-board.vala"
			_tmp8_ = (Coord*) _tmp7_;
#line 433 "../lib/sudoku-board.vala"
			_tmp9_ = *_tmp8_;
#line 433 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp8_);
#line 433 "../lib/sudoku-board.vala"
			coord = _tmp9_;
#line 434 "../lib/sudoku-board.vala"
			_tmp10_ = self->priv->cells;
#line 434 "../lib/sudoku-board.vala"
			_tmp10__length1 = self->priv->cells_length1;
#line 434 "../lib/sudoku-board.vala"
			_tmp10__length2 = self->priv->cells_length2;
#line 434 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 434 "../lib/sudoku-board.vala"
			_tmp12_ = coord;
#line 434 "../lib/sudoku-board.vala"
			_tmp13_ = _tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col];
#line 434 "../lib/sudoku-board.vala"
			if (_tmp13_ == val) {
#line 3469 "sudoku-board.c"
				GeeSet* _tmp14_;
				Coord _tmp15_;
#line 435 "../lib/sudoku-board.vala"
				_tmp14_ = occurances;
#line 435 "../lib/sudoku-board.vala"
				_tmp15_ = coord;
#line 435 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp14_, &_tmp15_);
#line 3478 "sudoku-board.c"
			}
		}
	}
#line 437 "../lib/sudoku-board.vala"
	result = occurances;
#line 437 "../lib/sudoku-board.vala"
	return result;
#line 3486 "sudoku-board.c"
}

gboolean
sudoku_board_row_contains (SudokuBoard* self,
                           gint row,
                           gint val)
{
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 440 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 442 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_row;
#line 442 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, row);
#line 442 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 442 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 442 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 442 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 442 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 442 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 442 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 442 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 442 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 442 "../lib/sudoku-board.vala"
	return result;
#line 3529 "sudoku-board.c"
}

gboolean
sudoku_board_col_contains (SudokuBoard* self,
                           gint col,
                           gint val)
{
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 445 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 447 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_col;
#line 447 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, col);
#line 447 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 447 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 447 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 447 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 447 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 447 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 447 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 447 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 447 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 447 "../lib/sudoku-board.vala"
	return result;
#line 3572 "sudoku-board.c"
}

gboolean
sudoku_board_block_contains (SudokuBoard* self,
                             Coord* block,
                             gint val)
{
	GeeMap* _tmp0_;
	Coord _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 450 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 450 "../lib/sudoku-board.vala"
	g_return_val_if_fail (block != NULL, FALSE);
#line 452 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_block;
#line 452 "../lib/sudoku-board.vala"
	_tmp1_ = *block;
#line 452 "../lib/sudoku-board.vala"
	_tmp2_ = gee_map_get (_tmp0_, &_tmp1_);
#line 452 "../lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 452 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_board_get_occurances (self, _tmp3_, val);
#line 452 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 452 "../lib/sudoku-board.vala"
	_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 452 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_;
#line 452 "../lib/sudoku-board.vala"
	_tmp8_ = _tmp7_ != 0;
#line 452 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp5_);
#line 452 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 452 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 452 "../lib/sudoku-board.vala"
	return result;
#line 3620 "sudoku-board.c"
}

static void
sudoku_board_remove_breakages_for (SudokuBoard* self,
                                   GeeList* coords,
                                   gint val)
{
#line 455 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 455 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 3632 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _coord_index = 0;
#line 457 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 457 "../lib/sudoku-board.vala"
		_tmp0_ = _coord_list;
#line 457 "../lib/sudoku-board.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 457 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp1_;
#line 457 "../lib/sudoku-board.vala"
		_coord_size = _tmp2_;
#line 457 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 457 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3654 "sudoku-board.c"
			gint _tmp3_;
			gint _tmp4_;
			Coord coord = {0};
			GeeList* _tmp5_;
			gpointer _tmp6_;
			Coord* _tmp7_;
			Coord _tmp8_;
			gboolean _tmp9_ = FALSE;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			Coord _tmp11_;
			Coord _tmp12_;
			gint _tmp13_;
#line 457 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 457 "../lib/sudoku-board.vala"
			_tmp3_ = _coord_index;
#line 457 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_size;
#line 457 "../lib/sudoku-board.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 457 "../lib/sudoku-board.vala"
				break;
#line 3679 "sudoku-board.c"
			}
#line 457 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_list;
#line 457 "../lib/sudoku-board.vala"
			_tmp6_ = gee_list_get (_tmp5_, _coord_index);
#line 457 "../lib/sudoku-board.vala"
			_tmp7_ = (Coord*) _tmp6_;
#line 457 "../lib/sudoku-board.vala"
			_tmp8_ = *_tmp7_;
#line 457 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp7_);
#line 457 "../lib/sudoku-board.vala"
			coord = _tmp8_;
#line 458 "../lib/sudoku-board.vala"
			_tmp10_ = self->priv->cells;
#line 458 "../lib/sudoku-board.vala"
			_tmp10__length1 = self->priv->cells_length1;
#line 458 "../lib/sudoku-board.vala"
			_tmp10__length2 = self->priv->cells_length2;
#line 458 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 458 "../lib/sudoku-board.vala"
			_tmp12_ = coord;
#line 458 "../lib/sudoku-board.vala"
			_tmp13_ = _tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col];
#line 458 "../lib/sudoku-board.vala"
			if (_tmp13_ == val) {
#line 3707 "sudoku-board.c"
				GeeSet* _tmp14_;
				Coord _tmp15_;
#line 458 "../lib/sudoku-board.vala"
				_tmp14_ = self->priv->_broken_coords;
#line 458 "../lib/sudoku-board.vala"
				_tmp15_ = coord;
#line 458 "../lib/sudoku-board.vala"
				_tmp9_ = gee_collection_contains ((GeeCollection*) _tmp14_, &_tmp15_);
#line 3716 "sudoku-board.c"
			} else {
#line 458 "../lib/sudoku-board.vala"
				_tmp9_ = FALSE;
#line 3720 "sudoku-board.c"
			}
#line 458 "../lib/sudoku-board.vala"
			if (_tmp9_) {
#line 3724 "sudoku-board.c"
				GeeSet* _tmp16_;
				Coord _tmp17_;
#line 459 "../lib/sudoku-board.vala"
				_tmp16_ = self->priv->_broken_coords;
#line 459 "../lib/sudoku-board.vala"
				_tmp17_ = coord;
#line 459 "../lib/sudoku-board.vala"
				gee_collection_remove ((GeeCollection*) _tmp16_, &_tmp17_);
#line 3733 "sudoku-board.c"
			}
		}
	}
}

static void
sudoku_board_mark_breakages_for (SudokuBoard* self,
                                 GeeList* coords,
                                 gint val)
{
	GeeSet* occurances = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 463 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 463 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 465 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_occurances (self, coords, val);
#line 465 "../lib/sudoku-board.vala"
	occurances = _tmp0_;
#line 466 "../lib/sudoku-board.vala"
	_tmp1_ = occurances;
#line 466 "../lib/sudoku-board.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 466 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 466 "../lib/sudoku-board.vala"
	if (_tmp3_ != 1) {
#line 3765 "sudoku-board.c"
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 467 "../lib/sudoku-board.vala"
		_tmp4_ = self->priv->_broken_coords;
#line 467 "../lib/sudoku-board.vala"
		_tmp5_ = occurances;
#line 467 "../lib/sudoku-board.vala"
		gee_collection_add_all ((GeeCollection*) _tmp4_, (GeeCollection*) _tmp5_);
#line 3774 "sudoku-board.c"
	}
#line 463 "../lib/sudoku-board.vala"
	_g_object_unref0 (occurances);
#line 3778 "sudoku-board.c"
}

void
sudoku_board_to_initial_state (SudokuBoard* self)
{
#line 470 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3786 "sudoku-board.c"
	{
		gint l1 = 0;
#line 472 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3791 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 472 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 472 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3798 "sudoku-board.c"
				gint _tmp2_;
#line 472 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3802 "sudoku-board.c"
					gint _tmp1_;
#line 472 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 472 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3808 "sudoku-board.c"
				}
#line 472 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 472 "../lib/sudoku-board.vala"
				_tmp2_ = self->priv->_rows;
#line 472 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp2_)) {
#line 472 "../lib/sudoku-board.vala"
					break;
#line 3818 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 473 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3824 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 473 "../lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 473 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3831 "sudoku-board.c"
							gint _tmp5_;
							gboolean* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gboolean _tmp7_;
#line 473 "../lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 3839 "sudoku-board.c"
								gint _tmp4_;
#line 473 "../lib/sudoku-board.vala"
								_tmp4_ = l2;
#line 473 "../lib/sudoku-board.vala"
								l2 = _tmp4_ + 1;
#line 3845 "sudoku-board.c"
							}
#line 473 "../lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 473 "../lib/sudoku-board.vala"
							_tmp5_ = self->priv->_cols;
#line 473 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp5_)) {
#line 473 "../lib/sudoku-board.vala"
								break;
#line 3855 "sudoku-board.c"
							}
#line 474 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->is_fixed;
#line 474 "../lib/sudoku-board.vala"
							_tmp6__length1 = self->priv->is_fixed_length1;
#line 474 "../lib/sudoku-board.vala"
							_tmp6__length2 = self->priv->is_fixed_length2;
#line 474 "../lib/sudoku-board.vala"
							_tmp7_ = _tmp6_[(l1 * _tmp6__length2) + l2];
#line 474 "../lib/sudoku-board.vala"
							if (!_tmp7_) {
#line 475 "../lib/sudoku-board.vala"
								sudoku_board_remove (self, l1, l2, FALSE);
#line 3869 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}

void
sudoku_board_print (SudokuBoard* self,
                    gint indent)
{
	FILE* _tmp14_;
#line 478 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3886 "sudoku-board.c"
	{
		gint l1 = 0;
#line 480 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3891 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 480 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 480 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3898 "sudoku-board.c"
				FILE* _tmp13_;
#line 480 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3902 "sudoku-board.c"
					gint _tmp1_;
#line 480 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 480 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3908 "sudoku-board.c"
				}
#line 480 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 480 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 480 "../lib/sudoku-board.vala"
					break;
#line 3916 "sudoku-board.c"
				}
				{
					gint i = 0;
#line 482 "../lib/sudoku-board.vala"
					i = 0;
#line 3922 "sudoku-board.c"
					{
						gboolean _tmp2_ = FALSE;
#line 482 "../lib/sudoku-board.vala"
						_tmp2_ = TRUE;
#line 482 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3929 "sudoku-board.c"
							FILE* _tmp4_;
#line 482 "../lib/sudoku-board.vala"
							if (!_tmp2_) {
#line 3933 "sudoku-board.c"
								gint _tmp3_;
#line 482 "../lib/sudoku-board.vala"
								_tmp3_ = i;
#line 482 "../lib/sudoku-board.vala"
								i = _tmp3_ + 1;
#line 3939 "sudoku-board.c"
							}
#line 482 "../lib/sudoku-board.vala"
							_tmp2_ = FALSE;
#line 482 "../lib/sudoku-board.vala"
							if (!(i < indent)) {
#line 482 "../lib/sudoku-board.vala"
								break;
#line 3947 "sudoku-board.c"
							}
#line 483 "../lib/sudoku-board.vala"
							_tmp4_ = stdout;
#line 483 "../lib/sudoku-board.vala"
							fprintf (_tmp4_, " ");
#line 3953 "sudoku-board.c"
						}
					}
				}
				{
					gint l2 = 0;
#line 484 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3961 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 484 "../lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 484 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3968 "sudoku-board.c"
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 484 "../lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 3975 "sudoku-board.c"
								gint _tmp6_;
#line 484 "../lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 484 "../lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 3981 "sudoku-board.c"
							}
#line 484 "../lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 484 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 484 "../lib/sudoku-board.vala"
								break;
#line 3989 "sudoku-board.c"
							}
#line 486 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 486 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 486 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 486 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 486 "../lib/sudoku-board.vala"
							if (_tmp8_ != 0) {
#line 4001 "sudoku-board.c"
								FILE* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
#line 487 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 487 "../lib/sudoku-board.vala"
								_tmp10_ = self->priv->cells;
#line 487 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->priv->cells_length1;
#line 487 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->priv->cells_length2;
#line 487 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(l1 * _tmp10__length2) + l2];
#line 487 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, "%d ", _tmp11_);
#line 4019 "sudoku-board.c"
							} else {
								FILE* _tmp12_;
#line 489 "../lib/sudoku-board.vala"
								_tmp12_ = stdout;
#line 489 "../lib/sudoku-board.vala"
								fprintf (_tmp12_, "  ");
#line 4026 "sudoku-board.c"
							}
						}
					}
				}
#line 491 "../lib/sudoku-board.vala"
				_tmp13_ = stdout;
#line 491 "../lib/sudoku-board.vala"
				fprintf (_tmp13_, "\n");
#line 4035 "sudoku-board.c"
			}
		}
	}
#line 493 "../lib/sudoku-board.vala"
	_tmp14_ = stdout;
#line 493 "../lib/sudoku-board.vala"
	fflush (_tmp14_);
#line 4043 "sudoku-board.c"
}

void
sudoku_board_get_string (SudokuBoard* self)
{
	FILE* _tmp0_;
	FILE* _tmp12_;
#line 496 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 498 "../lib/sudoku-board.vala"
	_tmp0_ = stdout;
#line 498 "../lib/sudoku-board.vala"
	fprintf (_tmp0_, "[ ");
#line 4057 "sudoku-board.c"
	{
		gint l1 = 0;
#line 499 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4062 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 499 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 499 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4069 "sudoku-board.c"
				FILE* _tmp3_;
				FILE* _tmp10_;
#line 499 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4074 "sudoku-board.c"
					gint _tmp2_;
#line 499 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 499 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4080 "sudoku-board.c"
				}
#line 499 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 499 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 499 "../lib/sudoku-board.vala"
					break;
#line 4088 "sudoku-board.c"
				}
#line 501 "../lib/sudoku-board.vala"
				_tmp3_ = stdout;
#line 501 "../lib/sudoku-board.vala"
				fprintf (_tmp3_, "[ ");
#line 4094 "sudoku-board.c"
				{
					gint l2 = 0;
#line 502 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4099 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 502 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 502 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4106 "sudoku-board.c"
							FILE* _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 502 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4114 "sudoku-board.c"
								gint _tmp5_;
#line 502 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 502 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4120 "sudoku-board.c"
							}
#line 502 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 502 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 502 "../lib/sudoku-board.vala"
								break;
#line 4128 "sudoku-board.c"
							}
#line 504 "../lib/sudoku-board.vala"
							_tmp6_ = stdout;
#line 504 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 504 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 504 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 504 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 504 "../lib/sudoku-board.vala"
							fprintf (_tmp6_, "%d", _tmp8_);
#line 505 "../lib/sudoku-board.vala"
							if (l2 != 8) {
#line 4144 "sudoku-board.c"
								FILE* _tmp9_;
#line 506 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 506 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, ",");
#line 4150 "sudoku-board.c"
							}
						}
					}
				}
#line 508 "../lib/sudoku-board.vala"
				_tmp10_ = stdout;
#line 508 "../lib/sudoku-board.vala"
				fprintf (_tmp10_, " ]");
#line 509 "../lib/sudoku-board.vala"
				if (l1 != 8) {
#line 4161 "sudoku-board.c"
					FILE* _tmp11_;
#line 510 "../lib/sudoku-board.vala"
					_tmp11_ = stdout;
#line 510 "../lib/sudoku-board.vala"
					fprintf (_tmp11_, ",");
#line 4167 "sudoku-board.c"
				}
			}
		}
	}
#line 512 "../lib/sudoku-board.vala"
	_tmp12_ = stdout;
#line 512 "../lib/sudoku-board.vala"
	fprintf (_tmp12_, " ]");
#line 4176 "sudoku-board.c"
}

gchar*
sudoku_board_to_string (SudokuBoard* self,
                        gboolean get_original_state)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 515 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 517 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 517 "../lib/sudoku-board.vala"
	board_string = _tmp0_;
#line 4192 "sudoku-board.c"
	{
		gint i = 0;
#line 518 "../lib/sudoku-board.vala"
		i = 0;
#line 4197 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 518 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 518 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4204 "sudoku-board.c"
				gint _tmp3_;
#line 518 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4208 "sudoku-board.c"
					gint _tmp2_;
#line 518 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 518 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4214 "sudoku-board.c"
				}
#line 518 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 518 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 518 "../lib/sudoku-board.vala"
				if (!(i < _tmp3_)) {
#line 518 "../lib/sudoku-board.vala"
					break;
#line 4224 "sudoku-board.c"
				}
				{
					gint j = 0;
#line 520 "../lib/sudoku-board.vala"
					j = 0;
#line 4230 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 520 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 520 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4237 "sudoku-board.c"
							gint _tmp6_;
							gboolean* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gboolean _tmp8_;
#line 520 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4245 "sudoku-board.c"
								gint _tmp5_;
#line 520 "../lib/sudoku-board.vala"
								_tmp5_ = j;
#line 520 "../lib/sudoku-board.vala"
								j = _tmp5_ + 1;
#line 4251 "sudoku-board.c"
							}
#line 520 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 520 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 520 "../lib/sudoku-board.vala"
							if (!(j < _tmp6_)) {
#line 520 "../lib/sudoku-board.vala"
								break;
#line 4261 "sudoku-board.c"
							}
#line 522 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->is_fixed;
#line 522 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->is_fixed_length1;
#line 522 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->is_fixed_length2;
#line 522 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(i * _tmp7__length2) + j];
#line 522 "../lib/sudoku-board.vala"
							if (_tmp8_) {
#line 4273 "sudoku-board.c"
								const gchar* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
#line 523 "../lib/sudoku-board.vala"
								_tmp9_ = board_string;
#line 523 "../lib/sudoku-board.vala"
								_tmp10_ = self->priv->cells;
#line 523 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->priv->cells_length1;
#line 523 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->priv->cells_length2;
#line 523 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 523 "../lib/sudoku-board.vala"
								_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 523 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_;
#line 523 "../lib/sudoku-board.vala"
								_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 523 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 523 "../lib/sudoku-board.vala"
								board_string = _tmp14_;
#line 523 "../lib/sudoku-board.vala"
								_g_free0 (_tmp13_);
#line 4304 "sudoku-board.c"
							} else {
								gchar* _tmp15_ = NULL;
								const gchar* _tmp20_;
								gchar* _tmp21_;
#line 525 "../lib/sudoku-board.vala"
								if (get_original_state) {
#line 4311 "sudoku-board.c"
									gchar* _tmp16_;
#line 525 "../lib/sudoku-board.vala"
									_tmp16_ = g_strdup ("0");
#line 525 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 525 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp16_;
#line 4319 "sudoku-board.c"
								} else {
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
									gint _tmp18_;
									gchar* _tmp19_;
#line 525 "../lib/sudoku-board.vala"
									_tmp17_ = self->priv->cells;
#line 525 "../lib/sudoku-board.vala"
									_tmp17__length1 = self->priv->cells_length1;
#line 525 "../lib/sudoku-board.vala"
									_tmp17__length2 = self->priv->cells_length2;
#line 525 "../lib/sudoku-board.vala"
									_tmp18_ = _tmp17_[(i * _tmp17__length2) + j];
#line 525 "../lib/sudoku-board.vala"
									_tmp19_ = g_strdup_printf ("%i", _tmp18_);
#line 525 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 525 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp19_;
#line 4340 "sudoku-board.c"
								}
#line 525 "../lib/sudoku-board.vala"
								_tmp20_ = board_string;
#line 525 "../lib/sudoku-board.vala"
								_tmp21_ = g_strconcat (_tmp20_, _tmp15_, NULL);
#line 525 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 525 "../lib/sudoku-board.vala"
								board_string = _tmp21_;
#line 522 "../lib/sudoku-board.vala"
								_g_free0 (_tmp15_);
#line 4352 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 528 "../lib/sudoku-board.vala"
	result = board_string;
#line 528 "../lib/sudoku-board.vala"
	return result;
#line 4364 "sudoku-board.c"
}

static gint*
_vala_array_dup9 (gint* self,
                  gssize length)
{
#line 533 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 533 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 4375 "sudoku-board.c"
	}
#line 533 "../lib/sudoku-board.vala"
	return NULL;
#line 4379 "sudoku-board.c"
}

gint*
sudoku_board_get_cells (SudokuBoard* self,
                        gint* result_length1,
                        gint* result_length2)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint* result;
#line 531 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 533 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->cells;
#line 533 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 533 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 533 "../lib/sudoku-board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup9 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 533 "../lib/sudoku-board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 533 "../lib/sudoku-board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 533 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 533 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 533 "../lib/sudoku-board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 533 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 533 "../lib/sudoku-board.vala"
		*result_length1 = _tmp2__length1;
#line 4421 "sudoku-board.c"
	}
#line 533 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 533 "../lib/sudoku-board.vala"
		*result_length2 = _tmp2__length2;
#line 4427 "sudoku-board.c"
	}
#line 533 "../lib/sudoku-board.vala"
	result = _tmp2_;
#line 533 "../lib/sudoku-board.vala"
	return result;
#line 4433 "sudoku-board.c"
}

GeeHashMap*
sudoku_board_calculate_open_squares (SudokuBoard* self)
{
	GeeHashMap* possibilities = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 536 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 538 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 538 "../lib/sudoku-board.vala"
	possibilities = _tmp0_;
#line 4448 "sudoku-board.c"
	{
		gint l1 = 0;
#line 539 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4453 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 539 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 539 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4460 "sudoku-board.c"
				gint _tmp3_;
#line 539 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4464 "sudoku-board.c"
					gint _tmp2_;
#line 539 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 539 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4470 "sudoku-board.c"
				}
#line 539 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 539 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 539 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp3_)) {
#line 539 "../lib/sudoku-board.vala"
					break;
#line 4480 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 541 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4486 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 541 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 541 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4493 "sudoku-board.c"
							gint _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 541 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4501 "sudoku-board.c"
								gint _tmp5_;
#line 541 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 541 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4507 "sudoku-board.c"
							}
#line 541 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 541 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 541 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp6_)) {
#line 541 "../lib/sudoku-board.vala"
								break;
#line 4517 "sudoku-board.c"
							}
#line 543 "../lib/sudoku-board.vala"
							_tmp7_ = self->priv->cells;
#line 543 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->priv->cells_length1;
#line 543 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->priv->cells_length2;
#line 543 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 543 "../lib/sudoku-board.vala"
							if (_tmp8_ == 0) {
#line 4529 "sudoku-board.c"
								GeeList* possArrayList = NULL;
								GeeArrayList* _tmp9_;
								gint* possArray = NULL;
								gint _tmp10_ = 0;
								gint* _tmp11_;
								gint possArray_length1;
								gint _possArray_size_;
								gint* _tmp12_;
								gint _tmp12__length1;
								GeeHashMap* _tmp14_;
								Coord _tmp15_ = {0};
								GeeList* _tmp16_;
#line 545 "../lib/sudoku-board.vala"
								_tmp9_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 545 "../lib/sudoku-board.vala"
								possArrayList = (GeeList*) _tmp9_;
#line 546 "../lib/sudoku-board.vala"
								_tmp11_ = sudoku_board_get_possibilities (self, l1, l2, &_tmp10_);
#line 546 "../lib/sudoku-board.vala"
								possArray = _tmp11_;
#line 546 "../lib/sudoku-board.vala"
								possArray_length1 = _tmp10_;
#line 546 "../lib/sudoku-board.vala"
								_possArray_size_ = possArray_length1;
#line 547 "../lib/sudoku-board.vala"
								_tmp12_ = possArray;
#line 547 "../lib/sudoku-board.vala"
								_tmp12__length1 = possArray_length1;
#line 4558 "sudoku-board.c"
								{
									gint* i_collection = NULL;
									gint i_collection_length1 = 0;
									gint _i_collection_size_ = 0;
									gint i_it = 0;
#line 547 "../lib/sudoku-board.vala"
									i_collection = _tmp12_;
#line 547 "../lib/sudoku-board.vala"
									i_collection_length1 = _tmp12__length1;
#line 547 "../lib/sudoku-board.vala"
									for (i_it = 0; i_it < i_collection_length1; i_it = i_it + 1) {
#line 4570 "sudoku-board.c"
										gint i = 0;
#line 547 "../lib/sudoku-board.vala"
										i = i_collection[i_it];
#line 4574 "sudoku-board.c"
										{
											GeeList* _tmp13_;
#line 548 "../lib/sudoku-board.vala"
											_tmp13_ = possArrayList;
#line 548 "../lib/sudoku-board.vala"
											gee_collection_add ((GeeCollection*) _tmp13_, (gpointer) ((gintptr) i));
#line 4581 "sudoku-board.c"
										}
									}
								}
#line 549 "../lib/sudoku-board.vala"
								_tmp14_ = possibilities;
#line 549 "../lib/sudoku-board.vala"
								coord_init (&_tmp15_, l1, l2);
#line 549 "../lib/sudoku-board.vala"
								_tmp16_ = possArrayList;
#line 549 "../lib/sudoku-board.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, &_tmp15_, _tmp16_);
#line 543 "../lib/sudoku-board.vala"
								possArray = (g_free (possArray), NULL);
#line 543 "../lib/sudoku-board.vala"
								_g_object_unref0 (possArrayList);
#line 4597 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 553 "../lib/sudoku-board.vala"
	result = possibilities;
#line 553 "../lib/sudoku-board.vala"
	return result;
#line 4609 "sudoku-board.c"
}

gboolean
sudoku_board_is_finished (SudokuBoard* self)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* finishgame_file = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* file = NULL;
	GFile* _tmp7_;
	gboolean result;
#line 556 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 558 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_to_string (self, TRUE);
#line 558 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 558 "../lib/sudoku-board.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".save", NULL);
#line 558 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 558 "../lib/sudoku-board.vala"
	_g_free0 (_tmp1_);
#line 558 "../lib/sudoku-board.vala"
	board_string = _tmp3_;
#line 559 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_saver_get_finishgame_dir ();
#line 559 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 559 "../lib/sudoku-board.vala"
	_tmp6_ = g_build_path (G_DIR_SEPARATOR_S, _tmp5_, board_string, NULL);
#line 559 "../lib/sudoku-board.vala"
	finishgame_file = _tmp6_;
#line 560 "../lib/sudoku-board.vala"
	_tmp7_ = g_file_new_for_path (finishgame_file);
#line 560 "../lib/sudoku-board.vala"
	file = _tmp7_;
#line 562 "../lib/sudoku-board.vala"
	result = g_file_query_exists (file, NULL);
#line 562 "../lib/sudoku-board.vala"
	_g_object_unref0 (file);
#line 562 "../lib/sudoku-board.vala"
	_g_free0 (finishgame_file);
#line 562 "../lib/sudoku-board.vala"
	_g_free0 (board_string);
#line 562 "../lib/sudoku-board.vala"
	return result;
#line 4663 "sudoku-board.c"
}

gboolean*
sudoku_board_get_earmarks (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint* result_length1)
{
	gboolean* the_earmarks = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint the_earmarks_length1;
	gint _the_earmarks_size_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gboolean* result;
#line 565 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 567 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 567 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 567 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 567 "../lib/sudoku-board.vala"
	the_earmarks = _tmp2_;
#line 567 "../lib/sudoku-board.vala"
	the_earmarks_length1 = _tmp1_;
#line 567 "../lib/sudoku-board.vala"
	_the_earmarks_size_ = the_earmarks_length1;
#line 4695 "sudoku-board.c"
	{
		gint i = 0;
#line 568 "../lib/sudoku-board.vala"
		i = 1;
#line 4700 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 568 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 568 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4707 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
				gboolean* _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint _tmp8__length3;
				gboolean _tmp9_;
#line 568 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 4719 "sudoku-board.c"
					gint _tmp4_;
#line 568 "../lib/sudoku-board.vala"
					_tmp4_ = i;
#line 568 "../lib/sudoku-board.vala"
					i = _tmp4_ + 1;
#line 4725 "sudoku-board.c"
				}
#line 568 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 568 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 568 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 568 "../lib/sudoku-board.vala"
				if (!(i <= _tmp6_)) {
#line 568 "../lib/sudoku-board.vala"
					break;
#line 4737 "sudoku-board.c"
				}
#line 569 "../lib/sudoku-board.vala"
				_tmp7_ = the_earmarks;
#line 569 "../lib/sudoku-board.vala"
				_tmp7__length1 = the_earmarks_length1;
#line 569 "../lib/sudoku-board.vala"
				_tmp8_ = self->priv->earmarks;
#line 569 "../lib/sudoku-board.vala"
				_tmp8__length1 = self->priv->earmarks_length1;
#line 569 "../lib/sudoku-board.vala"
				_tmp8__length2 = self->priv->earmarks_length2;
#line 569 "../lib/sudoku-board.vala"
				_tmp8__length3 = self->priv->earmarks_length3;
#line 569 "../lib/sudoku-board.vala"
				_tmp9_ = _tmp8_[(((row * _tmp8__length2) + col) * _tmp8__length3) + (i - 1)];
#line 569 "../lib/sudoku-board.vala"
				_tmp7_[i - 1] = _tmp9_;
#line 4755 "sudoku-board.c"
			}
		}
	}
#line 570 "../lib/sudoku-board.vala"
	_tmp10_ = the_earmarks;
#line 570 "../lib/sudoku-board.vala"
	_tmp10__length1 = the_earmarks_length1;
#line 570 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 570 "../lib/sudoku-board.vala"
		*result_length1 = _tmp10__length1;
#line 4767 "sudoku-board.c"
	}
#line 570 "../lib/sudoku-board.vala"
	result = _tmp10_;
#line 570 "../lib/sudoku-board.vala"
	return result;
#line 4773 "sudoku-board.c"
}

gboolean
sudoku_board_has_earmarks (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gboolean* current_earmarks = NULL;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gint current_earmarks_length1;
	gint _current_earmarks_size_;
	gboolean has_earmarks = FALSE;
	gboolean result;
#line 573 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_earmarks (self, row, col, &_tmp0_);
#line 575 "../lib/sudoku-board.vala"
	current_earmarks = _tmp1_;
#line 575 "../lib/sudoku-board.vala"
	current_earmarks_length1 = _tmp0_;
#line 575 "../lib/sudoku-board.vala"
	_current_earmarks_size_ = current_earmarks_length1;
#line 576 "../lib/sudoku-board.vala"
	has_earmarks = FALSE;
#line 4800 "sudoku-board.c"
	{
		gint i = 0;
#line 577 "../lib/sudoku-board.vala"
		i = 0;
#line 4805 "sudoku-board.c"
		{
			gboolean _tmp2_ = FALSE;
#line 577 "../lib/sudoku-board.vala"
			_tmp2_ = TRUE;
#line 577 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4812 "sudoku-board.c"
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_;
#line 577 "../lib/sudoku-board.vala"
				if (!_tmp2_) {
#line 4818 "sudoku-board.c"
					gint _tmp3_;
#line 577 "../lib/sudoku-board.vala"
					_tmp3_ = i;
#line 577 "../lib/sudoku-board.vala"
					i = _tmp3_ + 1;
#line 4824 "sudoku-board.c"
				}
#line 577 "../lib/sudoku-board.vala"
				_tmp2_ = FALSE;
#line 577 "../lib/sudoku-board.vala"
				if (!(i < 9)) {
#line 577 "../lib/sudoku-board.vala"
					break;
#line 4832 "sudoku-board.c"
				}
#line 578 "../lib/sudoku-board.vala"
				_tmp4_ = current_earmarks;
#line 578 "../lib/sudoku-board.vala"
				_tmp4__length1 = current_earmarks_length1;
#line 578 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[i];
#line 578 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 580 "../lib/sudoku-board.vala"
					has_earmarks = TRUE;
#line 581 "../lib/sudoku-board.vala"
					break;
#line 4846 "sudoku-board.c"
				}
			}
		}
	}
#line 583 "../lib/sudoku-board.vala"
	result = has_earmarks;
#line 583 "../lib/sudoku-board.vala"
	current_earmarks = (g_free (current_earmarks), NULL);
#line 583 "../lib/sudoku-board.vala"
	return result;
#line 4857 "sudoku-board.c"
}

gchar*
sudoku_board_get_earmarks_string (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 586 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 588 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 588 "../lib/sudoku-board.vala"
	s = _tmp0_;
#line 4874 "sudoku-board.c"
	{
		gint i = 0;
#line 589 "../lib/sudoku-board.vala"
		i = 1;
#line 4879 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 589 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 589 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4886 "sudoku-board.c"
				gint _tmp3_;
				gint _tmp4_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gint _tmp5__length3;
				gboolean _tmp6_;
#line 589 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4896 "sudoku-board.c"
					gint _tmp2_;
#line 589 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 589 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4902 "sudoku-board.c"
				}
#line 589 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 589 "../lib/sudoku-board.vala"
				_tmp3_ = sudoku_board_get_max_val (self);
#line 589 "../lib/sudoku-board.vala"
				_tmp4_ = _tmp3_;
#line 589 "../lib/sudoku-board.vala"
				if (!(i <= _tmp4_)) {
#line 589 "../lib/sudoku-board.vala"
					break;
#line 4914 "sudoku-board.c"
				}
#line 590 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->earmarks;
#line 590 "../lib/sudoku-board.vala"
				_tmp5__length1 = self->priv->earmarks_length1;
#line 590 "../lib/sudoku-board.vala"
				_tmp5__length2 = self->priv->earmarks_length2;
#line 590 "../lib/sudoku-board.vala"
				_tmp5__length3 = self->priv->earmarks_length3;
#line 590 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_[(((row * _tmp5__length2) + col) * _tmp5__length3) + (i - 1)];
#line 590 "../lib/sudoku-board.vala"
				if (_tmp6_) {
#line 4928 "sudoku-board.c"
					const gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 591 "../lib/sudoku-board.vala"
					_tmp7_ = s;
#line 591 "../lib/sudoku-board.vala"
					_tmp8_ = g_strdup_printf ("%i", i);
#line 591 "../lib/sudoku-board.vala"
					_tmp9_ = _tmp8_;
#line 591 "../lib/sudoku-board.vala"
					_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
#line 591 "../lib/sudoku-board.vala"
					_g_free0 (s);
#line 591 "../lib/sudoku-board.vala"
					s = _tmp10_;
#line 591 "../lib/sudoku-board.vala"
					_g_free0 (_tmp9_);
#line 4947 "sudoku-board.c"
				}
			}
		}
	}
#line 593 "../lib/sudoku-board.vala"
	result = s;
#line 593 "../lib/sudoku-board.vala"
	return result;
#line 4956 "sudoku-board.c"
}

static gint*
sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                               gint* ints_2d,
                               gint ints_2d_length1,
                               gint ints_2d_length2,
                               gint* result_length1)
{
	gint* ints_1d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_1d_length1;
	gint _ints_1d_size_;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* result;
#line 598 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 600 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 600 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 600 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 600 "../lib/sudoku-board.vala"
	ints_1d = _tmp2_;
#line 600 "../lib/sudoku-board.vala"
	ints_1d_length1 = _tmp0_ * _tmp1_;
#line 600 "../lib/sudoku-board.vala"
	_ints_1d_size_ = ints_1d_length1;
#line 601 "../lib/sudoku-board.vala"
	i = 0;
#line 4992 "sudoku-board.c"
	{
		gint row = 0;
#line 602 "../lib/sudoku-board.vala"
		row = 0;
#line 4997 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 602 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 602 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 5004 "sudoku-board.c"
				gint _tmp5_;
#line 602 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 5008 "sudoku-board.c"
					gint _tmp4_;
#line 602 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 602 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 5014 "sudoku-board.c"
				}
#line 602 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 602 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 602 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 602 "../lib/sudoku-board.vala"
					break;
#line 5024 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 603 "../lib/sudoku-board.vala"
					col = 0;
#line 5030 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 603 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 603 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 5037 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp10_;
							gint _tmp11_;
#line 603 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 5045 "sudoku-board.c"
								gint _tmp7_;
#line 603 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 603 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 5051 "sudoku-board.c"
							}
#line 603 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 603 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 603 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 603 "../lib/sudoku-board.vala"
								break;
#line 5061 "sudoku-board.c"
							}
#line 604 "../lib/sudoku-board.vala"
							_tmp9_ = ints_1d;
#line 604 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_1d_length1;
#line 604 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 604 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 604 "../lib/sudoku-board.vala"
							_tmp11_ = ints_2d[(row * ints_2d_length2) + col];
#line 604 "../lib/sudoku-board.vala"
							_tmp9_[_tmp10_] = _tmp11_;
#line 5075 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 605 "../lib/sudoku-board.vala"
	_tmp12_ = ints_1d;
#line 605 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_1d_length1;
#line 605 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 605 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 5090 "sudoku-board.c"
	}
#line 605 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 605 "../lib/sudoku-board.vala"
	return result;
#line 5096 "sudoku-board.c"
}

static gint*
sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                               gint* ints_1d,
                               gint ints_1d_length1,
                               gint* result_length1,
                               gint* result_length2)
{
	gint* ints_2d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_2d_length1;
	gint ints_2d_length2;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint* result;
#line 610 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 612 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 612 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 612 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 612 "../lib/sudoku-board.vala"
	ints_2d = _tmp2_;
#line 612 "../lib/sudoku-board.vala"
	ints_2d_length1 = _tmp0_;
#line 612 "../lib/sudoku-board.vala"
	ints_2d_length2 = _tmp1_;
#line 613 "../lib/sudoku-board.vala"
	i = 0;
#line 5133 "sudoku-board.c"
	{
		gint row = 0;
#line 614 "../lib/sudoku-board.vala"
		row = 0;
#line 5138 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 614 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 614 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 5145 "sudoku-board.c"
				gint _tmp5_;
#line 614 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 5149 "sudoku-board.c"
					gint _tmp4_;
#line 614 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 614 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 5155 "sudoku-board.c"
				}
#line 614 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 614 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 614 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 614 "../lib/sudoku-board.vala"
					break;
#line 5165 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 615 "../lib/sudoku-board.vala"
					col = 0;
#line 5171 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 615 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 615 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 5178 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gint _tmp10_;
							gint _tmp11_;
#line 615 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 5187 "sudoku-board.c"
								gint _tmp7_;
#line 615 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 615 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 5193 "sudoku-board.c"
							}
#line 615 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 615 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 615 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 615 "../lib/sudoku-board.vala"
								break;
#line 5203 "sudoku-board.c"
							}
#line 616 "../lib/sudoku-board.vala"
							_tmp9_ = ints_2d;
#line 616 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_2d_length1;
#line 616 "../lib/sudoku-board.vala"
							_tmp9__length2 = ints_2d_length2;
#line 616 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 616 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 616 "../lib/sudoku-board.vala"
							_tmp11_ = ints_1d[_tmp10_];
#line 616 "../lib/sudoku-board.vala"
							_tmp9_[(row * _tmp9__length2) + col] = _tmp11_;
#line 5219 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 617 "../lib/sudoku-board.vala"
	_tmp12_ = ints_2d;
#line 617 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_2d_length1;
#line 617 "../lib/sudoku-board.vala"
	_tmp12__length2 = ints_2d_length2;
#line 617 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 617 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 5236 "sudoku-board.c"
	}
#line 617 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 617 "../lib/sudoku-board.vala"
		*result_length2 = _tmp12__length2;
#line 5242 "sudoku-board.c"
	}
#line 617 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 617 "../lib/sudoku-board.vala"
	return result;
#line 5248 "sudoku-board.c"
}

gdouble
sudoku_board_get_previous_played_time (SudokuBoard* self)
{
	gdouble result;
#line 38 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "../lib/sudoku-board.vala"
	result = self->priv->_previous_played_time;
#line 38 "../lib/sudoku-board.vala"
	return result;
#line 5261 "sudoku-board.c"
}

void
sudoku_board_set_previous_played_time (SudokuBoard* self,
                                       gdouble value)
{
	gdouble old_value;
#line 38 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_previous_played_time (self);
#line 38 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 38 "../lib/sudoku-board.vala"
		self->priv->_previous_played_time = value;
#line 38 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY]);
#line 5279 "sudoku-board.c"
	}
}

DifficultyCategory
sudoku_board_get_difficulty_category (SudokuBoard* self)
{
	DifficultyCategory result;
#line 40 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../lib/sudoku-board.vala"
	result = self->priv->_difficulty_category;
#line 40 "../lib/sudoku-board.vala"
	return result;
#line 5293 "sudoku-board.c"
}

void
sudoku_board_set_difficulty_category (SudokuBoard* self,
                                      DifficultyCategory value)
{
	DifficultyCategory old_value;
#line 40 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_difficulty_category (self);
#line 40 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 40 "../lib/sudoku-board.vala"
		self->priv->_difficulty_category = value;
#line 40 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY]);
#line 5311 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_rows (SudokuBoard* self)
{
	gint result;
#line 43 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../lib/sudoku-board.vala"
	result = self->priv->_block_rows;
#line 43 "../lib/sudoku-board.vala"
	return result;
#line 5325 "sudoku-board.c"
}

static void
sudoku_board_set_block_rows (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 43 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 43 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_rows (self);
#line 43 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 43 "../lib/sudoku-board.vala"
		self->priv->_block_rows = value;
#line 43 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY]);
#line 5343 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_cols (SudokuBoard* self)
{
	gint result;
#line 46 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../lib/sudoku-board.vala"
	result = self->priv->_block_cols;
#line 46 "../lib/sudoku-board.vala"
	return result;
#line 5357 "sudoku-board.c"
}

static void
sudoku_board_set_block_cols (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 46 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 46 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_cols (self);
#line 46 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 46 "../lib/sudoku-board.vala"
		self->priv->_block_cols = value;
#line 46 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY]);
#line 5375 "sudoku-board.c"
	}
}

gint
sudoku_board_get_rows (SudokuBoard* self)
{
	gint result;
#line 49 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../lib/sudoku-board.vala"
	result = self->priv->_rows;
#line 49 "../lib/sudoku-board.vala"
	return result;
#line 5389 "sudoku-board.c"
}

static void
sudoku_board_set_rows (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 49 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 49 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_rows (self);
#line 49 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 49 "../lib/sudoku-board.vala"
		self->priv->_rows = value;
#line 49 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY]);
#line 5407 "sudoku-board.c"
	}
}

gint
sudoku_board_get_cols (SudokuBoard* self)
{
	gint result;
#line 52 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "../lib/sudoku-board.vala"
	result = self->priv->_cols;
#line 52 "../lib/sudoku-board.vala"
	return result;
#line 5421 "sudoku-board.c"
}

static void
sudoku_board_set_cols (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 52 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 52 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_cols (self);
#line 52 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 52 "../lib/sudoku-board.vala"
		self->priv->_cols = value;
#line 52 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY]);
#line 5439 "sudoku-board.c"
	}
}

gint
sudoku_board_get_max_val (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 57 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 57 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 57 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 57 "../lib/sudoku-board.vala"
	return result;
#line 5459 "sudoku-board.c"
}

gboolean
sudoku_board_get_broken (SudokuBoard* self)
{
	gboolean result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 62 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_broken_coords;
#line 62 "../lib/sudoku-board.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 62 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 62 "../lib/sudoku-board.vala"
	result = _tmp2_ != 0;
#line 62 "../lib/sudoku-board.vala"
	return result;
#line 5481 "sudoku-board.c"
}

gint
sudoku_board_get_filled (SudokuBoard* self)
{
	gint result;
#line 66 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../lib/sudoku-board.vala"
	result = self->priv->_filled;
#line 66 "../lib/sudoku-board.vala"
	return result;
#line 5494 "sudoku-board.c"
}

static void
sudoku_board_set_filled (SudokuBoard* self,
                         gint value)
{
	gint old_value;
#line 66 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_filled (self);
#line 66 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 66 "../lib/sudoku-board.vala"
		self->priv->_filled = value;
#line 66 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY]);
#line 5512 "sudoku-board.c"
	}
}

gint
sudoku_board_get_fixed (SudokuBoard* self)
{
	gint result;
#line 69 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 69 "../lib/sudoku-board.vala"
	result = self->priv->_fixed;
#line 69 "../lib/sudoku-board.vala"
	return result;
#line 5526 "sudoku-board.c"
}

static void
sudoku_board_set_fixed (SudokuBoard* self,
                        gint value)
{
	gint old_value;
#line 69 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 69 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_fixed (self);
#line 69 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 69 "../lib/sudoku-board.vala"
		self->priv->_fixed = value;
#line 69 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY]);
#line 5544 "sudoku-board.c"
	}
}

gint
sudoku_board_get_size (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 73 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 73 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 73 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 73 "../lib/sudoku-board.vala"
	return result;
#line 5564 "sudoku-board.c"
}

gboolean
sudoku_board_get_complete (SudokuBoard* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 78 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 78 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_cols;
#line 78 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 78 "../lib/sudoku-board.vala"
	if (_tmp1_ == (_tmp2_ * _tmp3_)) {
#line 5585 "sudoku-board.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 78 "../lib/sudoku-board.vala"
		_tmp4_ = sudoku_board_get_broken (self);
#line 78 "../lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 78 "../lib/sudoku-board.vala"
		_tmp0_ = !_tmp5_;
#line 5594 "sudoku-board.c"
	} else {
#line 78 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5598 "sudoku-board.c"
	}
#line 78 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 78 "../lib/sudoku-board.vala"
	return result;
#line 5604 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_broken_coords (SudokuBoard* self)
{
	GeeSet* result;
	GeeSet* _tmp0_;
#line 95 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_broken_coords;
#line 95 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 95 "../lib/sudoku-board.vala"
	return result;
#line 5620 "sudoku-board.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../lib/sudoku-board.vala"
	return self ? g_object_ref (self) : NULL;
#line 5628 "sudoku-board.c"
}

static void
sudoku_board_set_broken_coords (SudokuBoard* self,
                                GeeSet* value)
{
	GeeSet* old_value;
#line 95 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 95 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_broken_coords (self);
#line 95 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5642 "sudoku-board.c"
		GeeSet* _tmp0_;
#line 95 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 95 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_broken_coords);
#line 95 "../lib/sudoku-board.vala"
		self->priv->_broken_coords = _tmp0_;
#line 95 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BROKEN_COORDS_PROPERTY]);
#line 5652 "sudoku-board.c"
	}
}

GeeList*
sudoku_board_get_coords_for_col (SudokuBoard* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 98 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_col;
#line 98 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 98 "../lib/sudoku-board.vala"
	return result;
#line 5669 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_col (SudokuBoard* self,
                                 GeeList* value)
{
	GeeList* old_value;
#line 98 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_col (self);
#line 98 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5683 "sudoku-board.c"
		GeeList* _tmp0_;
#line 98 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 98 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_col);
#line 98 "../lib/sudoku-board.vala"
		self->priv->_coords_for_col = _tmp0_;
#line 98 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY]);
#line 5693 "sudoku-board.c"
	}
}

GeeList*
sudoku_board_get_coords_for_row (SudokuBoard* self)
{
	GeeList* result;
	GeeList* _tmp0_;
#line 101 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_row;
#line 101 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 101 "../lib/sudoku-board.vala"
	return result;
#line 5710 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_row (SudokuBoard* self,
                                 GeeList* value)
{
	GeeList* old_value;
#line 101 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 101 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_row (self);
#line 101 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5724 "sudoku-board.c"
		GeeList* _tmp0_;
#line 101 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 101 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_row);
#line 101 "../lib/sudoku-board.vala"
		self->priv->_coords_for_row = _tmp0_;
#line 101 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY]);
#line 5734 "sudoku-board.c"
	}
}

GeeMap*
sudoku_board_get_coords_for_block (SudokuBoard* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 104 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 104 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_coords_for_block;
#line 104 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 104 "../lib/sudoku-board.vala"
	return result;
#line 5751 "sudoku-board.c"
}

static void
sudoku_board_set_coords_for_block (SudokuBoard* self,
                                   GeeMap* value)
{
	GeeMap* old_value;
#line 104 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 104 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_coords_for_block (self);
#line 104 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 5765 "sudoku-board.c"
		GeeMap* _tmp0_;
#line 104 "../lib/sudoku-board.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 104 "../lib/sudoku-board.vala"
		_g_object_unref0 (self->priv->_coords_for_block);
#line 104 "../lib/sudoku-board.vala"
		self->priv->_coords_for_block = _tmp0_;
#line 104 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY]);
#line 5775 "sudoku-board.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_BOOLEAN) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../lib/sudoku-board.vala"
	g_return_if_fail (n_param_values == 5);
#line 24 "../lib/sudoku-board.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../lib/sudoku-board.vala"
		data1 = closure->data;
#line 24 "../lib/sudoku-board.vala"
		data2 = param_values->data[0].v_pointer;
#line 5801 "sudoku-board.c"
	} else {
#line 24 "../lib/sudoku-board.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../lib/sudoku-board.vala"
		data2 = closure->data;
#line 5807 "sudoku-board.c"
	}
#line 24 "../lib/sudoku-board.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../lib/sudoku-board.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_boolean (param_values + 4), data2);
#line 5813 "sudoku-board.c"
}

static void
sudoku_board_class_init (SudokuBoardClass * klass,
                         gpointer klass_data)
{
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-board.vala"
	g_type_class_adjust_private_offset (klass, &SudokuBoard_private_offset);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_board_get_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_board_set_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_board_finalize;
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY] = g_param_spec_double ("previous-played-time", "previous-played-time", "previous-played-time", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY] = g_param_spec_enum ("difficulty-category", "difficulty-category", "difficulty-category", TYPE_DIFFICULTY_CATEGORY, DIFFICULTY_CATEGORY_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY] = g_param_spec_int ("block-rows", "block-rows", "block-rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY] = g_param_spec_int ("block-cols", "block-cols", "block-cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_MAX_VAL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_MAX_VAL_PROPERTY] = g_param_spec_int ("max-val", "max-val", "max-val", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_PROPERTY] = g_param_spec_boolean ("broken", "broken", "broken", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FILLED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY] = g_param_spec_int ("filled", "filled", "filled", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FIXED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY] = g_param_spec_int ("fixed", "fixed", "fixed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_SIZE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COMPLETE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COMPLETE_PROPERTY] = g_param_spec_boolean ("complete", "complete", "complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_COORDS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_COORDS_PROPERTY] = g_param_spec_object ("broken-coords", "broken-coords", "broken-coords", GEE_TYPE_SET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY] = g_param_spec_object ("coords-for-col", "coords-for-col", "coords-for-col", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY] = g_param_spec_object ("coords-for-row", "coords-for-row", "coords-for-row", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY] = g_param_spec_object ("coords-for-block", "coords-for-block", "coords-for-block", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL] = g_signal_new ("completed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_EARMARK_CHANGED_SIGNAL] = g_signal_new ("earmark-changed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_BOOLEAN, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 5866 "sudoku-board.c"
}

static void
sudoku_board_instance_init (SudokuBoard * self,
                            gpointer klass)
{
#line 24 "../lib/sudoku-board.vala"
	self->priv = sudoku_board_get_instance_private (self);
#line 38 "../lib/sudoku-board.vala"
	self->priv->_previous_played_time = (gdouble) 0;
#line 40 "../lib/sudoku-board.vala"
	self->priv->_difficulty_category = DIFFICULTY_CATEGORY_UNKNOWN;
#line 5879 "sudoku-board.c"
}

static void
sudoku_board_finalize (GObject * obj)
{
	SudokuBoard * self;
#line 24 "../lib/sudoku-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 28 "../lib/sudoku-board.vala"
	self->priv->cells = (g_free (self->priv->cells), NULL);
#line 29 "../lib/sudoku-board.vala"
	self->priv->solution = (g_free (self->priv->solution), NULL);
#line 30 "../lib/sudoku-board.vala"
	self->priv->is_fixed = (g_free (self->priv->is_fixed), NULL);
#line 31 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 32 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 33 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 35 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 95 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_broken_coords);
#line 98 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_col);
#line 101 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_row);
#line 104 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->priv->_coords_for_block);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (sudoku_board_parent_class)->finalize (obj);
#line 5912 "sudoku-board.c"
}

static GType
sudoku_board_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuBoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuBoard), 0, (GInstanceInitFunc) sudoku_board_instance_init, NULL };
	GType sudoku_board_type_id;
	sudoku_board_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuBoard", &g_define_type_info, 0);
	SudokuBoard_private_offset = g_type_add_instance_private (sudoku_board_type_id, sizeof (SudokuBoardPrivate));
	return sudoku_board_type_id;
}

GType
sudoku_board_get_type (void)
{
	static volatile gsize sudoku_board_type_id__once = 0;
	if (g_once_init_enter (&sudoku_board_type_id__once)) {
		GType sudoku_board_type_id;
		sudoku_board_type_id = sudoku_board_get_type_once ();
		g_once_init_leave (&sudoku_board_type_id__once, sudoku_board_type_id);
	}
	return sudoku_board_type_id__once;
}

static void
_vala_sudoku_board_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_double (value, sudoku_board_get_previous_played_time (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_enum (value, sudoku_board_get_difficulty_category (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_MAX_VAL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_max_val (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_broken (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_filled (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_fixed (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_SIZE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_size (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COMPLETE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_complete (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_COORDS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_broken_coords (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_col (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_row (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_object (value, sudoku_board_get_coords_for_block (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6043 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6049 "sudoku-board.c"
	}
}

static void
_vala_sudoku_board_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_previous_played_time (self, g_value_get_double (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_difficulty_category (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_filled (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_COORDS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_broken_coords (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_COL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_col (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_ROW_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_row (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COORDS_FOR_BLOCK_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_coords_for_block (self, g_value_get_object (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6135 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 6141 "sudoku-board.c"
	}
}

static GType
house_get_type_once (void)
{
	static const GEnumValue values[] = {{HOUSE_ROW, "HOUSE_ROW", "row"}, {HOUSE_COLUMN, "HOUSE_COLUMN", "column"}, {HOUSE_BLOCK, "HOUSE_BLOCK", "block"}, {0, NULL, NULL}};
	GType house_type_id;
	house_type_id = g_enum_register_static ("House", values);
	return house_type_id;
}

GType
house_get_type (void)
{
	static volatile gsize house_type_id__once = 0;
	if (g_once_init_enter (&house_type_id__once)) {
		GType house_type_id;
		house_type_id = house_get_type_once ();
		g_once_init_leave (&house_type_id__once, house_type_id);
	}
	return house_type_id__once;
}

void
coord_init (Coord *self,
            gint row,
            gint col)
{
#line 633 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Coord));
#line 635 "../lib/sudoku-board.vala"
	(*self).row = row;
#line 636 "../lib/sudoku-board.vala"
	(*self).col = col;
#line 6177 "sudoku-board.c"
}

gint
coord_hash (Coord* coord)
{
	Coord _tmp0_;
	Coord _tmp1_;
	gint result;
#line 639 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coord != NULL, 0);
#line 641 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 641 "../lib/sudoku-board.vala"
	_tmp1_ = *coord;
#line 641 "../lib/sudoku-board.vala"
	result = (_tmp0_.row * 33) ^ _tmp1_.col;
#line 641 "../lib/sudoku-board.vala"
	return result;
#line 6196 "sudoku-board.c"
}

gboolean
coord_equal (Coord* a,
             Coord* b)
{
	gboolean _tmp0_ = FALSE;
	Coord _tmp1_;
	Coord _tmp2_;
	gboolean result;
#line 644 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 644 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 646 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 646 "../lib/sudoku-board.vala"
	_tmp2_ = *b;
#line 646 "../lib/sudoku-board.vala"
	if (_tmp1_.row == _tmp2_.row) {
#line 6217 "sudoku-board.c"
		Coord _tmp3_;
		Coord _tmp4_;
#line 646 "../lib/sudoku-board.vala"
		_tmp3_ = *a;
#line 646 "../lib/sudoku-board.vala"
		_tmp4_ = *b;
#line 646 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp3_.col == _tmp4_.col;
#line 6226 "sudoku-board.c"
	} else {
#line 646 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 6230 "sudoku-board.c"
	}
#line 646 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 646 "../lib/sudoku-board.vala"
	return result;
#line 6236 "sudoku-board.c"
}

Coord*
coord_dup (const Coord* self)
{
	Coord* dup;
#line 628 "../lib/sudoku-board.vala"
	dup = g_new0 (Coord, 1);
#line 628 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Coord));
#line 628 "../lib/sudoku-board.vala"
	return dup;
#line 6249 "sudoku-board.c"
}

void
coord_free (Coord* self)
{
#line 628 "../lib/sudoku-board.vala"
	g_free (self);
#line 6257 "sudoku-board.c"
}

static GType
coord_get_type_once (void)
{
	GType coord_type_id;
	coord_type_id = g_boxed_type_register_static ("Coord", (GBoxedCopyFunc) coord_dup, (GBoxedFreeFunc) coord_free);
	return coord_type_id;
}

GType
coord_get_type (void)
{
	static volatile gsize coord_type_id__once = 0;
	if (g_once_init_enter (&coord_type_id__once)) {
		GType coord_type_id;
		coord_type_id = coord_get_type_once ();
		g_once_init_leave (&coord_type_id__once, coord_type_id);
	}
	return coord_type_id__once;
}

void
cell_init (Cell *self,
           Coord* coord,
           gint val)
{
	Coord _tmp0_;
#line 655 "../lib/sudoku-board.vala"
	g_return_if_fail (coord != NULL);
#line 655 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Cell));
#line 657 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 657 "../lib/sudoku-board.vala"
	(*self).coord = _tmp0_;
#line 658 "../lib/sudoku-board.vala"
	(*self).val = val;
#line 6296 "sudoku-board.c"
}

gint
cell_hash (Cell* cell)
{
	Cell _tmp0_;
	Coord _tmp1_;
	Cell _tmp2_;
	gint result;
#line 661 "../lib/sudoku-board.vala"
	g_return_val_if_fail (cell != NULL, 0);
#line 663 "../lib/sudoku-board.vala"
	_tmp0_ = *cell;
#line 663 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.coord;
#line 663 "../lib/sudoku-board.vala"
	_tmp2_ = *cell;
#line 663 "../lib/sudoku-board.vala"
	result = (coord_hash (&_tmp1_) * 33) ^ _tmp2_.val;
#line 663 "../lib/sudoku-board.vala"
	return result;
#line 6318 "sudoku-board.c"
}

gboolean
cell_equal (Cell* a,
            Cell* b)
{
	gboolean _tmp0_ = FALSE;
	Cell _tmp1_;
	Coord _tmp2_;
	Cell _tmp3_;
	Coord _tmp4_;
	gboolean result;
#line 666 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 666 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 668 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 668 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.coord;
#line 668 "../lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 668 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.coord;
#line 668 "../lib/sudoku-board.vala"
	if (coord_equal (&_tmp2_, &_tmp4_)) {
#line 6345 "sudoku-board.c"
		Cell _tmp5_;
		Cell _tmp6_;
#line 668 "../lib/sudoku-board.vala"
		_tmp5_ = *a;
#line 668 "../lib/sudoku-board.vala"
		_tmp6_ = *b;
#line 668 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp5_.val == _tmp6_.val;
#line 6354 "sudoku-board.c"
	} else {
#line 668 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 6358 "sudoku-board.c"
	}
#line 668 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 668 "../lib/sudoku-board.vala"
	return result;
#line 6364 "sudoku-board.c"
}

Cell*
cell_dup (const Cell* self)
{
	Cell* dup;
#line 650 "../lib/sudoku-board.vala"
	dup = g_new0 (Cell, 1);
#line 650 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Cell));
#line 650 "../lib/sudoku-board.vala"
	return dup;
#line 6377 "sudoku-board.c"
}

void
cell_free (Cell* self)
{
#line 650 "../lib/sudoku-board.vala"
	g_free (self);
#line 6385 "sudoku-board.c"
}

static GType
cell_get_type_once (void)
{
	GType cell_type_id;
	cell_type_id = g_boxed_type_register_static ("Cell", (GBoxedCopyFunc) cell_dup, (GBoxedFreeFunc) cell_free);
	return cell_type_id;
}

GType
cell_get_type (void)
{
	static volatile gsize cell_type_id__once = 0;
	if (g_once_init_enter (&cell_type_id__once)) {
		GType cell_type_id;
		cell_type_id = cell_get_type_once ();
		g_once_init_leave (&cell_type_id__once, cell_type_id);
	}
	return cell_type_id__once;
}

gchar*
difficulty_category_to_string (DifficultyCategory self)
{
	gchar* result;
#line 683 "../lib/sudoku-board.vala"
	switch (self) {
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 6416 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 686 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup (_ ("Unknown Difficulty"));
#line 686 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 686 "../lib/sudoku-board.vala"
			return result;
#line 6425 "sudoku-board.c"
		}
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 6429 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 688 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup (_ ("Easy Difficulty"));
#line 688 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 688 "../lib/sudoku-board.vala"
			return result;
#line 6438 "sudoku-board.c"
		}
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 6442 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 690 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup (_ ("Medium Difficulty"));
#line 690 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 690 "../lib/sudoku-board.vala"
			return result;
#line 6451 "sudoku-board.c"
		}
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 6455 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 692 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup (_ ("Hard Difficulty"));
#line 692 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 692 "../lib/sudoku-board.vala"
			return result;
#line 6464 "sudoku-board.c"
		}
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 6468 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 694 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup (_ ("Very Hard Difficulty"));
#line 694 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 694 "../lib/sudoku-board.vala"
			return result;
#line 6477 "sudoku-board.c"
		}
#line 683 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 6481 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 696 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup (_ ("Custom Puzzle"));
#line 696 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 696 "../lib/sudoku-board.vala"
			return result;
#line 6490 "sudoku-board.c"
		}
		default:
		{
#line 698 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 6496 "sudoku-board.c"
		}
	}
}

gchar*
difficulty_category_to_untranslated_string (DifficultyCategory self)
{
	gchar* result;
#line 704 "../lib/sudoku-board.vala"
	switch (self) {
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 6509 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 707 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup ("Unknown Difficulty");
#line 707 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 707 "../lib/sudoku-board.vala"
			return result;
#line 6518 "sudoku-board.c"
		}
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 6522 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 709 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup ("Easy Difficulty");
#line 709 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 709 "../lib/sudoku-board.vala"
			return result;
#line 6531 "sudoku-board.c"
		}
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 6535 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 711 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup ("Medium Difficulty");
#line 711 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 711 "../lib/sudoku-board.vala"
			return result;
#line 6544 "sudoku-board.c"
		}
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 6548 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 713 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup ("Hard Difficulty");
#line 713 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 713 "../lib/sudoku-board.vala"
			return result;
#line 6557 "sudoku-board.c"
		}
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 6561 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 715 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup ("Very Hard Difficulty");
#line 715 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 715 "../lib/sudoku-board.vala"
			return result;
#line 6570 "sudoku-board.c"
		}
#line 704 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 6574 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 717 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup ("Custom Puzzle");
#line 717 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 717 "../lib/sudoku-board.vala"
			return result;
#line 6583 "sudoku-board.c"
		}
		default:
		{
#line 719 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 6589 "sudoku-board.c"
		}
	}
}

DifficultyCategory
difficulty_category_from_string (const gchar* input)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label0 = 0;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label1 = 0;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label2 = 0;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label3 = 0;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label4 = 0;
#line 725 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label5 = 0;
#line 6611 "sudoku-board.c"
	DifficultyCategory result;
#line 723 "../lib/sudoku-board.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 725 "../lib/sudoku-board.vala"
	_tmp0_ = input;
#line 725 "../lib/sudoku-board.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 725 "../lib/sudoku-board.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Unknown Difficulty")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6623 "sudoku-board.c"
			default:
			{
#line 728 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_UNKNOWN;
#line 728 "../lib/sudoku-board.vala"
				return result;
#line 6630 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Easy Difficulty")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6636 "sudoku-board.c"
			default:
			{
#line 730 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 730 "../lib/sudoku-board.vala"
				return result;
#line 6643 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Medium Difficulty")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6649 "sudoku-board.c"
			default:
			{
#line 732 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_MEDIUM;
#line 732 "../lib/sudoku-board.vala"
				return result;
#line 6656 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Hard Difficulty")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6662 "sudoku-board.c"
			default:
			{
#line 734 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_HARD;
#line 734 "../lib/sudoku-board.vala"
				return result;
#line 6669 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("Very Hard Difficulty")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6675 "sudoku-board.c"
			default:
			{
#line 736 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_VERY_HARD;
#line 736 "../lib/sudoku-board.vala"
				return result;
#line 6682 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("Custom Puzzle")))) {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6688 "sudoku-board.c"
			default:
			{
#line 738 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_CUSTOM;
#line 738 "../lib/sudoku-board.vala"
				return result;
#line 6695 "sudoku-board.c"
			}
		}
	} else {
#line 725 "../lib/sudoku-board.vala"
		switch (0) {
#line 6701 "sudoku-board.c"
			default:
			{
#line 740 "../lib/sudoku-board.vala"
				g_warning ("sudoku-board.vala:740: Could not parse difficulty level. Falling back " \
"to Easy difficulty");
#line 741 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 741 "../lib/sudoku-board.vala"
				return result;
#line 6710 "sudoku-board.c"
			}
		}
	}
}

static GType
difficulty_category_get_type_once (void)
{
	static const GEnumValue values[] = {{DIFFICULTY_CATEGORY_UNKNOWN, "DIFFICULTY_CATEGORY_UNKNOWN", "unknown"}, {DIFFICULTY_CATEGORY_EASY, "DIFFICULTY_CATEGORY_EASY", "easy"}, {DIFFICULTY_CATEGORY_MEDIUM, "DIFFICULTY_CATEGORY_MEDIUM", "medium"}, {DIFFICULTY_CATEGORY_HARD, "DIFFICULTY_CATEGORY_HARD", "hard"}, {DIFFICULTY_CATEGORY_VERY_HARD, "DIFFICULTY_CATEGORY_VERY_HARD", "very-hard"}, {DIFFICULTY_CATEGORY_CUSTOM, "DIFFICULTY_CATEGORY_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType difficulty_category_type_id;
	difficulty_category_type_id = g_enum_register_static ("DifficultyCategory", values);
	return difficulty_category_type_id;
}

GType
difficulty_category_get_type (void)
{
	static volatile gsize difficulty_category_type_id__once = 0;
	if (g_once_init_enter (&difficulty_category_type_id__once)) {
		GType difficulty_category_type_id;
		difficulty_category_type_id = difficulty_category_get_type_once ();
		g_once_init_leave (&difficulty_category_type_id__once, difficulty_category_type_id);
	}
	return difficulty_category_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

